<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:		Buruj Solutions
  + Contact:		www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:	April 05, 2012
  ^
  + Project: 		JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class JSAutozControllerTransmission extends JSAutozController {

    function __construct() {
        parent::__construct();
        $this->registerTask('add', 'edit');
    }

    function editvehicletransmission() {          //editvehicletransmission
        JRequest::setVar('layout', 'formvehicletransmission');
        JRequest::setVar('view', 'transmission');
        JRequest::setVar('c', 'transmission');
        $this->display();
    }

    function maketransmissiondefault() {
        $cid = JRequest::getVar('cid', array(), '', 'array');
        $transmissionid = $cid[0];
        $transmission_model = $this->getmodel('Transmission', 'JSAutozModel');
        $return_value = $transmission_model->makeTransmissionDefault($transmissionid);
        if ($return_value == 1) $msg = JText::_('Vehicle Transmission Set Default');
        elseif ($return_value == 4) $msg = JText::_('Unpublished Object Cannot Be Default');
        else $msg = JText::_('Error In Vehicle Transmission Set Default');
        $link = 'index.php?option=com_jsautoz&c=transmission&view=transmission&layout=transmissions';
        $this->setRedirect($link, $msg);
    }

    function savevehicletransmission() {              //savevehicletransmission
        $redirect = $this->storevehicletransmission('saveclose');
    }

    function savevehicletransmissionsave() {              //savevehicletransmissionsave
        $redirect = $this->storevehicletransmission('save');
    }

    function savevehicletransmissionandnew() {              //savevehicletransmissionandnew
        $redirect = $this->storevehicletransmission('saveandnew');
    }

    function storevehicletransmission($callfrom) {
        $link = null;
        $transmission_model = $this->getmodel('Transmission', 'JSAutozModel');
        $return_value = $transmission_model->storeVehicleTransmission();
        if ($return_value[0] == 1) {
            if ($callfrom == 'saveclose') {
                $msg = JText::_('Vehicle Transmission Saved');
                $link = 'index.php?option=com_jsautoz&c=transmission&view=transmission&layout=transmissions';
            } elseif ($callfrom == 'save') {
                $msg = JText::_('Vehicle Transmission Saved');
                $link = 'index.php?option=com_jsautoz&c=transmission&view=transmission&layout=formvehicletransmission&cid[]=' . $return_value[1];
            } elseif ($callfrom == 'saveandnew') {
                $msg = JText::_('Vehicle Transmission Saved');
                $link = 'index.php?option=com_jsautoz&c=transmission&view=transmission&layout=formvehicletransmission';
            }
        } else if ($return_value[0] == 2) {
            $msg = JText::_('All Field Must Be Entered');
            $link = 'index.php?option=com_jsautoz&c=transmission&view=transmission&layout=formvehicletransmission';
        } else if ($return_value[0] == 3) {
            $msg = JText::_('Vehicle Transmission Already Exist');
            $link = 'index.php?option=com_jsautoz&c=transmission&view=transmission&layout=formvehicletransmission';
        } else {
            $msg = JText::_('Error Saving Vehicle Transmission');
            $link = 'index.php?option=com_jsautoz&c=transmission&view=transmission&layout=transmissions';
        }
        $this->setRedirect($link, $msg);
    }

    function removevehicletramsmission() {                         //Remove Vehicle transmission
        $transmission_model = $this->getmodel('Transmission', 'JSAutozModel');
        $return_value = $transmission_model->deleteVehicleTransmission();
        if ($return_value == 1)
            $msg = JText::_('Vehicle Transmission Deleted');
        else
            $msg = $return_value - 1 . '' . JText::_('Error Vehicle Transmission Could Not Deleted');
        $link = 'index.php?option=com_jsautoz&c=transmission&view=transmission&layout=transmissions';
        $this->setredirect($link, $msg);
    }

    function cancelvehicletransmission() {          //cancelvehicletransmission
        $msg = JText::_('Operation Canceled');
        $link = 'index.php?option=com_jsautoz&c=transmission&view=transmission&layout=transmissions';
        $this->setRedirect($link, $msg);
    }

    function publishvehicletransmission() {
        $cid = JRequest::getVar('cid', array(), '', 'array');
        $id = $cid[0];
        $transmission_model = $this->getmodel('Transmission', 'JSAutozModel');
        $result = $transmission_model->changeStatusVehicleTransmission($id, 1);
        if ($result == 3)
            $msg = JText::_('Default Object Cannot Be Unpublished Or Published');
        elseif ($result == 1)
            $msg = JText::_('Published');
        else
            $msg = JText::_('Error Occurred');
        $link = 'index.php?option=com_jsautoz&c=transmission&view=transmission&layout=transmissions';
        $this->setRedirect($link, $msg);
    }

    function unpublishvehicletransmission() {
        $cid = JRequest::getVar('cid', array(), '', 'array');
        $id = $cid[0];
        $transmission_model = $this->getmodel('Transmission', 'JSAutozModel');
        $result = $transmission_model->changeStatusVehicleTransmission($id, 0);
        if ($result == 3)
            $msg = JText::_('Default Object Cannot Be Unpublished Or Published');
        elseif ($result == 1)
            $msg = JText::_('Unpublished');
        else
            $msg = JText::_('Error Occurred');
        $link = 'index.php?option=com_jsautoz&c=transmission&view=transmission&layout=transmissions';
        $this->setRedirect($link, $msg);
    }

    function display($cachable = false, $urlparams = false) {
        $document = JFactory::getDocument();
        $viewName = JRequest::getVar('view', 'transmission');
        $layoutName = JRequest::getVar('layout', 'transmissions');
        $viewType = $document->getType();
        $view = $this->getView($viewName, $viewType);
        $view->setLayout($layoutName);
        $view->display();
    }

}

?>