<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:     www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest::getVar('option', 'com_jsautoz');

class JSAutozModelAddexpiry extends JSAutozModel {

    var $_countries = null;

    function __construct() {
        parent::__construct();
    }

    function makeAdexpiryDefault($id) {
        if (!is_numeric($id))
            return false;
        $canmakedefault = $this->getJSModel('common')->canMakeDefault($id, 'adexpiries');
        if ($canmakedefault) {
            $db = $this->getDBO();
            $query = "UPDATE `#__js_auto_adexpiries` AS adexp SET adexp.isdefault= 0";
            $db->setQuery($query);
            if (!$db->query()) {
                $returnvalue = 0;
            }
            $row = $this->getTable('adexpiry');
            $row->id = $id;
            $row->isdefault = 1;
            $row->status = 1;
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                $returnvalue = 0;
            } else
                $returnvalue = 1;
        } else
            $returnvalue = 4;
        return $returnvalue;
    }

    function getAllAddExpiries($limitstart, $limit) {               //get all adexpires
        $db = JFactory::getDBO();
        $result = array();
        $query = "SELECT COUNT(id) FROM #__js_auto_adexpiries WHERE id != 1";
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;
        $query = "SELECT * FROM #__js_auto_adexpiries WHERE id != 1 ORDER BY id ASC";

        $db->setQuery($query, $limitstart, $limit);
        $result[0] = $db->loadObjectList();
        $result[1] = $total;
        return $result;
    }

    function getVehiclesAdexpirie($title) {       //get vehicle adexpiries
        $db = JFactory::getDBO();
        $query = "SELECT  id, title,type FROM `#__js_auto_adexpiries` WHERE id != 1 AND status = 1 ORDER BY title ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $adexpiries = array();
        if ($title)
            $adexpiries[] = array('value' => JText::_(''), 'text' => $title);
        foreach ($rows as $row) {
            switch($row->type){
                case 1 : $row->type = JText::_('Year'); break;
                case 2 : $row->type = JText::_('Month'); break;
                case 3 : $row->type = JText::_('Week'); break;
                case 4 : $row->type = JText::_('Day'); break;
            }
            $adexpiries[] = array('value' => $row->id, 'text' => $row->title . ' ' . $row->type);
        }
        return $adexpiries;
    }

    function storeVehicleAdexpiry() {         //store vehicle adexpiry
        $row = $this->getTable('adexpiry');
        $result = array();
        $data = JRequest::get('post');
        if (is_numeric($data['title']) == false) {
            $result[0] = 5;
            return $result;
        }
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if ($data['id'] == '') { // only for new
            $result1 = $this->getJSModel('addexpiry')->isVehicleAdexpiryExist($data['title'], $data['type']);
            if ($result1 == 1) {
                $result[0] = 3;
                return $result;
            }
        }
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        $result[0] = true;
        $result[1] = $row->id;
        return $result;
    }

    function deleteVehicleAdexpiry() {               //deleteVehicleAdexpiry
        $cids = JRequest::getVar('cid', array(0), 'post', 'array');
        $row = $this->getTable('adexpiry');
        $deleteall = 1;
        foreach ($cids as $cid) {
            if ($this->getJSModel('addexpiry')->vehicleAdexpiryCanDelete($cid) == true) {
                if (!$row->delete($cid)) {
                    $this->setError($row->getErrorMsg());
                    return false;
                }
            } else
                $deleteall++;
        }
        return $deleteall;
    }

    function vehicleAdexpiryCanDelete($id) {             //vehicleAdexpiryCanDelete
        if (is_numeric($id) == false)
            return false;
        $db = $this->getDBO();
        if ($id == 1)
            return true;
        $query = "SELECT 
                    (SELECT COUNT(id) FROM `#__js_auto_adexpiries` WHERE id = " . $id . " AND isdefault = 1)
                    + (SELECT COUNT(id) FROM `#__js_auto_vehicles` WHERE adexpiryid = " . $id . ") 
                    AS total";
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total > 0)
            return false;
        else
            return true;
    }

    function getVehicleAdexpiryforForm($id) {               //getVehicleAdexpiryforForm
        $db = $this->getDBO();
        $result = array();
        $adexpiry = null;
        if ($id) {
            if (is_numeric($id) == false)
                return false;
            $query = " SELECT vehicleadexpiry.*
            FROM `#__js_auto_adexpiries` AS vehicleadexpiry
            WHERE vehicleadexpiry.id != 1 AND vehicleadexpiry.id = " . $id;
            $db->setQuery($query);
            $adexpiry = $db->loadObject();
        }
        $adexpirycombo = $this->getJSModel('addexpiry')->getAdexpiryForCombo();
        if (isset($adexpiry)) {
            $lists['adexpiry'] = JHTML::_('select.genericList', $adexpirycombo, 'type', 'class=inputbox ' . '', 'value', 'text', $adexpiry->type);
        } else {
            $lists['adexpiry'] = JHTML::_('select.genericList', $adexpirycombo, 'type', 'class=inputbox ' . '', 'value', 'text', '');
        }
        $result[0] = $adexpiry;
        $result[1] = $lists;
        return $result;
    }

    function getAdexpiryForCombo() {
        $adexpiry = array(
            '0' => array('value' => '1', 'text' => JText::_('Year')),
            '1' => array('value' => '2', 'text' => JText::_('Month')),
            '2' => array('value' => '3', 'text' => JText::_('Week')),
            '3' => array('value' => '4', 'text' => JText::_('Day')));
        return $adexpiry;
    }

    function changeStatusVehicleAdexpiry($id, $status) {          //changeStatusVehicleAdexpiry
        if (is_numeric($id) == false)
            return false;
        if (is_numeric($status) == false)
            return false;
        $canpublishunpublish = $this->getJSModel('common')->canPublishUnpublish($id, 'adexpiries');
        if ($canpublishunpublish) {
            $row = $this->getTable('adexpiry');
            $row->id = $id;
            $row->status = $status;
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                $returnvalue = 0;
            } else
                $returnvalue = 1;
        } else
            $returnvalue = 3;

        return $returnvalue;
    }

    function isVehicleAdexpiryExist($title, $type) {              //isVehicleAdexpiryExist
        $db = JFactory::getDBO();
        $query = "SELECT COUNT(id) FROM #__js_auto_adexpiries WHERE id != 1 AND title = " . $db->Quote($title) . " AND type = " . $db->quote($type);
        $db->setQuery($query);
        $result = $db->loadResult();
        if ($result == 0)
            return 0;
        else
            return 1;
    }

    function getAdexpiryidByTitle($title) {
        if ($title == "")
            return $title;
        $adexpiryarray = explode($title, " ");
        $db = JFactory::getDBO();
        $query = "SELECT adexpiry.id AS adexpiryid FROM `#__js_auto_adexpiries` AS Ad Expiry WHERE LOWER(adexpiry.title) = " . $db->quote(strtolower($adexpiryarray[0])) . " AND LOWER(adexpiry.type) = " . $db->quote(strtolower($adexpiryarray[1]));
        $db->setQuery($query);
        $result = $db->loadObject();
        if ($result) {
            return $result->adexpiryid;
        } else {
            return $this->getJSModel('addexpiry')->getDefaultAdexpriy();
        }
    }

    function getDefaultAdexpriy() {
        $db = JFactory::getDBO();
        $query = "SELECT id FROM `#__js_auto_adexpiries` WHERE isdefault = 1";
        $db->setQuery($query);
        $result = $db->loadResult();
        return $result;
    }

}

?>
