<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:     www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest :: getVar('option', 'com_jsautoz');

class JSAutozModelCity extends JSAutozModel {

    var $_countries = null;

    function __construct() {
        parent :: __construct();
    }

    function publishedCities($cids) {
        $db = $this->getDBO();
        foreach ($cids as $cid) {
            if (!is_numeric($cid))
                return false;
            $query = "UPDATE `#__js_auto_cities` AS city SET city.enabled= '1'
                        WHERE city.id =" . $cid;
            $db->setQuery($query);
            if (!$db->query()) {
                return false;
            }
        }
        return true;
    }

    function unpublishedCities($cids) {
        $db = $this->getDBO();
        foreach ($cids as $cid) {
            if (!is_numeric($cid))
                return false;
            $query = "UPDATE `#__js_auto_cities` AS city SET city.enabled= '0'
                        WHERE city.id =" . $cid;
            $db->setQuery($query);
            if (!$db->query()) {
                return false;
            }
        }
        return true;
    }

    function getAddressDataByCityName($cityname, $id) {
        $db = JFactory::getDbo();
        $config = $this->getJSModel('configuration')->getConfiginArray('default');
        $query = "SELECT concat(city.name";
        switch ($config['defaultaddressdisplaytype']) {
            case 'csc'://City, State, Country
                $query .= " ,', ', (IF(state.name is not null,state.name,'')),IF(state.name is not null,', ',''),country.name)";
                break;
            case 'cs'://City, State
                $query .= " ,', ', (IF(state.name is not null,state.name,'')))";
                break;
            case 'cc'://City, Country
                $query .= " ,', ', country.name)";
                break;
            case 'c'://city by default select for each case
                $query .= ")";
                break;
        }
        $query .= " AS name, city.id AS id
                    FROM `#__js_auto_cities` AS city  
                    JOIN `#__js_auto_countries` AS country on city.countryid=country.id
                    LEFT JOIN `#__js_auto_states` AS state on city.stateid=state.id ";
        if ($id == 0)
            $query .= " WHERE city.name LIKE '" . $cityname . "%' AND country.enabled = 1 AND city.enabled = 1 LIMIT 10";
        else
            $query .= " WHERE city.id = $id AND country.enabled = 1 AND city.enabled = 1";
        $db->setQuery($query);

        $result = $db->loadObjectList();
        if (empty($result))
            return null;
        else
            return $result;
    }

    function storeVehicleCity($countryid, $stateid) {
        $row = $this->getTable('city');
        $data = JRequest :: get('post');
        $row->countryid = $countryid;
        $row->stateid = $stateid;
        $row->cityName = $data['name'];
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        if ($data['id'] == '') { // only for new
            $result = $this->getJSModel('city')->isVehicleCityExist($countryid, $stateid, $data['name']);
            if ($result == 1)
                return 3;
        }
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        return true;
    }

    function deleteCity() {
        $cids = JRequest :: getVar('cid', array(0), 'post', 'array');
        $row = $this->getTable('city');
        $deleteall = 1;
        foreach ($cids as $cid) {
            if ($this->getJSModel('city')->cityCanDelete($cid) == true) {
                if (!$row->delete($cid)) {
                    $this->setError($row->getErrorMsg());
                    return false;
                }
            } else
                $deleteall++;
        }
        return $deleteall;
    }

    function cityCanDelete($cityid) {
        if (is_numeric($cityid) == false)
            return false;
        $db = $this->getDBO();

        $query = "SELECT
                    ( SELECT COUNT(vehicle.id) FROM `#__js_auto_vehicles` AS vehicle
                    WHERE vehicle.loccity = " . $cityid . ")
                    + ( SELECT COUNT(vehicle.id) FROM `#__js_auto_vehicles` AS vehicle
                    WHERE vehicle.regcity = " . $cityid . ")";
                    

        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total > 0)
            return false;
        else
            return true;
    }

    function getVehicleCityforForm($id) {              //getVehicleCountryforForm
        $db = $this->getDBO();
        $city = null;
        if ($id) {
            if (is_numeric($id) == false)
                return false;
            $query = "SELECT city.*
            FROM `#__js_auto_cities` AS city
            WHERE city.id = " . $id;
            $db->setQuery($query);
            $city = $db->loadObject();
        }
        return $city;
    }

    function isVehicleCityExist($countryid, $stateid, $title) {
        if (!is_numeric($countryid))
            return false;
        if (!is_numeric($stateid))
            return false;
        $db = JFactory::getDBO();
        $query = "SELECT COUNT(id) FROM #__js_auto_cities WHERE countryid=" . $countryid . "
                    AND stateid=" . $stateid . " AND LOWER(name) = " . $db->Quote(strtolower($title));
        $db->setQuery($query);
        $result = $db->loadResult();
        if ($result == 0)
            return 0;
        else
            return 1;
    }

    function makeCityCode($cit, $countycode) {
        $db = JFactory::getDBO();
        $city = str_replace(" ", "", $cit); // remove spaces
        $totallen = strlen($city);
        $len = 4;
        if ($len > $totallen)
            $len = $totallen;
        $code = substr($city, 0, $len);
        $found = false;
        $start = 0;
        while (!$found == true) {
            $query = "SELECT COUNT(id) FROM #__js_auto_cities WHERE code = " . $db->Quote($code);
            $db->setQuery($query);
            $result = $db->loadResult();
            if ($result == 0) {
                $found = true;
                return $code;
            } else {
                $code = substr($city, 0, $len);
                if ($len == $totallen) {
                    $city .= $countycode;
                    $totallen = strlen($city);
                    $code = substr($city, 0, $len);
                }
                if ($len > $totallen)
                    return false;
                $len++;
            }
        }
    }

    function getCities($stateid, $title) {           //getCities
        if (!is_numeric($stateid))
            return false;
        $db = JFactory::getDBO();
        $query = "SELECT * FROM `#__js_auto_cities` WHERE enabled = '1' AND stateid = " . $stateid . " ORDER BY name ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            return false;
        }
        $cities = array();
        if ($title)
            $cities[] = array('value' => JText::_(''), 'text' => $title);
        else
            $cities[] = array('value' => JText::_(''), 'text' => JText::_('CHOOSE_CITY'));

        foreach ($rows as $row) {
            $cities[] = array('value' => JText::_($row->id), 'text' => JText::_($row->name));
        }
        return $cities;
    }

    function getCityidByTitle($title) {
        if ($title == "")
            return $title;
        $db = JFactory::getDBO();
        $query = "SELECT city.id AS cityid FROM `#__js_auto_cities` AS city WHERE LOWER(city.name) = " . $db->quote(strtolower($title));
        $db->setQuery($query);
        $result = $db->loadObject();
        if ($result) {
            return $result->cityid;
        } else {
            return $title;
        }
    }

    function getAllCountryStateCity($searchname, $stateid, $countryid, $limitstart, $limit){
        if ($stateid)
            if (!is_numeric($stateid))
                return false;
        if ($countryid)
            if (!is_numeric($countryid))
                return false;
        $db = JFactory :: getDBO();
        $result = array();
        $query = "SELECT COUNT(id) FROM `#__js_auto_cities` ";
        $wherequery = "";
        if ($stateid) {
            $wherequery = " WHERE stateid = " . $stateid;
        }
        if ($countryid) {
            if (empty($wherequery))
                $wherequery = " WHERE countryid = " . $countryid;
            else
                $wherequery .= " AND countryid = " . $countryid;
        }
        $query .=$wherequery;
        if ($searchname) {
            if($wherequery != '') $clause = ' AND ';else $clause = ' WHERE ';
            $query .= " ".$clause."name LIKE '%" . str_replace("'", "", $db->Quote($searchname)) . "%'";
        }
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;

        $query = "SELECT * FROM `#__js_auto_cities` " . $wherequery;
        if ($searchname) {
            if($wherequery != '') $clause = ' AND ';else $clause = ' WHERE ';
            $query .= " ".$clause."name LIKE '%" . str_replace("'","",$db->Quote($searchname)) . "%' ORDER BY name ASC";
        } else {
            $query .= " ORDER BY name ASC";
        }

        $db->setQuery($query, $limitstart, $limit);

        $result[0] = $db->loadObjectList();
        $result[1] = $total;
        if ($searchname) {
            $lists['searchname'] = $searchname;
            $result[2] = $lists;
        }
        return $result;
        
    }

}
?>