<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:     www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest::getVar('option', 'com_jsautoz');

class JSAutozModelCondition extends JSAutozModel {

    var $_countries = null;

    function __construct() {
        parent::__construct();
    }

    function getAllCondition($limitstart, $limit) {          // get all condition
        $db = JFactory::getDBO();
        $result = array();
        $query = "SELECT COUNT(id) FROM #__js_auto_conditions";
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;
        $query = "SELECT * FROM #__js_auto_conditions ORDER BY id ASC";

        $db->setQuery($query, $limitstart, $limit);
        $result[0] = $db->loadObjectList();
        $result[1] = $total;
        return $result;
    }

    function getVehiclesCondition($title = "Any") {          // get vehicle condition
        $db = JFactory::getDBO();
        $query = "SELECT  id, title FROM `#__js_auto_conditions` WHERE status = 1 ORDER BY title ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $conditions = array();
        if ($title)
            $conditions [] = array('value' => JText::_(''), 'text' => $title);
        foreach ($rows as $row) {
            $conditions [] = array('value' => $row->id, 'text' => JText::_($row->title));
        }
        return $conditions;
    }

    function storeVehicleCondition() {              //storeVehicleCondition
        $row = $this->getTable('condition');
        $result = array();
        $data = JRequest::get('post');
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if ($data['id'] == '') { // only for new
            $result1 = $this->getJSModel('condition')->isVehicleConditionExist($data['title']);
            if ($result1 == 1) {
                $result[0] = 3;
                return $result;
            }
        }
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        $result[0] = true;
        $result[1] = $row->id;
        return $result;
    }

    function deleteVehicleCondition() {              //deleteVehicleCondition
        $cids = JRequest::getVar('cid', array(0), 'post', 'array');
        $row = $this->getTable('condition');
        $deleteall = 1;
        foreach ($cids as $cid) {
            if ($this->getJSModel('condition')->vehicleConditionCanDelete($cid) == true) {
                if (!$row->delete($cid)) {
                    $this->setError($row->getErrorMsg());
                    return false;
                }
            } else
                $deleteall++;
        }
        return $deleteall;
    }

    function vehicleConditionCanDelete($id) {           //vehicleConditionCanDelete
        if (is_numeric($id) == false)
            return false;
        if ($id < 3)
            return false;
        $db = $this->getDBO();
        $query = " SELECT COUNT(id) FROM `#__js_auto_conditions` WHERE id = " . $id;
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total > 0)
            return true;
        else
            return false;
    }

    function getVehicleConditionforForm($id) {              //getVehicleConditionforForm
        $db = $this->getDBO();
        $condition = null;
        if ($id) {
            if (is_numeric($id) == false)
                return false;
            $query = "SELECT vehiclecondition.*
            FROM `#__js_auto_conditions` AS vehiclecondition
            WHERE vehiclecondition.id = " . $id;
            $db->setQuery($query);
            $condition = $db->loadObject();
        }
        return $condition;
    }

    function changeStatusVehicleCondition($id, $status) {          //changeStatusVehicleCondition
        if (is_numeric($id) == false)
            return false;
        if (is_numeric($status) == false)
            return false;
        $canpublishunpublish = $this->getJSModel('common')->canPublishUnpublishWithOutDefault($id, 'conditions');
        if ($canpublishunpublish) {
            $row = $this->getTable('condition');
            $row->id = $id;
            $row->status = $status;
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                $returnvalue = 0;
            } else
                $returnvalue = 1;
        } else
            $returnvalue = 3;
        return $returnvalue;
    }

    function isVehicleConditionExist($title) {          //isVehicleConditionExist
        $db = JFactory::getDBO();
        $query = "SELECT COUNT(id) FROM #__js_auto_conditions WHERE title = " . $db->Quote($title);
        $db->setQuery($query);
        $result = $db->loadResult();
        if ($result == 0)
            return 0;
        else
            return 1;
    }

    function getConditionidByTitle($title) {
        if ($title == "")
            return $title;
        $db = JFactory::getDBO();
        $query = "SELECT vcondition.id AS conditionid FROM `#__js_auto_conditions` AS vcondition WHERE LOWER(vcondition.title) = " . $db->quote(strtolower($title));
        $db->setQuery($query);
        $result = $db->loadObject();
        if ($result) {
            return $result->conditionid;
        } else {
            $row = $this->getTable('condition');
            $data['title'] = $title;
            $data['status'] = 1;

            if (!$row->bind($data)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->check()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return $row->id;
        }
    }

}

?>