<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:     www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest::getVar('option', 'com_jsautoz');

class JSAutozModelCountry extends JSAutozModel {

    var $_countries = null;

    function __construct() {
        parent::__construct();
    }

    function publishedCountry($cids) {
        $db = $this->getDBO();
        foreach ($cids as $cid) {
            if (!is_numeric($cid))
                return false;
            $query = "UPDATE `#__js_auto_countries` AS country SET country.enabled= '1'
                        WHERE country.id =" . $cid;
            $db->setQuery($query);
            if (!$db->query()) {
                return false;
            }
        }
        return true;
    }

    function unPublishedCountry($cids) {
        $db = $this->getDBO();
        foreach ($cids as $cid) {
            if (!is_numeric($cid))
                return false;
            $query = "UPDATE `#__js_auto_countries` AS country SET country.enabled= '0'
                        WHERE country.id =" . $cid;
            $db->setQuery($query);
            if (!$db->query()) {
                return false;
            }
        }
        return true;
    }

    function getAllCountries($searchname, $limitstart, $limit) {          //get all countries
        $db = JFactory::getDBO();
        $result = array();
        $query = "SELECT COUNT(id) FROM #__js_auto_countries";
        if ($searchname) {
            $wherequery = " WHERE name LIKE '%" . str_replace("'", "", $db->quote($searchname)) . "%' ORDER BY name ASC";
        } else {
            $wherequery = " ORDER BY name ASC";
        }
        $query .= $wherequery;
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;

        $query = "SELECT * FROM #__js_auto_countries ";
        if ($searchname) {
            $wherequery = " WHERE name LIKE '%" . str_replace("'", "", $db->quote($searchname)) . "%' ORDER BY name ASC";
        } else {
            $wherequery = " ORDER BY name ASC";
        }
        $query .= $wherequery;
        $db->setQuery($query, $limitstart, $limit);

        $result[0] = $db->loadObjectList();
        $result[1] = $total;
        if ($searchname) {
            $lists['searchname'] = $searchname;
            $result[2] = $lists;
        }
        return $result;
    }

    function storeVehicleCountry() {                 // store Vehicle Country
        $row = $this->getTable('country');
        $data = JRequest::get('post');
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        if ($data['id'] == '') { // only for new
            $result = $this->getJSModel('country')->isVehicleCountryExist($data['name']);
            if ($result == true)
                return 3;
        }
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        return true;
    }

    function deleteVehicleCountry() {
        $cids = JRequest::getVar('cid', array(0), 'post', 'array');
        $row = $this->getTable('country');
        $deleteall = 1;
        foreach ($cids as $cid) {
            if ($this->getJSModel('country')->vehicleCountryCanDelete($cid) == true) {
                if (!$row->delete($cid)) {
                    $this->setError($row->getErrorMsg());
                    return false;
                }
            } else
                $deleteall++;
        }
        return $deleteall;
    }

    function vehicleCountryCanDelete($id) {    //vehicleCountryCanDelete
        if (is_numeric($id) == false)
            return false;
        $db = $this->getDBO();

        $query = "SELECT COUNT(city.id) AS total FROM `#__js_auto_cities` AS city 
                    WHERE city.countryid = " . $id;

        $db->setQuery($query);
        $total = $db->loadResult();

        if ($total > 0)
            return false;
        else
            return true;
    }

    function getVehicleCountryforForm($id) {              //getVehicleCountryforForm
        $db = $this->getDBO();
        $country = null;
        if ($id) {
            if (is_numeric($id) == false)
                return false;
            $query = "SELECT country.*
            FROM `#__js_auto_countries` AS country
            WHERE country.id = " . $id;
            $db->setQuery($query);
            $country = $db->loadObject();
        }
        return $country;
    }

    function isVehicleCountryExist($title) {          //isVehiclecountryExist
        $db = JFactory::getDBO();
        $query = "SELECT COUNT(id) FROM #__js_auto_countries WHERE name = " . $db->Quote($title);
        $db->setQuery($query);
        $result = $db->loadResult();
        if ($result == 0)
            return false;
        else
            return true;
    }

    function makeCountryCode($country) {
        $db = JFactory::getDBO();
        $code = substr($country, 0, 2);
        $found = false;
        $start = 1;
        while (!$found == true) {
            $query = "SELECT COUNT(id) FROM #__js_auto_countries WHERE code = " . $db->Quote($code);
            $db->setQuery($query);
            $result = $db->loadResult();
            if ($result == 0) {
                $found = true;
                return $code;
            } else {
                $code = substr($country, $start, 2);
                $start++;
                if ($start == strlen($country))
                    return false;
            }
        }
    }

    function getCountries($title) {                  //getCountries
        if (!$this->_countries) {
            $db = JFactory::getDBO();
            $query = "SELECT * FROM `#__js_auto_countries` WHERE enabled = 'Y' ORDER BY name ASC ";
            $db->setQuery($query);
            $rows = $db->loadObjectList();
            if ($db->getErrorNum()) {
                echo $db->stderr();
                return false;
            }
            $this->_countries = $rows;
        }
        $countries = array();
        if ($title)
            $countries[] = array('value' => JText::_(''), 'text' => $title);
        else
            $countries[] = array('value' => JText::_(''), 'text' => JText::_('Choose Country'));

        foreach ($this->_countries as $row) {
            $countries[] = array('value' => $row->id, 'text' => JText::_($row->name));
        }
        return $countries;
    }

    function getCountryidByTitle($title) {
        if ($title == "")
            return $title;
        $db = JFactory::getDBO();
        $query = "SELECT country.id AS countryid FROM `#__js_auto_countries` AS country WHERE LOWER(country.name) = " . $db->quote(strtolower($title));
        $db->setQuery($query);
        $result = $db->loadObject();
        if ($result) {
            return $result->countryid;
        } else {
            $row = $this->getTable('country');
            $data['name'] = $title;
            $data['loc'] = 'AF'; //fix value
            $data['code'] = strtoupper(substr($title, 0, 2));
            $data['enabled'] = 'Y';

            if (!$row->bind($data)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->check()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return $row->id;
        }
    }

}
?>
