<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:     www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest::getVar('option', 'com_jsautoz');

class JSAutozModelCurrency extends JSAutozModel {

    var $_countries = null;

    function __construct() {
        parent::__construct();
    }

    function makeDefaultCurrency($id) {
        if (!is_numeric($id))
            return false;
        $canmakedefault = $this->getJSModel('common')->canMakeDefault($id, 'currency');
        if ($canmakedefault) {
            $db = $this->getDBO();
            $query = "UPDATE `#__js_auto_currency` AS currency SET currency.isdefault= 0";

            $db->setQuery($query);
            if (!$db->query()) {
                $returnvalue = 0;
            }
            $row = $this->getTable('currency');
            $row->id = $id;
            $row->isdefault = 1;
            $row->status = 1;
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                $returnvalue = 0;
            } else
                $returnvalue = 1;
        } else
            $returnvalue = 4;

        return $returnvalue;
    }

    function getAllCurrency($limitstart, $limit) {      //get all currency
        $db = JFactory::getDBO();
        $result = array();
        $query = "SELECT COUNT(id) FROM #__js_auto_currency WHERE id != 1";
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;
        $query = "SELECT * FROM #__js_auto_currency WHERE id != 1 ORDER BY id ASC";

        $db->setQuery($query, $limitstart, $limit);
        $result[0] = $db->loadObjectList();
        $result[1] = $total;
        return $result;
    }

    function storeCurrency() {                     //store Fuel Type
        $row = $this->getTable('currency');
        $result = array();
        $data = JRequest::get('post');
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if ($data['id'] == '') { // only for new
            $result1 = $this->getJSModel('currency')->isCurrencyExist($data['title']);
            if ($result1 == 1) {
                $result[0] = 3;
                return $result;
            }
        }
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        $result[0] = true;
        $result[1] = $row->id;
        return $result;
    }

    function deleteCurrency() {
        $cids = JRequest::getVar('cid', array(0), 'post', 'array');
        $row = $this->getTable('currency');
        $deleteall = 1;
        foreach ($cids as $cid) {
            if ($this->getJSModel('currency')->currencyCanDelete($cid) == true) {
                if (!$row->delete($cid)) {
                    $this->setError($row->getErrorMsg());
                    return false;
                }
            } else
                $deleteall++;
        }
        return $deleteall;
    }

    function currencyCanDelete($id) {                       //fuleTypeCanDelete
        if (is_numeric($id) == false)
            return false;
        $db = $this->getDBO();

        $query = "SELECT 
                    (SELECT COUNT(id) FROM `#__js_auto_currency` WHERE id = " . $id . " AND isdefault = 1)
                    + (SELECT COUNT(id) FROM `#__js_auto_vehicles` WHERE currencyid = " . $id . " )
                    AS total";
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total > 0)
            return false;
        else
            return true;
    }

    function getCurrencyforForm($id) {
        $db = $this->getDBO();
        $currency = null;
        if ($id) {
            if (is_numeric($id) == false)
                return false;
            $query = "SELECT currency.*
            FROM `#__js_auto_currency` AS currency
            WHERE currency.id != 1 AND currency.id = " . $id;
            $db->setQuery($query);
            $currency = $db->loadObject();
        }
        return $currency;
    }

    function changeStatusCurrency($id, $status) {          //changeStatusFuelType
        if (is_numeric($id) == false)
            return false;
        if (is_numeric($status) == false)
            return false;
        $canpublishunpublish = $this->getJSModel('common')->canPublishUnpublish($id, 'currency');
        if ($canpublishunpublish) {
            $row = $this->getTable('currency');
            $row->id = $id;
            $row->status = $status;
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                $returnvalue = 0;
            } else
                $returnvalue = 1;
        } else
            $returnvalue = 3;

        return $returnvalue;
    }

    function isCurrencyExist($title) {                //isFuelTypeExist
        $db = JFactory::getDBO();
        $query = "SELECT COUNT(id) FROM #__js_auto_currency  WHERE id != 1 AND title = " . $db->Quote($title);
        $db->setQuery($query);
        $result = $db->loadResult();
        if ($result == 0)
            return 0;
        else
            return 1;
    }

    function getCurrency($title) {
        $db = JFactory::getDBO();
        $query = "SELECT  id, symbol,title FROM `#__js_auto_currency`  WHERE id != 1 AND status = 1 ORDER BY title ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $currency = array();
        if ($title)
            $currency[] = array('value' => JText::_(''), 'text' => $title);
        foreach ($rows as $row) {
            $currency[] = array('value' => $row->id, 'text' => $row->symbol);
        }
        return $currency;
    }

    function getCurrencyidBySymbol($title) {
        if ($title == "")
            return $title;
        $db = JFactory::getDBO();
        $query = "SELECT currency.id AS currencyid FROM `#__js_auto_currency` AS currency WHERE LOWER(currency.symbol) = " . $db->quote(strtolower($title));
        $db->setQuery($query);
        $result = $db->loadObject();
        if ($result) {
            return $result->currencyid;
        } else {
            $row = $this->getTable('currency');
            $data['title'] = $title;
            $data['symbol'] = $title;
            $data['status'] = 1;

            if (!$row->bind($data)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->check()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return $row->id;
        }
    }

}

?>