<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:     www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest::getVar('option', 'com_jsautoz');

class JSAutozModelCustomfield extends JSAutozModel {

    var $_countries = null;

    function __construct() {
        parent::__construct();
    }

    function getUserFields($fieldfor, $limitstart, $limit) {
        if (is_numeric($fieldfor) == false)
            return false;
        $db = JFactory::getDBO();
        $result = array();

        $query = "SELECT COUNT(id) FROM #__js_auto_userfields WHERE fieldfor = " . $fieldfor;
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;

        $query = "SELECT field.* FROM #__js_auto_userfields AS field WHERE fieldfor = " . $fieldfor;
        $query .= " ORDER BY field.id";


        $db->setQuery($query, $limitstart, $limit);
        $this->_application = $db->loadObjectList();

        $result[0] = $this->_application;
        $result[1] = $total;
        return $result;
    }

    function storeUserFieldData($data, $refid) { //store  user field data        
        $row = $this->getTable('userfielddata');
        for ($i = 1; $i <= $data['userfields_total']; $i++) {
            $fname = "userfields_" . $i;
            $fid = "userfields_" . $i . "_id";
            $dataid = "userdata_" . $i . "_id";

            $fielddata['id'] = $data[$dataid];
            $fielddata['referenceid'] = $refid;
            $fielddata['field'] = $data[$fid];
            $fielddata['data'] = isset($data[$fname]) ? $data[$fname] : 0;

            if (!$row->bind($fielddata)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                echo $this->_db->getErrorMsg();
                return false;
            }
        }
        return true;
    }

    function makeUserfieldRequiredUnrequired($id, $status) {
        $row = $this->getTable('userfield');
        $row->id = $id;
        $row->required = $status;
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            echo $this->_db->getErrorMsg();
            return false;
        }
        return TRUE;
    }

    function makeUserfieldReadonlyNotReadonly($id, $status) {
        $row = $this->getTable('userfield');
        $row->id = $id;
        $row->readonly = $status;
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        return TRUE;
    }

    function makeUserfieldPublishedUnpublished($id, $status) {
        $row = $this->getTable('userfield');
        $row->id = $id;
        $row->published = $status;
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        return TRUE;
    }

    function storeUserField() {
        $db = JFactory::getDBO();
        $row = $this->getTable('userfield');
        $data = JRequest::get('post');

        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return 2;
        }
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        // add in field ordering
        if ($data['id'] == '') { // only for new
            $query = "INSERT INTO #__js_auto_fieldordering
                        (field, fieldtitle, ordering, section, fieldfor, published, sys, cannotunpublished)
                        VALUES(" . $row->id . ",'" . $data['title'] . "', ( SELECT max(ordering)+1 FROM #__js_auto_fieldordering AS field WHERE fieldfor = " . $data['fieldfor'] . "), ''
                        , " . $data['fieldfor'] . "," . $data['published'] . " ,0,0) ";
            $db->setQuery($query);
            if (!$db->query()) {
                return false;
            }
        }

        // store values
        $ids = $data['jsIds'];
        $names = $data['jsNames'];
        $values = $data['jsValues'];
        $fieldvaluerow = $this->getTable('userfieldvalue');
        for ($i = 0; $i <= $data['valueCount']; $i++) {
            $fieldvaluedata = array();
            if (isset($ids[$i]))
                $fieldvaluedata['id'] = $ids[$i];
            else
                $fieldvaluedata['id'] = $data['id'];
            $fieldvaluedata['field'] = $row->id;
            $fieldvaluedata['fieldtitle'] = $names[$i];
            $fieldvaluedata['fieldvalue'] = $values[$i];
            $fieldvaluedata['ordering'] = $i + 1;
            $fieldvaluedata['sys'] = 0;

            if (!$fieldvaluerow->bind($fieldvaluedata)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$fieldvaluerow->store()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
        }
        return true;
    }

    function storeVehicleUserFields() {
        $db = JFactory::getDBO();

        $data = JRequest::get('post');

        $fieldvaluerow = $this->getTable('fieldordering');

        $userfields = $data['userfield'];
        $titles = $data['title'];
        $publisheds = $data['published'];
        $requireds = $data['required'];
        $id = $data['id'];

        for ($i = 0; $i <= 15; $i++) {
            $fieldvaluedata = array();
            $fieldvaluedata['id'] = $id[$i];
            $fieldvaluedata['field'] = $userfields[$i];
            $fieldvaluedata['fieldtitle'] = $titles[$i];
            $fieldvaluedata['ordering'] = 141 + $i;
            $fieldvaluedata['section'] = 1000;
            $fieldvaluedata['fieldfor'] = 2;
            $fieldvaluedata['published'] = $publisheds[$i];
            $fieldvaluedata['sys'] = 0;
            $fieldvaluedata['cannotunpublish'] = 0;
            $fieldvaluedata['required'] = $requireds[$i];

            if (!$fieldvaluerow->bind($fieldvaluedata)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$fieldvaluerow->store()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
        }
        return true;
    }

    function deleteUserField() {
        $cids = JRequest::getVar('cid', array(0), 'post', 'array');
        $row = $this->getTable('userfield');
        $deleteall = 1;
        foreach ($cids as $cid) {
            if ($this->getJSModel('customfield')->userFieldCanDelete($cid) == true) {
                if (!$row->delete($cid)) {
                    $this->setError($row->getErrorMsg());
                    return false;
                }
            } else
                $deleteall++;
        }
        return $deleteall;
    }

    function userFieldCanDelete($field) {
        if (!is_numeric($field))
            return false;
        $db = $this->getDBO();
        $query = "SELECT COUNT(id) AS total FROM `#__js_auto_userfieldvalues` WHERE field = " . $field ;
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total > 0)
            return false;
        else
            return true;
    }

    function getUserFieldsForForm($fieldfor, $id, $formflag= null) {
        $db = $this->getDBO();
        $result;
        $field = array();
        $result = array();
        if (!is_numeric($fieldfor))
            return false;
        $query = "SELECT  * FROM `#__js_auto_userfields` WHERE published = 1 AND fieldfor = " . $fieldfor;
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        $i = 0;
        foreach ($rows as $row) {
            $field[0] = $row;
            if ($id != "") {
                if (!is_numeric($id))
                    return false;
                $query = "SELECT  * FROM `#__js_auto_userfield_data` WHERE referenceid = " . $id . " AND field = " . $row->id;
                $db->setQuery($query);
                $data = $db->loadObject();
                $field[1] = $data;
            }
            if ($row->type == "select") {
            if (isset($id) && $id != "") {//if id is not empty
                    $query = "SELECT  fieldvalue.* FROM `#__js_auto_userfield_data` AS fielddata
                                JOIN `#__js_auto_userfieldvalues` AS fieldvalue ON fieldvalue.id = fielddata.data
                                WHERE fielddata.field = " . $row->id . " AND fielddata.referenceid = " . $id;
                    $db->setQuery($query);
                    $value = $db->loadObject();
                    $field[2] = $value;
                } else {//general
                    $query = "SELECT  * FROM `#__js_auto_userfieldvalues`  WHERE field = " . $row->id;
                    $db->setQuery($query);
                    $value = $db->loadObject();
                    $field[2] = $value;
                }
                if($formflag == 1){
                    $query = "SELECT  * FROM `#__js_auto_userfieldvalues` WHERE field = " . $row->id;
                    $db->setQuery($query);
                    $values = $db->loadObjectList();
                    $field[2] = $values;

                }
                
            }
            $result[] = $field;
            $i++;
        }
        return $result;
    }

    function getUserFieldbyId($c_id) {
        if (is_numeric($c_id) == false)
            return false;
        $result = array();
        $db = JFactory::getDBO();
        $query = "SELECT * FROM #__js_auto_userfields WHERE id = " . $c_id;
        $db->setQuery($query);
        $result[0] = $db->loadObject();

        $query = "SELECT * FROM #__js_auto_userfieldvalues WHERE field = " . $c_id;
        $db->setQuery($query);
        $result[1] = $db->loadObjectList();

        return $result;
    }

}

?>