<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:     www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest::getVar('option', 'com_jsautoz');

class JSAutozModelCylinder extends JSAutozModel {

    var $_countries = null;

    function __construct() {
        parent::__construct();
    }

    function makeCylinderDefault($id) {
        if (!is_numeric($id))
            return false;
        $canmakedefault = $this->getJSModel('common')->canMakeDefault($id, 'cylinders');
        if ($canmakedefault) {
            $db = $this->getDBO();
            $query = "UPDATE `#__js_auto_cylinders` AS cylinder SET cylinder.isdefault= 0";
            $db->setQuery($query);
            if (!$db->query()) {
                $retunvalue = 0;
            }
            $row = $this->getTable('cylinder');
            $row->id = $id;
            $row->isdefault = 1;
            $row->status = 1;
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                $retunvalue = 0;
            } else
                $retunvalue = 1;
        } else
            $retunvalue = 4;
        return $retunvalue;
    }

    function getAllCylinder($limitstart, $limit) {       //get all cylinder
        $db = JFactory::getDBO();
        $result = array();
        $query = "SELECT COUNT(id) FROM #__js_auto_cylinders";
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;
        $query = "SELECT * FROM #__js_auto_cylinders ORDER BY id ASC";

        $db->setQuery($query, $limitstart, $limit);
        $result[0] = $db->loadObjectList();
        $result[1] = $total;
        return $result;
    }

    function getVehiclesCylinders($title = "Any") {       //get vehicle cylinders
        $db = JFactory::getDBO();
        $query = "SELECT  id, title FROM `#__js_auto_cylinders` WHERE status = 1 ORDER BY title ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $cylinders = array();
        if ($title)
            $cylinders[] = array('value' => JText::_(''), 'text' => $title);
        foreach ($rows as $row) {
            $cylinders[] = array('value' => $row->id, 'text' => JText::_($row->title));
        }
        return $cylinders;
    }

    function storeVehicleCylinder() {      //storeVehicleCylinder
        $row = $this->getTable('cylinder');
        $result = array();
        $data = JRequest::get('post');
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if ($data['id'] == '') { // only for new
            $result1 = $this->getJSModel('cylinder')->isVehicleCylinderExist($data['title']);
            if ($result1 == 1) {
                $result[0] = 3;
                return $result;
            }
        }
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        $result[0] = true;
        $result[1] = $row->id;
        return $result;
    }

    function deleteVehicleCylinder() {                 //deleteVehicleCylinder
        $cids = JRequest::getVar('cid', array(0), 'post', 'array');
        $row = $this->getTable('cylinder');
        $deleteall = 1;
        foreach ($cids as $cid) {
            if ($this->vehicleCylinderCanDelete($cid) == true) {
                if (!$row->delete($cid)) {
                    $this->setError($row->getErrorMsg());
                    return false;
                }
            } else
                $deleteall++;
        }
        return $deleteall;
    }

    function vehicleCylinderCanDelete($id) {                //vehicleCylinderCanDelete
        if (is_numeric($id) == false)
            return false;
        $db = $this->getDBO();

        $query = "SELECT 
                    (SELECT COUNT(id) FROM `#__js_auto_cylinders` WHERE id = " . $id . " AND isdefault = 1)
                    + (SELECT COUNT(id) FROM `#__js_auto_vehicles` WHERE cylinderid = " . $id . " )
                    AS total ";
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total > 0)
            return false;
        else
            return true;
    }

    function getVehicleCylinderforForm($id) {             //getVehicleCylinderforForm
        $db = $this->getDBO();
        $cylinder = null;
        if ($id) {
            if (is_numeric($id) == false)
                return false;
            $query = "SELECT vehiclecylinder.*
            FROM `#__js_auto_cylinders` AS vehiclecylinder
            WHERE vehiclecylinder.id = " . $id;
            $db->setQuery($query);
            $cylinder = $db->loadObject();
        }
        return $cylinder;
    }

    function changeStatusVehicleCylinder($id, $status) {          //changeStatusVehicleCylinder
        if (is_numeric($id) == false)
            return false;
        if (is_numeric($status) == false)
            return false;
        $canpublishunpublish = $this->getJSModel('common')->canPublishUnpublish($id, 'cylinders');
        if ($canpublishunpublish) {
            $row = $this->getTable('cylinder');
            $row->id = $id;
            $row->status = $status;
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                $returnvalue = 0;
            } else
                $returnvalue = 1;
        } else
            $returnvalue = 3;

        return $returnvalue;
    }

    function isVehicleCylinderExist($title) {           //isVehicleCylinderExist
        $db = JFactory::getDBO();
        $query = "SELECT COUNT(id) FROM #__js_auto_cylinders WHERE title = " . $db->Quote($title);
        $db->setQuery($query);
        $result = $db->loadResult();
        if ($result == 0)
            return 0;
        else
            return 1;
    }

    function getCylinderidByTitle($title) {
        if ($title == "")
            return $title;
        $db = JFactory::getDBO();
        $query = "SELECT cylinder.id AS cylinderid FROM `#__js_auto_cylinders` AS cylinder WHERE LOWER(cylinder.title) = " . $db->quote(strtolower($title));
        $db->setQuery($query);
        $result = $db->loadObject();
        if ($result) {
            return $result->cylinderid;
        } else {
            $row = $this->getTable('cylinder');
            $data['title'] = $title;
            $data['status'] = 1;

            if (!$row->bind($data)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->check()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return $row->id;
        }
    }

}
?>