<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:     www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest::getVar('option', 'com_jsautoz');

class JSAutozModelFueltype extends JSAutozModel {

    var $_countries = null;

    function __construct() {
        parent::__construct();
    }

    function makeFueltypeDefault($id) {
        if (!is_numeric($id))
            return false;
        $canmakedefault = $this->getJSModel('common')->canMakeDefault($id, 'fueltypes');
        if ($canmakedefault) {
            $db = $this->getDBO();
            $query = "UPDATE `#__js_auto_fueltypes` AS fueltype SET fueltype.isdefault= 0";

            $db->setQuery($query);
            if (!$db->query()) {
                $returnvalue = 0;
            }
            $row = $this->getTable('fueltype');
            $row->id = $id;
            $row->isdefault = 1;
            $row->status = 1;
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                echo $this->_db->getErrorMsg();
                $returnvalue = 0;
            } else
                $returnvalue = 1;
        } else
            $returnvalue = 4;

        return $returnvalue;
    }

    function getAllFuelTypes($limitstart, $limit) {           //get all fuel types
        $db = JFactory::getDBO();
        $result = array();
        $query = "SELECT COUNT(id) FROM #__js_auto_fueltypes";
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;
        $query = "SELECT * FROM #__js_auto_fueltypes ORDER BY id ASC";

        $db->setQuery($query, $limitstart, $limit);
        $result[0] = $db->loadObjectList();
        $result[1] = $total;
        return $result;
    }

    function storeFuelTypes() {                     //store Fuel Type
        $row = $this->getTable('fueltype');
        $result = array();
        $data = JRequest::get('post');
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if ($data['id'] == '') { // only for new
            $result1 = $this->getJSModel('fueltype')->isFuelTypeExist($data['title']);
            if ($result1 == 1) {
                $result[0] = 3;
                return $result;
            }
        }
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        $result[0] = true;
        $result[1] = $row->id;
        return $result;
    }

    function deleteFuelType() {                  //deleteFuelType
        $cids = JRequest::getVar('cid', array(0), 'post', 'array');
        $row = $this->getTable('fueltype');
        $deleteall = 1;
        foreach ($cids as $cid) {
            if ($this->getJSModel('fueltype')->fuleTypeCanDelete($cid) == true) {
                if (!$row->delete($cid)) {
                    $this->setError($row->getErrorMsg());
                    return false;
                }
            } else
                $deleteall++;
        }
        return $deleteall;
    }

    function fuleTypeCanDelete($id) {                       //fuleTypeCanDelete
        if (is_numeric($id) == false)
            return false;
        $db = $this->getDBO();

        $query = " SELECT 
                    (SELECT COUNT(id) FROM `#__js_auto_fueltypes` WHERE id = " . $id . " AND isdefault = 1 ) 
                    + (SELECT COUNT(id) FROM `#__js_auto_vehicles` WHERE fueltypeid = " . $id . " )
                    AS total";
        $db->setQuery($query);
        $total = $db->loadResult();

        if ($total > 0)
            return false;
        else
            return true;
    }

    function getFuelTypeforForm($id) {             //getFuelTypeforForm
        $db = $this->getDBO();
        $fueltype = null;
        if ($id) {
            if (is_numeric($id) == false)
                return false;
            $query = "SELECT fueltype.*
            FROM `#__js_auto_fueltypes` AS fueltype
            WHERE fueltype.id = " . $id;
            $db->setQuery($query);
            $fueltype = $db->loadObject();
        }
        return $fueltype;
    }

    function changeStatusFuelType($id, $status) {          //changeStatusFuelType
        if (is_numeric($id) == false)
            return false;
        if (is_numeric($status) == false)
            return false;
        $canunpblishedpublished = $this->getJSModel('common')->canPublishUnpublish($id, 'fueltypes');
        if ($canunpblishedpublished) {
            $row = $this->getTable('fueltype');
            $row->id = $id;
            $row->status = $status;
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                $returnvalue = 0;
            } else
                $returnvalue = 1;
        } else
            $returnvalue = 3;

        return $returnvalue;
    }

    function isFuelTypeExist($title) {                //isFuelTypeExist
        $db = JFactory::getDBO();
        $query = "SELECT COUNT(id) FROM #__js_auto_fueltypes WHERE title = " . $db->Quote($title);
        $db->setQuery($query);
        $result = $db->loadResult();
        if ($result == 0)
            return 0;
        else
            return 1;
    }

    function getVehiclesFuelType($title) {               //getVehiclesFuelType
        $db = JFactory::getDBO();
        $query = "SELECT  id, title FROM `#__js_auto_fueltypes` WHERE status = 1 ORDER BY title ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $fueltypes = array();
        if ($title)
            $fueltypes[] = array('value' => JText::_(''), 'text' => $title);
        foreach ($rows as $row) {
            $fueltypes[] = array('value' => $row->id, 'text' => JText::_($row->title));
        }
        return $fueltypes;
    }

    function getFueltypeidByTitle($title) {
        if ($title == "")
            return $title;
        $db = JFactory::getDBO();
        $query = "SELECT fueltype.id AS fueltypeid FROM `#__js_auto_fueltypes` AS fueltype WHERE LOWER(fueltype.title) = " . $db->quote(strtolower($title));
        $db->setQuery($query);
        $result = $db->loadObject();
        if ($result) {
            return $result->fueltypeid;
        } else {
            $row = $this->getTable('fueltype');
            $data['title'] = $title;
            $data['status'] = 1;

            if (!$row->bind($data)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->check()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return $row->id;
        }
    }

}

?>
