<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:     www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest::getVar('option', 'com_jsautoz');

class JSAutozModelMake extends JSAutozModel {

    var $_countries = null;

    function __construct() {
        parent::__construct();
    }

    function getAllMakes($searchtitle, $sortby, $limitstart, $limit) {               //get all makes
        $db = JFactory::getDBO();
        $result = array();
        $sort = array(
            0 => array('value' => '', 'text' => JText::_('Sort By')),
            1 => array('value' => 'ASC', 'text' => JText::_('Ascending')),
            2 => array('value' => 'DESC', 'text' => JText::_('Descending')),
        );

        $lists['sort'] = JHTML::_('select.genericList', $sort, 'sortby', 'class="inputbox" ' . '', 'value', 'text', $sortby);
        $query = "SELECT COUNT(id) FROM #__js_auto_makes AS make";
        if ($searchtitle)
            $query .= " WHERE make.title LIKE '%" . str_replace("'", "", $db->quote($searchtitle)) . "%'";
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;
        $query = "SELECT * FROM #__js_auto_makes AS make ";
        if ($searchtitle)
            $query .= " WHERE make.title LIKE '%" . str_replace("'", "", $db->quote($searchtitle)) . "%'";
        if ($sortby)
            $query .="ORDER BY make.title " . $sortby;
        if ($searchtitle)
            $lists['maketitle'] = $searchtitle;
        $db->setQuery($query, $limitstart, $limit);
        $result[0] = $db->loadObjectList();
        $result[2] = $lists;
        $result[1] = $total;
        return $result;
    }

    function storeVehicleMake() {                //store Vehicle Make
        $row = $this->getTable('vehiclemake');
        $result = array();
        $data = JRequest::get('post');

        if ($data['id'] != '') {
            if ($_FILES['logo']['size'] != '') {
                $this->deleteVehicleMakeImage($data['id']);
            }
        }
        if ($_FILES['logo']['size'] > 0) { // logo
            $data['logo'] = str_replace(' ', '-', $_FILES['logo']['name']); // file name
        }
//for alias apply rule
        if (!empty($data['alias']))
            $makealias = $data['alias'];
        else
            $makealias = $data['title'];

        $makealias = strtolower(str_replace(' ', '-', $makealias));
        $data['alias'] = $makealias;

        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if ($data['id'] == '') { // only for new
            $result1 = $this->getJSModel('make')->isVehicleMakeExist($data['title']);
            if ($result1 == 1) {
                $result[0] = 3;
                return $result;
            }
        }
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        $makeid = $row->id;
        if ($_FILES['logo']['size'] > 0) { // logo
            $returnvalue = $this->getJSModel('make')->uploadVehicleMakeLogo($makeid, 0);
            if ($returnvalue == 1) {
                $result[0] = True;
                $result[1] = $row->id;
                return $result;
            } else
                $result[0] = 5;
            return $result;
        }else {
            $result[0] = true;
            $result[1] = $row->id;
            return $result;
        }
    }

    function uploadVehicleMakeLogo($id, $isdeletefile) {      //upload vehicle image
        if (is_numeric($id) == false)
            return false;
        $result = array();
        $db = JFactory::getDBO();
        $base = JPATH_BASE;
        $path = $base . '/components/com_jsautoz/include/logo';
        if (!file_exists($path)) { // create user directory
            $this->getJSModel('common')->makeDir($path);
        }
        $isupload = false;
        $path = $path . '/makes';
        if (!file_exists($path)) { // create user directory
            $this->getJSModel('common')->makeDir($path);
        }
        $path = $path . '/make_' . $id;
        if (!file_exists($path)) { // create user directory
            $this->getJSModel('common')->makeDir($path);
        }
        if ($_FILES['logo']['size'] > 0) {
            $file_name = str_replace(' ', '-', $_FILES['logo']['name']); // file name
            $file_tmp = $_FILES['logo']['tmp_name']; // actual location

            $ext = $this->getJSModel('common')->getExtension($file_name);
            $ext = strtolower($ext);
            if (($ext != "gif") && ($ext != "jpg") && ($ext != "jpeg") && ($ext != "png"))
                return 6; //file type mistmathc

            $isupload = true;
        }
        if ($isupload) {
            move_uploaded_file($file_tmp, $path . '/' . $file_name);
            return 1;
        } else { // DELETE FILES
            if ($isdeletefile == 1) { // this code may not use
                $userpath = $path . '/make' . $id . '/logo';
                $files = glob($userpath . '/*.*');
                array_map('unlink', $files); // delete all file in the direcoty
            }
            return 1;
        }
    }

    function deleteVehicleMakeImage($id) { //delete vehicle make logo
        if (!is_numeric($id))
            return false;
        $db = JFactory::getDBO();
        $query = "SELECT vehmake.logo AS vehiclelogo FROM `#__js_auto_makes` AS vehmake WHERE vehmake.id = " . $id;
        $db->setQuery($query);
        $vehmake = $db->loadObject();
        $configs = $this->getJSModel('configuration')->getConfiginArray('default');
        $datadirectory = $configs['data_directory'];
        $str = JPATH_BASE;
        $base = substr($str, 0, strlen($str) - 14); //remove administrator
        $file_name = $vehmake->vehiclelogo;
        $path = $base . '/' . $datadirectory;
        $path = $path . '/make';
        $userpath = $path . '/logo';
        $userpath = $userpath . '/' . $file_name;
        unlink($userpath); //delete single image in the direetory
        return true;
    }

    function deleteVehicleMakeType() {             //deleteVehicleMakeType
        $cids = JRequest::getVar('cid', array(0), 'post', 'array');
        $row = $this->getTable('vehiclemake');
        $deleteall = 1;
        foreach ($cids as $cid) {
            if ($this->getJSModel('make')->vehicleMakeTypeCanDelete($cid) == true) {
                if (!$row->delete($cid)) {
                    $this->setError($row->getErrorMsg());
                    return false;
                }
            } else
                $deleteall++;
        }
        return $deleteall;
    }

    function vehicleMakeTypeCanDelete($id) {              //vehicleMakeTypeCanDelete
        if (is_numeric($id) == false)
            return false;
        $db = $this->getDBO();
        $query = "SELECT 
                    (SELECT COUNT(id) FROM `#__js_auto_vehicles` WHERE makeid = " . $id . ")
                    AS total";

        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total > 0)
            return false;
        else
            return true;
    }

    function getVehicleMakeforForm($id) {              //getVehicleMakeforForm
        $db = $this->getDBO();
        $vehiclemake = null;
        if ($id) {
            if (is_numeric($id) == false)
                return false;
            $query = "SELECT vehiclemake.*
            FROM `#__js_auto_makes` AS vehiclemake
            WHERE vehiclemake.id = " . $id;
            $db->setQuery($query);
            $vehiclemake = $db->loadObject();
        }

        return $vehiclemake;
    }

    function getVehicleMake($id) {             //getVehicleModelforForm
        $db = $this->getDBO();
        $query = "SELECT make.*
                    FROM `#__js_auto_makes` AS make
                    ORDER BY title ASC ";

        $db->setQuery($query);
        $make = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $makes = array();
        $makes[] = array('value' => '', 'text' => 'ALL');
        foreach ($make as $row) {
            $makes[] = array('value' => $row->id, 'text' => JText::_($row->title));
        }
        if ($id) {
            $lists['make'] = JHTML::_('select.genericList', $makes, 'makeid', 'class=inputbox ' . '', 'value', 'text', $makes);
        } else {
            $lists['make'] = JHTML::_('select.genericList', $makes, 'makeid', 'class=inputbox ' . '', 'value', 'text', '');
        }
        return $lists;
    }

    function getVehicleMakeTitle($id) {             //getVehicleModelforForm
        if (!is_numeric($id))
            return false;
        $db = $this->getDBO();
        $query = "SELECT make.title FROM `#__js_auto_makes` AS make WHERE make.id = " . $id;

        $db->setQuery($query);
        $make = $db->loadObject();
        if (isset($make))
            return $make->title;
        else
            return '';
    }

    function changeStatusVehicleMake($id, $status) {           //changeStatusVehicleMake
        if (is_numeric($id) == false)
            return false;
        if (is_numeric($status) == false)
            return false;
        $canpublishunpublish = $this->getJSModel('common')->canPublishUnpublishWithOutDefault($id, 'makes');
        if ($canpublishunpublish) {
            $row = $this->getTable('vehiclemake');
            $row->id = $id;
            $row->status = $status;
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                $returnvalue = 0;
            } else
                $returnvalue = 1;
        } else
            $returnvalue = 3;

        return $returnvalue;
    }

    function isVehicleMakeExist($title) {        //isVehicleMakeExist
        $db = JFactory::getDBO();
        $query = "SELECT COUNT(id) FROM #__js_auto_makes WHERE title = " . $db->Quote($title);
        $db->setQuery($query);
        $result = $db->loadResult();
        if ($result == 0)
            return 0;
        else
            return 1;
    }

    function getVehiclesMakes($title) {               //getVehiclesMakes
        $db = JFactory::getDBO();
        $query = "SELECT  id, title FROM `#__js_auto_makes` WHERE status = 1 ORDER BY title ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $makes = array();
        if ($title)
            $makes[] = array('value' => JText::_(''), 'text' => $title);
        foreach ($rows as $row) {
            $makes[] = array('value' => $row->id, 'text' => JText::_($row->title));
        }
        return $makes;
    }

    function getMakeidByTitle($title) {
        if ($title == "")
            return $title;
        $db = JFactory::getDBO();
        $query = "SELECT make.id AS makeid FROM `#__js_auto_makes` AS make WHERE LOWER(make.title) = " . $db->quote(strtolower($title));
        $db->setQuery($query);
        $result = $db->loadObject();
        if ($result) {
            return $result->makeid;
        } else {
            $row = $this->getTable('vehiclemake');
            $data['title'] = $title;
            $makealias = strtolower(str_replace(' ', '-', $title));
            $data['alias'] = $makealias;
            $data['status'] = 1;

            if (!$row->bind($data)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->check()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return $row->id;
        }
    }

}
?>
