<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:     www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest::getVar('option', 'com_jsautoz');

class JSAutozModelMileage extends JSAutozModel {

    var $_countries = null;

    function __construct() {
        parent::__construct();
    }

    function makeMileageDefault($id) {
        if (!is_numeric($id))
            return false;
        $canmakedefault = $this->getJSModel('common')->canMakeDefault($id, 'mileagetypes');
        if ($canmakedefault) {
            $db = $this->getDBO();
            $query = "UPDATE `#__js_auto_mileagetypes` AS mileagetype SET mileagetype.isdefault= 0";

            $db->setQuery($query);
            if (!$db->query()) {
                $returnvalue = 0;
            }
            $row = $this->getTable('mileagetype');
            $row->id = $id;
            $row->isdefault = 1;
            $row->status = 1;
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                echo $this->_db->getErrorMsg();
                $returnvalue = 0;
            } else
                $returnvalue = 1;
        } else
            $returnvalue = 4;

        return $returnvalue;
    }

    function getAllMileAgeTypes($limitstart, $limit) {          //get all mile age types
        $db = JFactory::getDBO();
        $result = array();
        $query = "SELECT COUNT(id) FROM #__js_auto_mileagetypes";
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;
        $query = "SELECT * FROM #__js_auto_mileagetypes ORDER BY id ASC";

        $db->setQuery($query, $limitstart, $limit);
        $result[0] = $db->loadObjectList();
        $result[1] = $total;
        return $result;
    }

    function storeMileageTypes() {                 // store Mileage Type
        $row = $this->getTable('mileagetype');
        $result = array();
        $data = JRequest::get('post');
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if ($data['id'] == '') { // only for new
            $result1 = $this->getJSModel('mileage')->isMileageTypeExist($data['title']);
            if ($result1 == 1) {
                $result[0] = 3;
                return $result;
            }
        }
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        $result[0] = true;
        $result[1] = $row->id;
        return $result;
    }

    function deletemileageType() {                        //deletemileageType
        $cids = JRequest::getVar('cid', array(0), 'post', 'array');
        $row = $this->getTable('mileagetype');
        $deleteall = 1;
        foreach ($cids as $cid) {
            if ($this->getJSModel('mileage')->mileageTypeCanDelete($cid) == true) {
                if (!$row->delete($cid)) {
                    $this->setError($row->getErrorMsg());
                    return false;
                }
            } else
                $deleteall++;
        }
        return $deleteall;
    }

    function mileageTypeCanDelete($id) {                 //mileageTypeCanDelete
        if (is_numeric($id) == false)
            return false;
        $db = $this->getDBO();
        $query = "SELECT 
                    (SELECT COUNT(id) FROM `#__js_auto_mileagetypes` WHERE id = " . $id . " AND isdefault = 1)
                    + (SELECT COUNT(id) FROM `#__js_auto_vehicles` WHERE mileagetypeid = " . $id . " )
                    AS total";

        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total > 0)
            return false;
        else
            return true;
    }

    function getMileageTypeforForm($id) {             //getMileageTypeforForm
        $db = $this->getDBO();
        $mileagetype = null;
        if ($id) {
            if (is_numeric($id) == false)
                return false;
            $query = "SELECT mileagetype.*
            FROM `#__js_auto_mileagetypes` AS mileagetype
            WHERE mileagetype.id = " . $id;
            $db->setQuery($query);
            $mileagetype = $db->loadObject();
        }
        return $mileagetype;
    }

    function changeStatusMileageType($id, $status) {           //changeStatusMileageType
        if (is_numeric($id) == false)
            return false;
        if (is_numeric($status) == false)
            return false;
        $canpublishunpublish = $this->getJSModel('common')->canPublishUnpublish($id, 'mileagetypes');
        if ($canpublishunpublish) {
            $row = $this->getTable('mileagetype');
            $row->id = $id;
            $row->status = $status;
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                $returnvalue = 0;
            } else
                $returnvalue = 1;
        } else
            $returnvalue = 3;

        return $returnvalue;
    }

    function isMileageTypeExist($title) {          //isMileageTypeExist
        $db = JFactory::getDBO();
        $query = "SELECT COUNT(id) FROM #__js_auto_mileagetypes WHERE title = " . $db->Quote($title);
        $db->setQuery($query);
        $result = $db->loadResult();
        if ($result == 0)
            return 0;
        else
            return 1;
    }

    function getMileagesType($title) {           //getMileagesType
        $db = JFactory::getDBO();
        $query = "SELECT  id, title FROM `#__js_auto_mileagetypes` WHERE status = 1 ORDER BY title ASC ";

        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            return false;
        }
        $mileagetypes = array();
        if ($title)
            $mileagetypes[] = array('value' => JText::_(''), 'text' => $title);
        foreach ($rows as $row) {
            $mileagetypes[] = array('value' => $row->id, 'text' => JText::_($row->title));
        }
        return $mileagetypes;
    }

    function getSpeedmetertypeidByTitle($title) {
        if ($title == "")
            return $title;
        $db = JFactory::getDBO();
        $query = "SELECT mileagetype.id AS mileagetypeid FROM `#__js_auto_mileagetypes` AS mileagetype WHERE LOWER(mileagetype.title) = " . $db->quote(strtolower($title));
        $db->setQuery($query);
        $result = $db->loadObject();
        if ($result) {
            return $result->mileagetypeid;
        } else {
            $row = $this->getTable('mileagetype');
            $data['title'] = $title;
            $data['symbol'] = strtolower($title);
            $data['status'] = 1;

            if (!$row->bind($data)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->check()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return $row->id;
        }
    }

}

?>
