<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:     www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest::getVar('option', 'com_jsautoz');

class JSAutozModelModel extends JSAutozModel {

    var $_countries = null;

    function __construct() {
        parent::__construct();
    }

    function getVehicleModelTitle($id) {             //getVehicleModelforForm
        if (!is_numeric($id))
            return false;
        $db = $this->getDBO();
        $query = "SELECT model.title FROM `#__js_auto_models` AS model WHERE model.id = " . $id;

        $db->setQuery($query);
        $model = $db->loadObject();
        if (isset($model))
            return $model->title;
        else
            return '';
    }

    function getAllModels($limitstart, $limit) {               //get all models
        $db = JFactory::getDBO();
        $result = array();
        $query = "SELECT COUNT(id) FROM #__js_auto_models";
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;
        $query = "SELECT * FROM #__js_auto_models ORDER BY id ASC";

        $db->setQuery($query, $limitstart, $limit);
        $result[0] = $db->loadObjectList();
        $result[1] = $total;
        return $result;
    }

    function getAllModelsByMake($mkid, $searchtitle, $sortby, $limitstart, $limit) {               //get all models
        $db = JFactory::getDBO();
        $result = array();
        $sort = array(
            0 => array('value' => '', 'text' => JText::_('Sort By')),
            1 => array('value' => 'ASC', 'text' => JText::_('Ascending')),
            2 => array('value' => 'DESC', 'text' => JText::_('Descending')),
        );

        $lists['sort'] = JHTML::_('select.genericList', $sort, 'sortby', 'class="inputbox" ' . '', 'value', 'text', $sortby);
        if (!is_numeric($mkid))
            return false;
        $query = "SELECT COUNT(id) FROM #__js_auto_models AS model  WHERE model.makeid=" . $mkid;
        if ($searchtitle)
            $query .= " AND model.title LIKE '%" . str_replace("'", "", $db->quote($searchtitle)) . "%'";
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;
        $query = "SELECT * FROM #__js_auto_models AS model WHERE model.makeid=" . $mkid;
        if ($searchtitle)
            $query .= " AND model.title LIKE '%" . str_replace("'", "", $db->quote($searchtitle)) . "%'";
        if ($sortby)
            $query .="ORDER BY model.title " . $sortby;
        $db->setQuery($query, $limitstart, $limit);
        $result[0] = $db->loadObjectList();
        $result[1] = $total;

        $query = "SELECT title FROM #__js_auto_makes WHERE id=" . $mkid;
        $db->setQuery($query);
        if ($searchtitle)
            $lists['modeltitle'] = $searchtitle;
        $result[2] = $db->loadObject();
        $result[3] = $lists;
        return $result;
    }

    function listModels($val, $req) {               //list models
        $db = $this->getDBO();
        if ($val)
            if (is_numeric($val) == false)
                return false;
        $required = '';
        $query = "SELECT id, title FROM `#__js_auto_models`  WHERE status = 1 AND makeid = " . $val . " ORDER BY title ASC";
        $db->setQuery($query);
        $result = $db->loadObjectList();
        if ($req == 1)
            $required == ' required';
        if (empty($result)) {
            $return_value = "<input class='inputbox" . $required . "' type='text' name='modelid' size='40' maxlength='100'  />";
        } else {
            $return_value = "<select name='modelid' class='inputbox" . $required . "' >\n";
            $return_value .= "<option value='0'>" . JText::_('Select Model') . "</option>\n";
            foreach ($result as $row) {
                $return_value .= "<option value=\"$row->id\" >$row->title</option> \n";
            }
            $return_value .= "</select>\n";
        }
        return $return_value;
    }

    function getVehiclesModel($title) {        //get vehicle models
        $db = JFactory::getDBO();
        $query = "SELECT  id, title FROM `#__js_auto_models` WHERE status = 1  ORDER BY title ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $models = array();
        if ($title)
            $models[] = array('value' => JText::_(''), 'text' => $title);
        foreach ($rows as $row) {
            $models[] = array('value' => $row->id, 'text' => JText::_($row->title));
        }
        return $models;
    }

    function getVehiclesModelsbyMakeId($makeid, $title) {        //get vehicle models by make id
        $db = JFactory::getDBO();
        if (!is_numeric($makeid))
            return false;
        $query = "SELECT  id, title FROM `#__js_auto_models` WHERE status = 1 AND makeid = " . $makeid . " ORDER BY title ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        $models = array();
        if ($title)
            $models[] = array('value' => JText::_(''), 'text' => $title);
        foreach ($rows as $row) {
            $models[] = array('value' => $row->id, 'text' => JText::_($row->title));
        }
        return $models;
    }

    function getVehiclesModels() {
        $title = 'Any';
        $db = JFactory::getDBO();
        $query = "SELECT  id, title FROM `#__js_auto_models` WHERE ";
        $query .= " status = 1 ORDER BY title ASC ";

        $db->setQuery($query);
        $rows = $db->loadObjectList();
        $models = array();
        if ($title)
            $models[] = array('value' => JText::_(''), 'text' => $title);
        foreach ($rows as $row) {
            $models[] = array('value' => $row->id, 'text' => JText::_($row->title));
        }
        return $models;
    }

    function storeVehicleModel() {       //store vehicle models
        $row = $this->getTable('vehiclemodel');
        $data = JRequest::get('post');

//for alias apply rule
        if (!empty($data['alias']))
            $modelalias = $data['alias'];
        else
            $modelalias = $data['title'];

        $modelalias = strtolower(str_replace(' ', '-', $modelalias));
        $data['alias'] = $modelalias;

        $result = array();
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if ($data['id'] == '') { // only for new
            $result1 = $this->getJSModel('model')->isVehicleModelExist($data['title']);
            if ($result1 == 1) {
                $result[0] = 3;
                return $result;
            }
        }
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        $result[0] = true;
        $result[1] = $row->id;
        return $result;
    }

    function deleteVehicleModel() {                  //deleteVehicleModel
        $cids = JRequest::getVar('cid', array(0), 'post', 'array');
        $row = $this->getTable('vehiclemodel');
        $deleteall = 1;
        foreach ($cids as $cid) {
            if ($this->getJSModel('model')->vehicleModelCanDelete($cid) == true) {
                if (!$row->delete($cid)) {
                    $this->setError($row->getErrorMsg());
                    return false;
                }
            } else
                $deleteall++;
        }
        return $deleteall;
    }

    function vehicleModelCanDelete($id) {                //vehicleModelCanDelete
        if (is_numeric($id) == false)
            return false;
        $db = $this->getDBO();

        $query = "SELECT 
                    (SELECT COUNT(id) FROM `#__js_auto_vehicles` WHERE modelid = " . $id . " )
                    AS total";
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total > 0)
            return false;
        else
            return true;
    }

    function getVehicleModelforForm($id) {             //getVehicleModelforForm
        $db = $this->getDBO();
        $vehiclemodel = null;
        if ($id) {
            if (is_numeric($id) == false)
                return false;
            $query = "SELECT vehiclemodel.*
            FROM `#__js_auto_models` AS vehiclemodel
            WHERE vehiclemodel.id = " . $id;
            $db->setQuery($query);
            $vehiclemodel = $db->loadObject();
        }
        return $vehiclemodel;
    }

    function changeStatusVehicleModel($id, $status) {              //changeStatusVehicleModel
        if (is_numeric($id) == false)
            return false;
        if (is_numeric($status) == false)
            return false;
        $canpublishunpublish = $this->getJSModel('common')->canPublishUnpublishWithOutDefault($id, 'models');
        if ($canpublishunpublish) {
            $row = $this->getTable('vehiclemodel');
            $row->id = $id;
            $row->status = $status;
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                $returnvalue = 0;
            } else
                $returnvalue = 1;
        } else
            $returnvalue = 3;

        return $returnvalue;
    }

    function isVehicleModelExist($title) {         //isVehicleModelExist
        $db = JFactory::getDBO();
        $query = "SELECT COUNT(id) FROM #__js_auto_models WHERE title = " . $db->Quote($title);
        $db->setQuery($query);
        $result = $db->loadResult();
        if ($result == 0)
            return 0;
        else
            return 1;
    }

    function getModelidByTitle($title, $makeid) {
        if ($title == "")
            return $title;
        $db = JFactory::getDBO();
        $query = "SELECT model.id AS modelid FROM `#__js_auto_models` AS model WHERE LOWER(model.title) = " . $db->quote(strtolower($title));
        $db->setQuery($query);
        $result = $db->loadObject();
        if ($result) {
            return $result->modelid;
        } else {
            $row = $this->getTable('vehiclemodel');
            $data['makeid'] = $makeid;
            $data['title'] = $title;
            $modelalias = strtolower(str_replace(' ', '-', $title));
            $data['alias'] = $modelalias;
            $data['status'] = 1;

            if (!$row->bind($data)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->check()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return $row->id;
        }
    }

}
?>