<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:     www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest::getVar('option', 'com_jsautoz');

class JSAutozModelModelyear extends JSAutozModel {

    var $_countries = null;

    function __construct() {
        parent::__construct();
    }

    function makeModelyearDefault($id) {
        if (!is_numeric($id))
            return false;
        $canmakedefault = $this->getJSModel('common')->canMakeDefault($id, 'modelyears');
        if ($canmakedefault) {
            $db = $this->getDBO();
            $query = "UPDATE `#__js_auto_modelyears` AS modelyear SET modelyear.isdefault= 0";
            $db->setQuery($query);
            if (!$db->query()) {
                $returnvalue = 0;
            }
            $row = $this->getTable('vehiclemodelyear');
            $row->id = $id;
            $row->isdefault = 1;
            $row->status = 1;
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                $returnvalue = 0;
            } else
                $returnvalue = 1;
        } else
            $returnvalue = 4;
        return $returnvalue;
    }

    function getAllModelyears($limitstart, $limit) {          //get all models year
        $db = JFactory::getDBO();
        $result = array();
        $query = "SELECT COUNT(id) FROM #__js_auto_modelyears";
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;
        $query = "SELECT * FROM #__js_auto_modelyears ORDER BY title DESC";

        $db->setQuery($query, $limitstart, $limit);
        $result[0] = $db->loadObjectList();
        $result[1] = $total;
        return $result;
    }

    function getVehiclesModelYear($title) {     //get vehicle models year
        $db = JFactory::getDBO();
        $query = "SELECT  id, title FROM `#__js_auto_modelyears` WHERE status = 1 ORDER BY title ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $modelyears = array();
        if ($title)
            $modelyears[] = array('value' => JText::_(''), 'text' => $title);
        foreach ($rows as $row) {
            $modelyears[] = array('value' => $row->id, 'text' => JText::_($row->title));
        }
        return $modelyears;
    }

    function storeVehicleModelyears() {         //store model year 
        $row = $this->getTable('vehiclemodelyear');
        $result = array();
        $data = JRequest::get('post');
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if ($data['id'] == '') { // only for new
            $result1 = $this->getJSModel('modelyear')->isVehicleModelYearExist($data['title']);
            if ($result1 == 1) {
                $result[0] = 3;
                return $result;
            }
        }
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        $result[0] = true;
        $result[1] = $row->id;
        return $result;
    }

    function deleteVehicleModelYear() {              //deleteVehicleModelYear
        $cids = JRequest::getVar('cid', array(0), 'post', 'array');
        $row = $this->getTable('vehiclemodelyear');
        $deleteall = 1;
        foreach ($cids as $cid) {
            if ($this->getJSModel('modelyear')->vehicleModelYearCanDelete($cid) == true) {
                if (!$row->delete($cid)) {
                    $this->setError($row->getErrorMsg());
                    return false;
                }
            } else
                $deleteall++;
        }
        return $deleteall;
    }

    function vehicleModelYearCanDelete($id) {           //vehicleModelYearCanDelete
        if (is_numeric($id) == false)
            return false;
        $db = $this->getDBO();

        $query = "SELECT 
                    (SELECT COUNT(id) FROM `#__js_auto_modelyears` WHERE id = " . $id . " AND isdefault = 1 )
                    + (SELECT COUNT(id) FROM `#__js_auto_vehicles` WHERE modelyearid = " . $id . " )
                    AS total";
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total > 0)
            return false;
        else
            return true;
    }

    function getVehicleModelyearforForm($id) {         //getVehicleModelyearforForm
        $db = $this->getDBO();
        $modelyear = null;
        if ($id) {
            if (is_numeric($id) == false)
                return false;
            $query = "SELECT vehiclemodelyear.*
            FROM `#__js_auto_modelyears` AS vehiclemodelyear
            WHERE vehiclemodelyear.id = " . $id;

            $db->setQuery($query);
            $modelyear = $db->loadObject();
        }
        return $modelyear;
    }

    function changeStatusVehicleModelYear($id, $status) {           //changeStatusVehicleModelYear
        if (is_numeric($id) == false)
            return false;
        if (is_numeric($status) == false)
            return false;
        $canpublishunpublish = $this->getJSModel('common')->canPublishUnpublish($id, 'modelyears');
        if ($canpublishunpublish) {
            $row = $this->getTable('vehiclemodelyear');
            $row->id = $id;
            $row->status = $status;
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                $returnvalue = 0;
            } else
                $returnvalue = 1;
        } else
            $returnvalue = 3;

        return $returnvalue;
    }

    function isVehicleModelYearExist($title) {        //isVehicleModelYearExist
        $db = JFactory::getDBO();
        $query = "SELECT COUNT(id) FROM #__js_auto_modelyears WHERE title = " . $db->Quote($title);
        $db->setQuery($query);
        $result = $db->loadResult();
        if ($result == 0)
            return 0;
        else
            return 1;
    }

    function getModelyearidByTitle($title) {
        if ($title == "")
            return $title;
        $db = JFactory::getDBO();
        $query = "SELECT modelyear.id AS modelyearid FROM `#__js_auto_modelyears` AS modelyear WHERE LOWER(modelyear.title) = " . $db->quote(strtolower($title));
        $db->setQuery($query);
        $result = $db->loadObject();
        if ($result) {
            return $result->modelyearid;
        } else {
            $row = $this->getTable('vehiclemodelyear');
            $data['title'] = $title;
            $data['status'] = 1;

            if (!$row->bind($data)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->check()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return $row->id;
        }
    }

}

?>