<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:     www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest::getVar('option', 'com_jsautoz');

class JSAutozModelState extends JSAutozModel {

    var $_countries = null;

    function __construct() {
        parent::__construct();
    }

    function publishedStates($cids) {
        $db = $this->getDBO();
        foreach ($cids as $cid) {
            if (!is_numeric($cid))
                return false;
            $query = "UPDATE `#__js_auto_states` AS state SET state.enabled= '1'
                        WHERE state.id =" . $cid;
            $db->setQuery($query);
            if (!$db->query()) {
                return false;
            }
        }
        return true;
    }

    function unPublishedStates($cids) {
        $db = $this->getDBO();
        foreach ($cids as $cid) {
            if (!is_numeric($cid))
                return false;
            $query = "UPDATE `#__js_auto_states` AS state SET state.enabled= '0'
                        WHERE state.id =" . $cid;
            $db->setQuery($query);
            if (!$db->query()) {
                return false;
            }
        }
        return true;
    }

    function getAllCountryStates($searchname, $countryid, $limitstart, $limit) {        //get all country states
        if (!is_numeric($countryid))
            return false;
        $db = JFactory::getDBO();
        $result = array();
        $query = "SELECT COUNT(id) FROM `#__js_auto_states` WHERE countryid = " . $countryid;
        if ($searchname) {
            $query .= " AND name LIKE '%" . str_replace("'", "", $db->Quote($searchname)) . "%'";
        }
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;

        $query = "SELECT * FROM `#__js_auto_states` WHERE countryid = " . $countryid;
        if ($searchname) {
            $query .= " AND name LIKE '%" . str_replace("'", "", $db->Quote($searchname)) . "%' ORDER BY name ASC";
        } else {
            $query .= " ORDER BY name ASC";
        }
        $db->setQuery($query, $limitstart, $limit);

        $result[0] = $db->loadObjectList();
        $result[1] = $total;
        if ($searchname) {
            $lists['searchname'] = $searchname;
            $result[2] = $lists;
        }
        return $result;
    }

    function storeVehicleState($countryid) {                 // store Vehicle Country
        $row = $this->getTable('state');
        $data = JRequest::get('post');
        $row->countryid = $countryid;
        $row->enabled = 1;
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        if ($data['id'] == '') { // only for new
            $result = $this->getJSModel('state')->isVehicleStateExist($countryid, $data['name']);
            if ($result == true)
                return 3;
        }
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        return true;
    }

    function deleteState() {
        $cids = JRequest::getVar('cid', array(0), 'post', 'array');
        $row = $this->getTable('state');
        $deleteall = 1;
        foreach ($cids as $cid) {
            if ($this->getJSModel('state')->stateCanDelete($cid) == true) {
                if (!$row->delete($cid)) {
                    $this->setError($row->getErrorMsg());
                    return false;
                }
            }
            else
                $deleteall++;
        }
        return $deleteall;
    }

    function stateCanDelete($stateid) {
        if (is_numeric($stateid) == false)
            return false;
        $db = $this->getDBO();

        $query = "SELECT COUNT(city.id) AS total FROM `#__js_auto_cities` AS city 
                    WHERE city.stateid = " . $stateid;
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total > 0)
            return false;
        else
            return true;
    }

    function getVehicleStateforForm($id) {              //getVehicleCountryforForm
        $db = $this->getDBO();
        $state = null;
        if ($id) {
            if (is_numeric($id) == false)
                return false;
            $query = "SELECT state.*
            FROM `#__js_auto_states` AS state
            WHERE state.id = " . $id;
            $db->setQuery($query);
            $state = $db->loadObject();
        }
        return $state;
    }

    function isVehicleStateExist($countryid, $title) {          //isVehiclestateExist
        if (!is_numeric($countryid))
            return false;
        $db = JFactory::getDBO();
        $query = "SELECT COUNT(id) FROM #__js_auto_states WHERE countryid=" . $countryid . " AND name = " . $db->Quote($title);
        $db->setQuery($query);
        $result = $db->loadResult();
        if ($result == 0)
            return false;
        else
            return true;
    }

    function makeStateCode($stat, $countrycode) {
        $db = JFactory::getDBO();
        $state = str_replace(" ", "", $stat); // remove spaces
        $totallen = strlen($state);
        $len = 4;
        if ($len > $totallen)
            $len = $totallen;
        $code = substr($state, 0, $len);
        $found = false;
        $start = 0;
        while (!$found == true) {
            $query = "SELECT COUNT(id) FROM #__js_auto_states WHERE code = " . $db->Quote($code);
            $db->setQuery($query);
            $result = $db->loadResult();
            if ($result == 0) {
                $found = true;
                return $code;
            } else {
                $code = substr($state, 0, $len);
                if ($len == $totallen)
                    $code .= $countrycode;
                if ($len > $totallen)
                    return false;
                $len++;
            }
        }
    }

    function getStates($countryid, $title) {          //getStates
        $db = JFactory::getDBO();
        $query = "SELECT * FROM `#__js_auto_states` WHERE enabled = '1' AND countryid = " . $db->quote($countryid) . " ORDER BY name ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $states = array();
        if ($title)
            $states[] = array('value' => JText::_(''), 'text' => $title);
        else
            $states[] = array('value' => JText::_(''), 'text' => JText::_('Choose State'));

        foreach ($rows as $row) {
            $states[] = array('value' => JText::_($row->id), 'text' => JText::_($row->name));
        }
        return $states;
    }

    function getStateidByTitle($title) {
        if ($title == "")
            return $title;
        $db = JFactory::getDBO();
        $query = "SELECT state.id AS stateid FROM `#__js_auto_states` AS state WHERE LOWER(state.name) = " . $db->quote(strtolower($title));
        $db->setQuery($query);
        $result = $db->loadObject();
        if ($result) {
            return $result->stateid;
        } else {
            return $title;
        }
    }

}

?>