<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:     www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest::getVar('option', 'com_jsautoz');

class JSAutozModelTransmission extends JSAutozModel {

    var $_countries = null;

    function __construct() {
        parent::__construct();
    }

    function makeTransmissionDefault($id) {
        if (!is_numeric($id))
            return false;
        $canmakedefault = $this->getJSModel('common')->canMakeDefault($id, 'transmissions');
        if ($canmakedefault) {
            $db = $this->getDBO();
            $query = "UPDATE `#__js_auto_transmissions` AS trans SET trans.isdefault= 0";
            $db->setQuery($query);
            if (!$db->query()) {
                $retunvalue = 0;
            }
            $row = $this->getTable('transmission');
            $row->id = $id;
            $row->isdefault = 1;
            $row->status = 1;
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                $retunvalue = 0;
            } else
                $retunvalue = 1;
        } else
            $retunvalue = 4;
        return $retunvalue;
    }

    function getAllTransmissions($limitstart, $limit) {             //get all transmission
        $db = JFactory::getDBO();
        $result = array();
        $query = "SELECT COUNT(id) FROM #__js_auto_transmissions";
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;
        $query = "SELECT * FROM #__js_auto_transmissions ORDER BY id ASC";

        $db->setQuery($query, $limitstart, $limit);
        $result[0] = $db->loadObjectList();
        $result[1] = $total;
        return $result;
    }

    function getVehiclesTransmission($title = "Any") {         //get vehicle transmission
        $db = JFactory::getDBO();
        $query = "SELECT  id, title FROM `#__js_auto_transmissions` WHERE status = 1 ORDER BY title ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $transmissions = array();
        if ($title)
            $transmissions[] = array('value' => JText::_(''), 'text' => $title);
        foreach ($rows as $row) {
            $transmissions[] = array('value' => $row->id, 'text' => JText::_($row->title));
        }
        return $transmissions;
    }

    function storeVehicleTransmission() {       //store vehicle transmisson
        $row = $this->getTable('transmission');
        $result = array();
        $data = JRequest::get('post');
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if ($data['id'] == '') { // only for new
            $result1 = $this->getJSModel('transmission')->isVehicleTransmissionExist($data['title']);
            if ($result1 == 1) {
                $result[0] = 3;
                return $result;
            }
        }
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        $result[0] = true;
        $result[1] = $row->id;
        return $result;
    }

    function deleteVehicleTransmission() {             //deleteVehicleTransmission
        $cids = JRequest::getVar('cid', array(0), 'post', 'array');
        $row = $this->getTable('transmission');
        $deleteall = 1;
        foreach ($cids as $cid) {
            if ($this->getJSModel('transmission')->vehicleTransmissionCanDelete($cid) == true) {
                if (!$row->delete($cid)) {
                    $this->setError($row->getErrorMsg());
                    return false;
                }
            } else
                $deleteall++;
        }
        return $deleteall;
    }

    function vehicleTransmissionCanDelete($id) {               //vehicleTransmissionCanDelete
        if (is_numeric($id) == false)
            return false;
        $db = $this->getDBO();

        $query = "SELECT 
                    (SELECT COUNT(id) FROM `#__js_auto_transmissions` WHERE id = " . $id . " AND isdefault = 1)
                    + (SELECT COUNT(id) FROM `#__js_auto_vehicles` WHERE transmissionid = " . $id . ")
                    
                    
                    AS total";
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total > 0)
            return false;
        else
            return true;
    }

    function getVehicleTransmissionforForm($id) {          //getVehicleTransmissionforForm
        $db = $this->getDBO();
        $transmission = null;
        if ($id) {
            if (is_numeric($id) == false)
                return false;
            $query = "SELECT vehicletransmission.*
            FROM `#__js_auto_transmissions` AS vehicletransmission
            WHERE vehicletransmission.id = " . $id;
            $db->setQuery($query);
            $transmission = $db->loadObject();
        }
        return $transmission;
    }

    function changeStatusVehicleTransmission($id, $status) {         //changeStatusVehicleTransmission
        if (is_numeric($id) == false)
            return false;
        if (is_numeric($status) == false)
            return false;
        $canpublishunpublish = $this->getJSModel('common')->canPublishUnpublish($id, 'transmissions');
        if ($canpublishunpublish) {
            $row = $this->getTable('transmission');
            $row->id = $id;
            $row->status = $status;
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                $returnvalue = 0;
            } else
                $returnvalue = 1;
        } else
            $returnvalue = 3;

        return $returnvalue;
    }

    function isVehicleTransmissionExist($title) {             //isVehicleTransmissionExist
        $db = JFactory::getDBO();
        $query = "SELECT COUNT(id) FROM #__js_auto_transmissions WHERE title = " . $db->Quote($title);
        $db->setQuery($query);
        $result = $db->loadResult();
        if ($result == 0)
            return 0;
        else
            return 1;
    }

    function getTransmissionidByTitle($title) {
        if ($title == "")
            return $title;
        $db = JFactory::getDBO();
        $query = "SELECT transmission.id AS transmissionid FROM `#__js_auto_transmissions` AS transmission WHERE LOWER(transmission.title) = " . $db->quote(strtolower($title));
        $db->setQuery($query);
        $result = $db->loadObject();
        if ($result) {
            return $result->transmissionid;
        } else {
            $row = $this->getTable('transmission');
            $data['title'] = $title;
            $data['status'] = 1;

            if (!$row->bind($data)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->check()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return $row->id;
        }
    }

}
?>