<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:     www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest::getVar('option', 'com_jsautoz');

class JSAutozModelVehicle extends JSAutozModel {

    function __construct() {
        parent::__construct();
    }

    function getVehicleSort($sortvalue) {
        $sorting = array(
            '0' => array('value' => 'vehicles.title ', 'text' => JText::_('Title')),
            '1' => array('value' => 'makes.title', 'text' => JText::_('Make')),
            '2' => array('value' => 'models.title', 'text' => JText::_('Model')),
            '3' => array('value' => 'modelyear.title', 'text' => JText::_('Model Year')),
            '4' => array('value' => 'vehicles.price', 'text' => JText::_('Price')),
            '5' => array('value' => 'vehicletypes.title', 'text' => JText::_('Vehicle Type')),
            '6' => array('value' => 'fueltype.title', 'text' => JText::_('Fuel Type')),
            '7' => array('value' => 'created', 'text' => JText::_('Created')),);

        $selectsort['sort'] = JHTML::_('select.genericlist', $sorting, 'lv_sortvalue', 'class="inputbox" ' . 'onchange="submitSorting(1)"', 'value', 'text', $sortvalue);
        return $selectsort;
    }

    function getVehiclebyIds($id) {
        if (!is_numeric($id))
            return false;
        $db = $this->getDBO();
        $query = "SELECT vehicles.price,vehicles.created AS created,
                    vehicles.id,vehicles.title,vehicles.conditionid AS conditionid,
                    vehicles.exteriorcolor,vehicles.enginecapacity,vehicletypes.title AS vehicletitle,
                    makes.title maketitle,models.title AS modeltitle,modelyear.title AS modelyeartitle,
                    fueltype.title AS fueltitle,cylinder.title AS cylindertitle ,
                    conditions.title AS conditiontitle, cat.title AS cattitle , image.filename AS vehiclelogo
                    FROM `#__js_auto_vehicles` AS vehicles
                    LEFT JOIN `#__js_auto_vehicleimages` AS image ON vehicles.id= image.vehicleid AND image.isdefault = 1
                    LEFT JOIN `#__js_auto_vehicletypes` AS vehicletypes ON vehicles.vehicletypeid = vehicletypes.id
                    LEFT JOIN `#__js_auto_makes` AS makes ON vehicles.makeid =makes.id
                    LEFT JOIN `#__js_auto_models` AS models ON vehicles.modelid =  models.id
                    LEFT JOIN `#__js_auto_categories` AS cat ON vehicles.categoryid =  cat.id
                    LEFT JOIN `#__js_auto_modelyears` AS modelyear ON vehicles.modelyearid = modelyear.id
                    LEFT JOIN `#__js_auto_conditions` AS conditions ON vehicles.conditionid = conditions.id
                    LEFT JOIN `#__js_auto_fueltypes` AS fueltype ON vehicles.fueltypeid = fueltype.id
                    LEFT JOIN `#__js_auto_cylinders` AS cylinder ON vehicles.cylinderid = cylinder.id
                    WHERE vehicles.id = " . $id;

        $db->setQuery($query);
        $result = $db->loadObject();
        return $result;
    }
	function getNewVehicles(){
		$db = $this->getDBO();
		$query = "SELECT count(*) as total FROM `#__js_auto_vehicles`  
                    WHERE status = 1 AND conditionid = 1 AND created >= CURDATE(); ";

        $db->setQuery($query);
        $result = $db->loadObject();
        return $result;
		}
    function getUsedVehicles(){
        $db = $this->getDBO();
        $query = "SELECT count(*) as total FROM `#__js_auto_vehicles`  
                    WHERE status = 1 AND conditionid = 2 AND created >= CURDATE(); ";

        $db->setQuery($query);
        $result = $db->loadObject();
        return $result;
        }

	function getNewestVehicles(){
	$db = $this->getDBO();
	$query = "SELECT vehicles.id,vehicles.title,vehicles.enginecapacity,makes.title maketitle,miletype.symbol As mileagesymbol,
                    models.title AS modeltitle,modelyear.title AS modelyeartitle,trans.title AS transmission ,
                    fueltype.title AS fueltitle,conditions.title AS conditiontitle,conditions.id AS conditionid,
                    image.filename AS vehiclelogo,country.name AS countryname,state.name AS statename,vehicles.status,
                    city.name AS cityname,vehicles.price,vehicles.isdiscount,vehicles.discountstart,vehicles.mileages AS mileage,
                    vehicles.discountend,vehicles.discounttype,vehicles.discount,currency.symbol AS currency
                FROM `#__js_auto_vehicles` AS vehicles  
                LEFT JOIN `#__js_auto_vehicleimages` AS image ON vehicles.id= image.vehicleid AND image.isdefault = 1
                LEFT JOIN `#__js_auto_makes` AS makes ON vehicles.makeid =makes.id
                LEFT JOIN `#__js_auto_models` AS models ON vehicles.modelid =  models.id
                LEFT JOIN `#__js_auto_modelyears` AS modelyear ON vehicles.modelyearid = modelyear.id
                LEFT JOIN `#__js_auto_conditions` AS conditions ON vehicles.conditionid = conditions.id
                LEFT JOIN `#__js_auto_fueltypes` AS fueltype ON vehicles.fueltypeid = fueltype.id
                LEFT JOIN `#__js_auto_cities` AS city ON vehicles.loccity = city.id
                LEFT JOIN `#__js_auto_countries` AS country ON city.countryid = country.id
                LEFT JOIN `#__js_auto_states` AS state ON city.stateid = state.id
                LEFT JOIN `#__js_auto_currency` AS currency ON vehicles.currencyid = currency.id
                LEFT JOIN `#__js_auto_mileagetypes` AS miletype ON vehicles.speedmetertypeid = miletype.id
                LEFT JOIN `#__js_auto_transmissions` AS trans ON vehicles.transmissionid = trans.id        
                ORDER By vehicles.created DESC LIMIT 5" ;

    $db->setQuery($query);
    $result = $db->loadObjectList();
    
    return $result;
	}

    function getVehicleSpecificationbyId($id) {
        if (!is_numeric($id))
            return false;
        $db = $this->getDBO();
        $query = "SELECT  vehicles.description AS description,vehicles.issold AS soldvehicles,vehicles.uid,vehicles.price,trans.title AS transmission ,
                    vehicles.mileages AS mileage,vehicles.latitude,vehicles.longitude,vehicles.loczip,vehicles.stocknumber,
                    miletype.symbol As mileagesymbol,vehicles.created ,vehicles.isdiscount,
                    vehicles.id,vehicles.title,vehicles.map,vehicles.video,vehicles.makeid,vehicles.modelid,
                    vehicles.loccountry AS country,vehicles.locstate AS state,vehicles.loccity AS city,
                    country.name AS countryname,state.name AS statename,loccity.name AS loccityname,regcity.name AS regcityname,
                    vehicles.exteriorcolor,vehicles.interiorcolor,vehicles.enginecapacity,vehicletypes.title AS vehicletitle,
                    makes.title maketitle,models.title AS modeltitle,modelyear.title AS modelyeartitle,
                    fueltype.title AS fueltitle,cylinder.title AS cylindertitle ,
                    conditions.title AS conditiontitle, cat.title AS cattitle , image.filename AS vehiclelogo,currency.symbol AS currency,
                    vehicles.cityfuelconsumption AS cityfuelconsumption,vehicles.highwayfuelconsumption AS highwayfuelconsumption,
                    vehicles.acceleration AS acceleration,vehicles.maxspeed AS maxspeed,vehicles.streetaddress AS streetaddress,
                    vehicles.bargainprice AS bargainprice,vehicles.exportprice AS exportprice,vehicles.discount AS discount,vehicles.discounttype AS discounttype,
                    vehicles.discountstart AS discountstart, vehicles.discountend AS discountend,vehicles.co2 AS co2
                    FROM `#__js_auto_vehicles` AS vehicles
                    LEFT JOIN `#__js_auto_vehicleimages` AS image ON vehicles.id= image.vehicleid AND image.isdefault = 1
                    LEFT JOIN `#__js_auto_vehicletypes` AS vehicletypes ON vehicles.vehicletypeid = vehicletypes.id
                    LEFT JOIN `#__js_auto_mileagetypes` AS miletype ON vehicles.speedmetertypeid = miletype.id
                    LEFT JOIN `#__js_auto_makes` AS makes ON vehicles.makeid =makes.id
                    LEFT JOIN `#__js_auto_models` AS models ON vehicles.modelid =  models.id
                    LEFT JOIN `#__js_auto_categories` AS cat ON vehicles.categoryid =  cat.id
                    LEFT JOIN `#__js_auto_modelyears` AS modelyear ON vehicles.modelyearid = modelyear.id
                    LEFT JOIN `#__js_auto_conditions` AS conditions ON vehicles.conditionid = conditions.id
                    LEFT JOIN `#__js_auto_fueltypes` AS fueltype ON vehicles.fueltypeid = fueltype.id
                    LEFT JOIN `#__js_auto_cylinders` AS cylinder ON vehicles.cylinderid = cylinder.id
                    LEFT JOIN `#__js_auto_currency` AS currency ON vehicles.currencyid = currency.id
                    LEFT JOIN `#__js_auto_transmissions` AS trans ON vehicles.transmissionid = trans.id        
                    LEFT JOIN `#__js_auto_cities` AS loccity ON vehicles.loccity = loccity.id
                    LEFT JOIN `#__js_auto_countries` AS country ON loccity.countryid = country.id
                    LEFT JOIN `#__js_auto_states` AS state ON loccity.stateid = state.id
                    LEFT JOIN `#__js_auto_cities` AS regcity ON vehicles.regcity = regcity.id
                    WHERE  vehicles.id = " . $id . " GROUP BY vehicles.id";

        $db->setQuery($query);
        $result = $db->loadObject();
        return $result;
    }

    function getAllVehicle($searchtitle, $searchmakeid, $searchmodelid, $searchvehicletypeid, $searchconditionid, $statusid, $limitstart, $limit) {  // get all vehicle
        $db = $this->getDBO();
        $this->getJSModel('jsautoz')->checkCall();
        $result = array();
        $status [] = array('value' => '', 'text' => JText::_('Status'));
        $status [] = array('value' => 1, 'text' => JText::_('Approved'));
        $status [] = array('value' => -1, 'text' => JText::_('Rejected'));

        $lists['title'] = $searchtitle;
        $lists['makes'] = JHTML::_('select.genericList', $this->getJSModel('make')->getVehiclesMakes(JText::_('Make')), 'filter_av_makeid', 'class="inputbox" ' . 'onChange="getvfsmodels(this.value,0)"', 'value', 'text', $searchmakeid);
        $lists['models'] = JHTML::_('select.genericList', $this->getJSModel('model')->getVehiclesModelsbyMakeId(1, JText::_('Model')), 'filter_av_modelid', 'class="inputbox" ' . '', 'value', 'text', $searchmodelid);
        $lists['vehicletypes'] = JHTML::_('select.genericList', $this->getJSModel('vehicletype')->getVehiclesType(JText::_('Types')), 'filter_av_vehicletypeid', 'class="inputbox" ' . '', 'value', 'text', $searchvehicletypeid);
        $lists['conditions'] = JHTML::_('select.genericList', $this->getJSModel('condition')->getVehiclesCondition(JText::_('condition')), 'filter_av_conditionid', 'class="inputbox" ' . '', 'value', 'text', $searchconditionid);
        $lists['status'] = JHTML::_('select.genericList', $status, 'filter_av_statusid', 'class="inputbox" ' . '', 'value', 'text', $statusid);
        $query = "SELECT COUNT(id) FROM #__js_auto_vehicles AS vehicles WHERE vehicles.status <> 0";

        if ($searchtitle)
            $query .= " AND vehicles.title LIKE '%" . str_replace("'", "", $db->quote($searchtitle)) . "%'";
        if ($searchmakeid)
            if (is_numeric($searchmakeid))
                $query .= " AND vehicles.makeid = " . $searchmakeid;
        if ($searchmodelid)
            if (is_numeric($searchmodelid))
                $query .= " AND vehicles.modelid = " . $searchmodelid;
        if ($searchvehicletypeid)
            if (is_numeric($searchvehicletypeid))
                $query .=" AND vehicles.vehicletypeid = " . $searchvehicletypeid;
        if ($searchconditionid)
            if (is_numeric($searchconditionid))
                $query .=" AND vehicles.conditionid = " . $searchconditionid;
        if ($statusid)
            if (is_numeric($statusid))
                $query .=" AND vehicles.status = " . $statusid;
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;
        $query = "SELECT vehicles.issold AS soldvehicles,vehicles.price,vehicles.created,vehicles.uid AS uid,
                    vehicles.id,vehicles.title,vehicles.latitude,vehicles.longitude,vehicles.makeid AS makeid,vehicles.conditionid AS conditionid, vehicles.modelid AS modelid,vehicles.isgoldvehicle as gold,vehicles.isfeaturedvehicle as featured,
                    vehicles.exteriorcolor,vehicles.enginecapacity,vehicles.isdiscount,vehicles.discountstart,vehicles.discountend,vehicles.discounttype,vehicles.discount,vehicles.highwayfuelconsumption as highwayconsumption,vehicles.cityfuelconsumption as cityconsumption,
                    country.name AS countryname,state.name AS statename,city.name AS cityname,vehicles.addexpiryvalue,
                    vehicletypes.title AS vehicletitle,vehicles.mileages AS mileage,mileagetype.symbol as mileagetitle1,
                    makes.title AS maketitle,models.title AS modeltitle,modelyear.title AS modelyeartitle,vehicles.status,transmission.title AS transmissiontitle,
                    fueltype.title AS fueltitle,cylinder.title AS cylindertitle ,conditions.title AS conditiontitle, cat.title AS cattitle , image.filename AS vehiclelogo,currency.symbol AS currency,vehicles.enginecapacity,mileage.title as mileagetitle,mileage.symbol as mileagesymbol
                    FROM `#__js_auto_vehicles` AS vehicles
                    LEFT JOIN `#__js_auto_vehicleimages` AS image ON vehicles.id= image.vehicleid AND image.isdefault = 1
                    LEFT JOIN `#__js_auto_vehicletypes` AS vehicletypes ON vehicles.vehicletypeid = vehicletypes.id
                    LEFT JOIN `#__js_auto_makes` AS makes ON vehicles.makeid =makes.id
                    LEFT JOIN `#__js_auto_mileagetypes` AS mileagetype ON vehicles.mileagetypeid =mileagetype.id
                    LEFT JOIN `#__js_auto_transmissions` AS transmission ON vehicles.transmissionid =transmission.id
                    LEFT JOIN `#__js_auto_models` AS models ON vehicles.modelid =  models.id
                    LEFT JOIN `#__js_auto_categories` AS cat ON vehicles.categoryid =  cat.id
                    LEFT JOIN `#__js_auto_modelyears` AS modelyear ON vehicles.modelyearid = modelyear.id
                    LEFT JOIN `#__js_auto_conditions` AS conditions ON vehicles.conditionid = conditions.id
                    LEFT JOIN `#__js_auto_fueltypes` AS fueltype ON vehicles.fueltypeid = fueltype.id
                    LEFT JOIN `#__js_auto_cylinders` AS cylinder ON vehicles.cylinderid = cylinder.id
                    LEFT JOIN `#__js_auto_currency` AS currency ON vehicles.currencyid = currency.id
                    LEFT JOIN `#__js_auto_cities` AS city ON vehicles.loccity = city.id
                    LEFT JOIN `#__js_auto_countries` AS country ON city.countryid = country.id
                    LEFT JOIN `#__js_auto_states` AS state ON city.stateid = state.id
                    LEFT JOIN `#__js_auto_mileagetypes` AS mileage ON vehicles.speedmetertypeid = mileage.id
                    WHERE vehicles.status <> 0 ";
        if ($searchtitle)
            $query .= " AND vehicles.title LIKE '%" . str_replace("'", "", $db->quote($searchtitle)) . "%'";
        if ($searchmakeid)
            if (is_numeric($searchmakeid))
                $query .= " AND vehicles.makeid = " . $searchmakeid;
        if ($searchmodelid)
            if (is_numeric($searchmodelid))
                $query .= " AND vehicles.modelid = " . $searchmodelid;
        if ($searchvehicletypeid)
            if (is_numeric($searchvehicletypeid))
                $query .=" AND vehicles.vehicletypeid = " . $searchvehicletypeid;
        if ($searchconditionid)
            if (is_numeric($searchconditionid))
                $query .=" AND vehicles.conditionid = " . $searchconditionid;
        if ($statusid)
            if (is_numeric($statusid))
                $query .=" AND vehicles.status = " . $statusid;
        $query .=" ORDER BY vehicles.created DESC ";
        $db->setQuery($query, $limitstart, $limit);

        $vehicleresult = $db->loadObjectList();
        if(!empty($vehicleresult))
        foreach($vehicleresult AS $vehicle){
            $vehicle->vehicleimages = $this->getJSModel('vehicleimage')->getVehicleImagebyId($vehicle->id);
            
        }
        
        $result[0] = $vehicleresult;
        $result[1] = $total;
        $result[2] = $lists;
        return $result;
    }

    function getAllUnapprovedVehicle($searchtitle, $searchmakeid, $searchmodelid, $searchvehicletypeid, $searchconditionid, $limitstart, $limit) { //get all unapproved vehicle
        $db = $this->getDBO();
        $result = array();
        $lists['title'] = $searchtitle;
        $lists['makes'] = JHTML::_('select.genericList', $this->getJSModel('make')->getVehiclesMakes(JText::_('Make')), 'filter_av_makeid', 'class="inputbox" ' . 'onChange="getvfsmodels(this.value)"', 'value', 'text', $searchmakeid);
        $lists['models'] = JHTML::_('select.genericList', $this->getJSModel('model')->getVehiclesModelsbyMakeId(1, JText::_('Model')), 'filter_av_modelid', 'class="inputbox" ' . 'onchange="this.form.submit();"', 'value', 'text', $searchmodelid);
        $lists['vehicletypes'] = JHTML::_('select.genericList', $this->getJSModel('vehicletype')->getVehiclesType(JText::_('Types')), 'filter_av_vehicletypeid', 'class="inputbox" ' . 'onchange="this.form.submit();"', 'value', 'text', $searchvehicletypeid);
        $lists['conditions'] = JHTML::_('select.genericList', $this->getJSModel('condition')->getVehiclesCondition($title = ""), 'filter_av_conditionid', 'class="inputbox" ' . 'onchange="this.form.submit();"', 'value', 'text', $searchconditionid);
        $query = "SELECT COUNT(id) FROM #__js_auto_vehicles AS vehicles WHERE vehicles.status = 0";
        if ($searchtitle)
            $query .= " AND vehicles.title LIKE '%" . str_replace("'", "", $db->quote($searchtitle)) . "%'";
        if ($searchmakeid)
            if (is_numeric($searchmakeid))
                $query .= " AND vehicles.makeid = " . $searchmakeid;
        if ($searchmodelid)
            if (is_numeric($searchmodelid))
                $query .= " AND vehicles.modelid = " . $searchmodelid;
        if ($searchvehicletypeid)
            if (is_numeric($searchvehicletypeid))
                $query .=" AND vehicles.vehicletypeid = " . $searchvehicletypeid;
        if ($searchconditionid)
            if (is_numeric($searchconditionid))
                $query .=" AND vehicles.conditionid = " . $searchconditionid;
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;
        $query = "SELECT vehicles.issold AS soldvehicles,vehicles.price,vehicles.created,vehicles.uid AS uid,
                    vehicles.id,vehicles.title,vehicles.latitude,vehicles.longitude,vehicles.makeid AS makeid,vehicles.conditionid AS conditionid, vehicles.modelid AS modelid,vehicles.isgoldvehicle as gold,vehicles.isfeaturedvehicle as featured,
                    vehicles.exteriorcolor,vehicles.enginecapacity,vehicles.isdiscount,vehicles.discountstart,vehicles.discountend,vehicles.discounttype,vehicles.discount,vehicles.highwayfuelconsumption as highwayconsumption,vehicles.cityfuelconsumption as cityconsumption,
                    country.name AS countryname,state.name AS statename,city.name AS cityname,vehicles.addexpiryvalue,
                    vehicletypes.title AS vehicletitle,vehicles.mileages AS mileage,mileagetype.symbol as mileagetitle1,
                    makes.title AS maketitle,models.title AS modeltitle,modelyear.title AS modelyeartitle, transmission.title AS transmissiontitle,
                    fueltype.title AS fueltitle,cylinder.title AS cylindertitle ,
                    conditions.title AS conditiontitle, cat.title AS cattitle , image.filename AS vehiclelogo,currency.symbol AS currency,vehicles.enginecapacity,mileage.title as mileagetitle,mileage.symbol as mileagesymbol
                    FROM `#__js_auto_vehicles` AS vehicles
                    LEFT JOIN `#__js_auto_vehicleimages` AS image ON vehicles.id= image.vehicleid AND image.isdefault = 1
                    LEFT JOIN `#__js_auto_vehicletypes` AS vehicletypes ON vehicles.vehicletypeid = vehicletypes.id
                    LEFT JOIN `#__js_auto_makes` AS makes ON vehicles.makeid =makes.id
                    LEFT JOIN `#__js_auto_mileagetypes` AS mileagetype ON vehicles.mileagetypeid =mileagetype.id
                    LEFT JOIN `#__js_auto_transmissions` AS transmission ON vehicles.transmissionid =transmission.id
                    LEFT JOIN `#__js_auto_models` AS models ON vehicles.modelid =  models.id
                    LEFT JOIN `#__js_auto_categories` AS cat ON vehicles.categoryid =  cat.id
                    LEFT JOIN `#__js_auto_modelyears` AS modelyear ON vehicles.modelyearid = modelyear.id
                    LEFT JOIN `#__js_auto_conditions` AS conditions ON vehicles.conditionid = conditions.id
                    LEFT JOIN `#__js_auto_fueltypes` AS fueltype ON vehicles.fueltypeid = fueltype.id
                    LEFT JOIN `#__js_auto_cylinders` AS cylinder ON vehicles.cylinderid = cylinder.id
                    LEFT JOIN `#__js_auto_currency` AS currency ON vehicles.currencyid = currency.id
                    LEFT JOIN `#__js_auto_cities` AS city ON vehicles.loccity = city.id
                    LEFT JOIN `#__js_auto_countries` AS country ON city.countryid = country.id
                    LEFT JOIN `#__js_auto_states` AS state ON city.stateid = state.id
                    LEFT JOIN `#__js_auto_mileagetypes` AS mileage ON vehicles.mileagetypeid = mileage.id
                    WHERE vehicles.status = 0 ";
        if ($searchtitle)
            $query .= " AND vehicles.title LIKE '%" . str_replace("'", "", $db->quote($searchtitle)) . "%'";
        if ($searchmakeid)
            if (is_numeric($searchmakeid))
                $query .= " AND vehicles.makeid = " . $searchmakeid;
        if ($searchmodelid)
            if (is_numeric($searchmodelid))
                $query .= " AND vehicles.modelid = " . $searchmodelid;
        if ($searchvehicletypeid)
            if (is_numeric($searchvehicletypeid))
                $query .=" AND vehicles.vehicletypeid = " . $searchvehicletypeid;
        if ($searchconditionid)
            if (is_numeric($searchconditionid))
                $query .=" AND vehicles.conditionid = " . $searchconditionid;

        $db->setQuery($query, $limitstart, $limit);
        $vehicleresult = $db->loadObjectList();
        if(!empty($vehicleresult))
        foreach($vehicleresult AS $vehicle){
            $vehicle->vehicleimages = $this->getJSModel('vehicleimage')->getVehicleImagebyId($vehicle->id);
            
        }
        $result[0] = $vehicleresult;
        $result[1] = $total;
        $result[2] = $lists;
        return $result;
    }

    function getVehiclebyId($id) {          //get vehicle by id
        $db = $this->getDBO();
        if (is_numeric($id) == false)
            return false;
        $query = "SELECT vehicles.*,vehicletypes.title AS vehicletitle,
                    makes.title maketitle,models.title AS modeltitle,modelyear.title AS modelyeartitle,
                    fueltype.title AS fueltitle,cylinder.title AS cylindertitle, conditions.title AS conditiontitle,
                    categories.title AS cattitle,  transmissions.title AS transtitle, adexpiries.title AS adexptitle,
                    mileagetypes.title AS mileagetitle
                    FROM `#__js_auto_vehicles` AS vehicles
                    LEFT JOIN `#__js_auto_vehicletypes` AS vehicletypes ON vehicles.vehicletypeid = vehicletypes.id
                    LEFT JOIN `#__js_auto_makes` AS makes ON vehicles.makeid =makes.id
                    LEFT JOIN `#__js_auto_models` AS models ON vehicles.modelid =  models.id
                    LEFT JOIN `#__js_auto_categories` AS categories ON vehicles.categoryid = categories.id
                    LEFT JOIN `#__js_auto_modelyears` AS modelyear ON vehicles.modelyearid = modelyear.id
                    LEFT JOIN `#__js_auto_conditions` AS conditions ON vehicles.conditionid = conditions.id
                    LEFT JOIN `#__js_auto_fueltypes` AS fueltype ON vehicles.fueltypeid = fueltype.id
                    LEFT JOIN `#__js_auto_cylinders` AS cylinder ON vehicles.cylinderid = cylinder.id
                    LEFT JOIN `#__js_auto_transmissions` AS transmissions ON vehicles.transmissionid = transmissions.id
                    LEFT JOIN `#__js_auto_adexpiries` AS adexpiries ON vehicles.adexpiryid = adexpiries.id
                    LEFT JOIN `#__js_auto_mileagetypes` AS mileagetypes ON vehicles.mileagetypeid = mileagetypes.id
                    WHERE  vehicles.id = " . $id;

        $db->setQuery($query);
        $vehicle = $db->loadObject();
        $query = "SELECT vehicleoptions.*
                    FROM `#__js_auto_vehicleoptions` AS vehicleoptions
                    WHERE  vehicleoptions.vehicleid = " . $id;

        $db->setQuery($query);
        $vehicleoptions = $db->loadObject();
        $result[0] = $vehicle;
        $result[1] = $vehicleoptions;
        $result[2] = $this->getJSModel('fieldordering')->getFieldsOrdering(1); // vehicle fields
        $result[4] = $this->getJSModel('fieldordering')->getFieldsOrdering(2);
        return $result;
    }

    function storeVehicle() {              // check it store vehicle
        $row = $this->getTable('vehicles');
        $db = $this->getDBO();
        $data = JRequest::get('post');

        //for alias apply rule
        if (!empty($data['alias']))
            $vehiclealias = $data['alias'];
        else
            $vehiclealias = $this->getJSModel('make')->getVehicleMakeTitle($data['makeid']).'-'.$this->getJSModel('model')->getVehicleModelTitle($data['modelid']);

        $vehiclealias = strtolower(str_replace(' ', '-', $vehiclealias));
        $data['alias'] = $vehiclealias;
        $adexpid = $data['adexpiryid'];
        $created = $data['created'];
        $date = $created;
        if (!is_numeric($adexpid))
            return false;
        $query = "SELECT adexp.title AS advalue,adexp.type AS adtype
        FROM `#__js_auto_adexpiries` AS adexp
        WHERE adexp.id=" . $adexpid;
        $db->setQuery($query);
        $adexp = $db->loadObject();
        switch ($adexp->adtype) {
            case 1: $adexp->adtype = 'year';
                break;
            case 2: $adexp->adtype = 'month';
                break;
            case 3: $adexp->adtype = 'week';
                break;
            case 4: $adexp->adtype = 'day';
                break;
        }
        $date = strtotime(date("Y-m-d", strtotime($date)) . " +$adexp->advalue $adexp->adtype");
        $row->addexpiryvalue = date("Y-m-d", $date);
        $result = array();
        $configs = $this->getJSModel('configuration')->getConfiginArray('default');
        $data['description'] = JRequest::getVar('description', '', 'post', 'string', JREQUEST_ALLOWRAW);
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        $this->getJSModel('customfield')->storeUserFieldData($data, $row->id);
        $this->getJSModel('vehicleoption')->storeVehicleOptions($row->id);
        $this->getJSModel('vehiclecontact')->storeSellerContactInfo($data, $row->id, $row->uid);
        $result[0] = true;
        $result[1] = $row->id;
        return $result;
    }

    function storeVehicleCopy() {
        $row = $this->getTable('vehicles');
        $db = $this->getDBO();
        $data = JRequest::get('post');
        $data['id'] = 0;
        $adexpid = $data['adexpiryid'];
        $curdate = date("Y-m-d H:i:s");
        $data['created'] = $curdate;
        $created = $curdate;
        $date = $created;
        if (!is_numeric($adexpid))
            return false;
        $query = "SELECT adexp.title AS advalue,adexp.type AS adtype
                    FROM `#__js_auto_adexpiries` AS adexp
                    WHERE adexp.id=" . $adexpid;
        $db->setQuery($query);
        $adexp = $db->loadObject();
        $date = strtotime(date("Y-m-d", strtotime($date)) . " +$adexp->advalue $adexp->adtype");
        $row->addexpiryvalue = date("Y-m-d", $date);
        $result = array();
        $configs = $this->getJSModel('configuration')->getConfiginArray('default');
        $data['description'] = JRequest::getVar('description', '', 'post', 'string', JREQUEST_ALLOWRAW);
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        $this->getJSModel('customfield')->storeUserFieldData($data, $row->id);
        $this->getJSModel('vehicleoption')->storeVehicleOptionsCopy($row->id);
        $result[0] = true;
        $result[1] = $row->id;
        return $result;
    }

    function changeStatusVehicleApprove($id, $status) {           //cgange status vehicle
        if (is_numeric($id) == false)
            return false;
        if (is_numeric($status) == false)
            return false;
        $emailconfigs = $this->getJSModel('configuration')->getConfiginArray('email');
        $row = $this->getTable('vehicles');
        $row->id = $id;
        $row->status = $status;
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        if ($emailconfigs['seller_vehicle_approve'] == 1) {
            $this->getJSModel('email')->sendMailToSeller($id, 1);
        }
        return true;
    }

    function changeStatusVehicleReject($id, $status) {           //cgange status vehicle
        if (is_numeric($id) == false)
            return false;
        if (is_numeric($status) == false)
            return false;
        $emailconfigs = $this->getJSModel('configuration')->getConfiginArray('email');
        $row = $this->getTable('vehicles');
        $row->id = $id;
        $row->status = $status;
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        if ($emailconfigs['seller_vehicle_rejected'] == 1) {
            $this->getJSModel('email')->sendMailToSeller($id, 2);
        }
        return true;
    }

    function getVehicletitle($vehicleid) {
        $db = $this->getDBO();
        if (is_numeric($vehicleid) == false)
            return false;
        $query = "SELECT vehicle.title
                    FROM `#__js_auto_vehicles` AS vehicle
                    WHERE vehicle.id=" . $vehicleid;

        $db->setQuery($query);
        $result = $db->loadResult();
        return $result;
    }

    function deleteVehicle() {
        $cids = JRequest::getVar('cid');
        $cid = $cids[0];
        $db = $this->getDBO();
        if (!is_numeric($cid))
            return false;

        if ($this->vehicleCanDelete($cid) == true) {
            $query = " Delete vehicles,vehoption,vehimage,sellercontactinfo
                        FROM `#__js_auto_vehicles` AS vehicles
                        LEFT JOIN `#__js_auto_vehicleoptions` AS vehoption ON vehicles.id= vehoption.vehicleid
                        LEFT JOIN `#__js_auto_vehicleimages` AS vehimage ON vehicles.id= vehimage.vehicleid
                        LEFT JOIN `#__js_auto_seller_contact_info` AS sellercontactinfo ON vehicles.id= sellercontactinfo.vehicleid
                        WHERE vehicles.id = " . $cid;
            $db->setQuery($query);
            $db->query();
            return true;
        } else {
            return FALSE;
        }
    }

    function enforcedeletevehicle() {
        $cids = JRequest::getVar('cid', array(0), 'post', 'array');
        $cid = $cids[0];
        if(!$cid) $cid = JRequest::getVar('cid', '');
        $db = $this->getDBO();
        if (!is_numeric($cid))
            return false;
        $query = " Delete vehicles,vehoption,vehimage,sellercontactinfo
                    FROM `#__js_auto_vehicles` AS vehicles
                    LEFT JOIN `#__js_auto_vehicleoptions` AS vehoption ON vehicles.id= vehoption.vehicleid
                    LEFT JOIN `#__js_auto_vehicleimages` AS vehimage ON vehicles.id= vehimage.vehicleid
                    LEFT JOIN `#__js_auto_seller_contact_info` AS sellercontactinfo ON vehicles.id= sellercontactinfo.vehicleid
                    WHERE vehicles.id = " . $cid;
        $db->setQuery($query);
        $db->query();
        return true;
    }

    function vehicleCanDelete($id) {                       // dellerCanDelete
        if (is_numeric($id) == false)        return false;
            return true;
    }

    function getVehicleforForm($id) {         //getVehicleforForm
        $db = $this->getDBO();
        $yesno = array(
            '0' => array('value' => '', 'text' => JText::_('Mark Sold Unsold')),
            '1' => array('value' => 1, 'text' => JText::_('Sold')),
            '2' => array('value' => 0, 'text' => JText::_('Not Sold')),);
        if ($id) {
            if (is_numeric($id) == false)
                return false;
            $query = "SELECT vehicle.* FROM `#__js_auto_vehicles` AS vehicle WHERE vehicle.id = " . $id;
            $db->setQuery($query);
            $vehicle = $db->loadObject();
            $query = "SELECT vehicleoptions.* FROM `#__js_auto_vehicleoptions` AS vehicleoptions WHERE vehicleoptions.vehicleid =" . $id;
            $db->setQuery($query);
            $vehicleoptions = $db->loadObject();
        }
        $title = "";
        $vehicletypeid_req = '';
        $makeid_req = '';
        $modelid_req = '';
        $modelyearid_req = '';
        $conditionid_req = '';
        $fueltypeid_req = '';
        $cylinderid_req = '';
        $transmissionid_req = '';
        $adexpiryid_req = '';
        $mileagetypeid_req = '';
        $categoryid_req = '';

        $fieldorderings = $this->getJSModel('fieldordering')->getFieldsOrdering(1);
        $fieldorderings_options = $this->getJSModel('fieldordering')->getFieldsOrdering(2);
        foreach ($fieldorderings AS $field) {
            switch ($field->field) {
                case "vehicletypeid":
                    if ($field->required == 1)
                        $vehicletypeid_req = ' required';
                    break;
                case "makeid":
                    if ($field->required == 1)
                        $makeid_req = ' required';
                    break;
                case "modelid":
                    if ($field->required == 1) {
                        $modelid_req = ' required';
                        $model_required = 1;
                    }
                    break;
                case "modelyearid":
                    if ($field->required == 1)
                        $modelyearid_req = ' required';
                    break;
                case "conditionid":
                    if ($field->required == 1)
                        $conditionid_req = ' required';
                    break;
                case "fueltypeid":
                    if ($field->required == 1)
                        $fueltypeid_req = ' required';
                    break;
                case "cylinderid":
                    if ($field->required == 1)
                        $cylinderid_req = ' required';
                    break;
                case "transmissionid":
                    if ($field->required == 1)
                        $transmissionid_req = ' required';
                    break;
                case "adexpiryid":
                    if ($field->required == 1)
                        $adexpiryid_req = ' required';
                    break;
                case "mileagetypeid":
                    if ($field->required == 1)
                        $mileagetypeid_req = ' required';
                    break;
                case "categoryid":
                    if ($field->required == 1)
                        $categoryid_req = ' required';
                    break;
            }
        }
        $discounttypearray = array(array('value' => '1', 'text' => JText::_('Amount')), array('value' => '2', 'text' => JText::_('Percentage')));
        if (isset($vehicle)) {
            $lists['vehicletypes'] = JHTML::_('select.genericList', $this->getJSModel('vehicletype')->getVehiclesType($title), 'vehicletypeid', 'class="inputbox' . $vehicletypeid_req . '" ' . '', 'value', 'text', $vehicle->vehicletypeid);
            $lists['makes'] = JHTML::_('select.genericList', $this->getJSModel('make')->getVehiclesMakes($title), 'makeid', 'class="inputbox' . $makeid_req . '" ' . 'onChange="getvfmodels(this.value,' . $model_required . ')"', 'value', 'text', $vehicle->makeid);
            $lists['models'] = JHTML::_('select.genericList', $this->getJSModel('model')->getVehiclesModelsbyMakeId($vehicle->makeid, $title), 'modelid', 'class="inputbox' . $modelid_req . '" ' . '', 'value', 'text', $vehicle->modelid);
            $lists['categories'] = JHTML::_('select.genericList', $this->getJSModel('vehiclecategory')->getVehiclesCategory($title), 'categoryid', 'class="inputbox ' . $categoryid_req . '" ' . '', 'value', 'text', $vehicle->categoryid);
            $lists['modelyears'] = JHTML::_('select.genericList', $this->getJSModel('modelyear')->getVehiclesModelYear($title), 'modelyearid', 'class="inputbox' . $modelyearid_req . '" ' . '', 'value', 'text', $vehicle->modelyearid);
            $lists['conditions'] = JHTML::_('select.genericList', $this->getJSModel('condition')->getVehiclesCondition($title), 'conditionid', 'class="inputbox' . $conditionid_req . '" ' . '', 'value', 'text', $vehicle->conditionid);
            $lists['fueltypes'] = JHTML::_('select.genericList', $this->getJSModel('fueltype')->getVehiclesFuelType($title), 'fueltypeid', 'class="inputbox' . $fueltypeid_req . '" ' . '', 'value', 'text', $vehicle->fueltypeid);
            $lists['currency'] = JHTML::_('select.genericList', $this->getJSModel('currency')->getCurrency($title), 'currencyid', 'class="inputbox' . $fueltypeid_req . '" ' . 'onChange="setPriceCurrencyLabel();"', 'value', 'text', $vehicle->currencyid);
            $lists['cylinders'] = JHTML::_('select.genericList', $this->getJSModel('cylinder')->getVehiclesCylinders($title), 'cylinderid', 'class="inputbox' . $cylinderid_req . '" ' . '', 'value', 'text', $vehicle->cylinderid);
            $lists['transmissions'] = JHTML::_('select.genericList', $this->getJSModel('transmission')->getVehiclesTransmission($title), 'transmissionid', 'class="inputbox' . $transmissionid_req . '" ' . '', 'value', 'text', $vehicle->transmissionid);
            $lists['adexpiries'] = JHTML::_('select.genericList', $this->getJSModel('addexpiry')->getVehiclesAdexpirie($title), 'adexpiryid', 'class="inputbox' . $adexpiryid_req . '" ' . '', 'value', 'text', $vehicle->adexpiryid);

            $lists['mileagetypes'] = JHTML::_('select.genericList', $this->getJSModel('mileage')->getMileagesType($title), 'mileagetypeid', 'class="inputbox' . $mileagetypeid_req . '" ' . '', 'value', 'text', $vehicle->mileagetypeid);
            $lists['discounttype'] = JHTML::_('select.genericList', $discounttypearray, 'discounttype', 'class="inputbox' . $fueltypeid_req . '" ' . '', 'value', 'text', $vehicle->discounttype);
            $lists['speedmetertypeid'] = JHTML::_('select.genericList', $this->getJSModel('mileage')->getMileagesType($title), 'speedmetertypeid', 'class="inputbox' . $fueltypeid_req . '" ' . 'onChange="setSpeedoMeterLabel();"', 'value', 'text', $vehicle->speedmetertypeid);
            $lists['status'] = JHTML::_('select.genericList', $this->getJSModel('common')->getStatusforCombo($title), 'status', 'class="inputbox required" ' . '', 'value', 'text', $vehicle->status);
            ($vehicle->loccity) ? $vehicleloccity = $vehicle->loccity : $vehicleloccity = -1;
            ($vehicle->regcity) ? $vehicleregcity = $vehicle->regcity : $vehicleregcity = -1;
            $lists['loccityname'] = $this->getJSModel('city')->getAddressDataByCityName('', $vehicleloccity);
            $lists['regcityname'] = $this->getJSModel('city')->getAddressDataByCityName('', $vehicleregcity);
        } else {
            $vehicledefaultvalue = $this->getVehiclesDefaultValues();
            $this->_dfueltype = $vehicledefaultvalue->fueltypeid;
            $this->_dcylinder = $vehicledefaultvalue->cylinderid;
            $this->_dadexpiry = $vehicledefaultvalue->adexpiryid;
            $this->_dcurrency = $vehicledefaultvalue->currencyid;

            $this->_dvehicletype = $vehicledefaultvalue->vehicletypeid;
            $this->_dmileage = $vehicledefaultvalue->mileageid;
            $this->_dmodelyear = $vehicledefaultvalue->modelyearid;
            $this->_dtransmission = $vehicledefaultvalue->transmissionid;

            $configs = $this->getJSModel('configuration')->getConfiginArray('default');
            $vehiclemakes = $this->getJSModel('make')->getVehiclesMakes($title);
            $lists['vehicletypes'] = JHTML::_('select.genericList', $this->getJSModel('vehicletype')->getVehiclesType($title), 'vehicletypeid', 'class="inputbox' . $vehicletypeid_req . '" ' . '', 'value', 'text', $this->_dvehicletype);
            $lists['makes'] = JHTML::_('select.genericList', $vehiclemakes, 'makeid', 'class="inputbox required" ' . 'onChange="getvfmodels(this.value,' . $model_required . ')"', 'value', 'text', '');
            $lists['models'] = JHTML::_('select.genericList', $this->getJSModel('model')->getVehiclesModelsbyMakeId($vehiclemakes[0]['value'], $title), 'modelid', 'class="inputbox' . $modelid_req . '" ' . '', 'value', 'text', '');
            $lists['categories'] = JHTML::_('select.genericList', $this->getJSModel('vehiclecategory')->getVehiclesCategory($title), 'categoryid', 'class="inputbox' . $categoryid_req . ' " ' . '', 'value', 'text', '');
            $lists['modelyears'] = JHTML::_('select.genericList', $this->getJSModel('modelyear')->getVehiclesModelYear($title), 'modelyearid', 'class="inputbox' . $modelyearid_req . '" ' . '', 'value', 'text', $this->_dmodelyear);
            $lists['conditions'] = JHTML::_('select.genericList', $this->getJSModel('condition')->getVehiclesCondition($title), 'conditionid', 'class="inputbox' . $conditionid_req . '" ' . '', 'value', 'text', '');
            $lists['fueltypes'] = JHTML::_('select.genericList', $this->getJSModel('fueltype')->getVehiclesFuelType($title), 'fueltypeid', 'class="inputbox' . $fueltypeid_req . '" ' . '', 'value', 'text', $this->_dfueltype);
            $lists['cylinders'] = JHTML::_('select.genericList', $this->getJSModel('cylinder')->getVehiclesCylinders($title), 'cylinderid', 'class="inputbox' . $cylinderid_req . '" ' . '', 'value', 'text', $this->_dcylinder);
            $lists['currency'] = JHTML::_('select.genericList', $this->getJSModel('currency')->getCurrency($title), 'currencyid', 'class="inputbox' . $fueltypeid_req . '" ' . 'onChange="setPriceCurrencyLabel();"', 'value', 'text', $this->_dcurrency);
            $lists['transmissions'] = JHTML::_('select.genericList', $this->getJSModel('transmission')->getVehiclesTransmission($title), 'transmissionid', 'class="inputbox' . $transmissionid_req . '" ' . '', 'value', 'text', $this->_dtransmission);
            $lists['adexpiries'] = JHTML::_('select.genericList', $this->getJSModel('addexpiry')->getVehiclesAdexpirie($title), 'adexpiryid', 'class="inputbox' . $adexpiryid_req . '" ' . '', 'value', 'text', $this->_dadexpiry);

            $lists['mileagetypes'] = JHTML::_('select.genericList', $this->getJSModel('mileage')->getMileagesType($title), 'mileagetypeid', 'class="inputbox' . $mileagetypeid_req . '" ' . '', 'value', 'text', $this->_dmileage);
            $lists['discounttype'] = JHTML::_('select.genericList', $discounttypearray, 'discounttype', 'class="inputbox' . $fueltypeid_req . '" ' . '', 'value', 'text', '');
            $lists['speedmetertypeid'] = JHTML::_('select.genericList', $this->getJSModel('mileage')->getMileagesType($title), 'speedmetertypeid', 'class="inputbox' . $fueltypeid_req . '" ' . 'onChange="setSpeedoMeterLabel();"', 'value', 'text', '');

            $lists['status'] = JHTML::_('select.genericList', $this->getJSModel('common')->getStatusforCombo($title), 'status', 'class="inputbox required" ' . '', 'value', 'text', '1');
        }
        if (isset($vehicle))
            $result[0] = $vehicle;
        if (isset($vehicleoptions))
            $result[1] = $vehicleoptions;
        $result[2] = $lists;
        $result[3] = $fieldorderings;
        $result[4] = $fieldorderings_options;
        $result[5] = $this->getJSModel('customfield')->getUserFieldsForForm(1, $id,1); // job fields , ref id
        return $result;
    }

    function getVehiclesDefaultValues() {
        $db = $this->getDBO();
        $query = "SELECT fueltype.id AS fueltypeid,cylinder.id AS cylinderid,currency.id AS currencyid,
                    adexp.id AS adexpiryid,vehtype.id AS vehicletypeid,mileagetype.id AS mileageid,modelyear.id AS modelyearid,trans.id AS transmissionid
                    FROM `#__js_auto_fueltypes` AS fueltype,`#__js_auto_cylinders` AS cylinder,
                    `#__js_auto_adexpiries` AS adexp,`#__js_auto_currency` AS currency,
                    `#__js_auto_vehicletypes` AS vehtype,`#__js_auto_mileagetypes` AS mileagetype,
                    `#__js_auto_modelyears` AS modelyear,`#__js_auto_transmissions` AS trans
                    WHERE  fueltype.isdefault = 1 AND cylinder.isdefault = 1 AND adexp.isdefault = 1 AND currency.isdefault = 1
                    AND vehtype.isdefault = 1 AND mileagetype.isdefault = 1 AND modelyear.isdefault = 1 AND trans.isdefault = 1";
        $db->setQuery($query);
        $defaultvalues = $db->loadObject();
        return $defaultvalues;
    }

        function getVehicleDetails($vehicleid){
        if ((is_numeric($vehicleid) == false) || ($vehicleid == 0) || ($vehicleid == ''))
            return false;   
        $db = $this->getDBO();
        $query = "SELECT vehicles.issold AS soldvehicles,vehicles.price,vehicles.created,vehicles.uid AS uid,
                    vehicles.id,vehicles.title,vehicles.latitude,vehicles.longitude,vehicles.makeid AS makeid,vehicles.conditionid AS conditionid, vehicles.modelid AS modelid,vehicles.isgoldvehicle as gold,vehicles.isfeaturedvehicle as featured,
                    vehicles.exteriorcolor,vehicles.enginecapacity,vehicles.isdiscount,vehicles.discountstart,vehicles.discountend,vehicles.discounttype,vehicles.discount,vehicles.highwayfuelconsumption as highwayconsumption,vehicles.cityfuelconsumption as cityconsumption,
                    country.name AS countryname,state.name AS statename,city.name AS cityname,vehicles.addexpiryvalue,
                    vehicletypes.title AS vehicletitle,vehicles.mileages AS mileage,mileagetype.symbol as mileagetitle1,
                    makes.title AS maketitle,models.title AS modeltitle,modelyear.title AS modelyeartitle,vehicles.status,
                    fueltype.title AS fueltitle,cylinder.title AS cylindertitle ,transmission.title AS transmissiontitle,
                    conditions.title AS conditiontitle, cat.title AS cattitle , image.filename AS vehiclelogo,currency.symbol AS currency,vehicles.enginecapacity,mileage.title as mileagetitle
                    FROM `#__js_auto_vehicles` AS vehicles
                    LEFT JOIN `#__js_auto_vehicleimages` AS image ON vehicles.id= image.vehicleid AND image.isdefault = 1
                    LEFT JOIN `#__js_auto_vehicletypes` AS vehicletypes ON vehicles.vehicletypeid = vehicletypes.id
                    LEFT JOIN `#__js_auto_makes` AS makes ON vehicles.makeid =makes.id
                    LEFT JOIN `#__js_auto_mileagetypes` AS mileagetype ON vehicles.mileagetypeid =mileagetype.id
                    LEFT JOIN `#__js_auto_transmissions` AS transmission ON vehicles.transmissionid =transmission.id
                    LEFT JOIN `#__js_auto_models` AS models ON vehicles.modelid =  models.id
                    LEFT JOIN `#__js_auto_categories` AS cat ON vehicles.categoryid =  cat.id
                    LEFT JOIN `#__js_auto_modelyears` AS modelyear ON vehicles.modelyearid = modelyear.id
                    LEFT JOIN `#__js_auto_conditions` AS conditions ON vehicles.conditionid = conditions.id
                    LEFT JOIN `#__js_auto_fueltypes` AS fueltype ON vehicles.fueltypeid = fueltype.id
                    LEFT JOIN `#__js_auto_cylinders` AS cylinder ON vehicles.cylinderid = cylinder.id
                    LEFT JOIN `#__js_auto_currency` AS currency ON vehicles.currencyid = currency.id
                    LEFT JOIN `#__js_auto_cities` AS city ON vehicles.loccity = city.id
                    LEFT JOIN `#__js_auto_countries` AS country ON city.countryid = country.id
                    LEFT JOIN `#__js_auto_states` AS state ON city.stateid = state.id
                    LEFT JOIN `#__js_auto_mileagetypes` AS mileage ON vehicles.mileagetypeid = mileage.id
                    WHERE vehicles.id = ".$vehicleid;
        $db->setQuery($query);
        $vehicles = $db->loadObject();
        if(!empty($vehicles))
        $vehicles->vehicleimages = $this->getJSModel('vehicleimage')->getVehicleImagebyId($vehicles->id);
        
       return $vehicles;
    }

}

?>
