<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:     www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest::getVar('option', 'com_jsautoz');

class JSAutozModelVehiclecategory extends JSAutozModel {

    var $_countries = null;

    function __construct() {
        parent::__construct();
    }

    function getVehiclesCategory($title) {            //get vehicles category
        $db = JFactory::getDBO();
        $query = "SELECT  id, title FROM `#__js_auto_categories` WHERE status = 1 ORDER BY title ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $categories = array();
        if ($title)
            $categories[] = array('value' => JText::_(''), 'text' => $title);
        foreach ($rows as $row) {
            $categories[] = array('value' => $row->id, 'text' => JText::_($row->title));
        }
        return $categories;
    }

    function storeVehicleCategory() {              //storeVehicleCategory
        $row = $this->getTable('category');
        $result = array();
        $data = JRequest::get('post');
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if ($data['id'] == '') { // only for new
            $result1 = $this->isVehicleCategoryExist($data['title']);
            if ($result1 == 1) {
                $result[0] = 3;
                return $result;
            }
        }
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        $result[0] = true;
        $result[1] = $row->id;
        return $result;
    }

    function deleteVehicleCategory() {              //deleteVehicleCategory
        $cids = JRequest::getVar('cid', array(0), 'post', 'array');
        $row = $this->getTable('category');
        $deleteall = 1;
        foreach ($cids as $cid) {
            if ($this->vehicleCategoryCanDelete($cid) == true) {
                if (!$row->delete($cid)) {
                    $this->setError($row->getErrorMsg());
                    return false;
                }
            } else
                $deleteall++;
        }
        return $deleteall;
    }

    function vehicleCategoryCanDelete($id) {           //vehicleCategoryCanDelete
        if (is_numeric($id) == false)
            return false;
        $db = $this->getDBO();

        $query = " SELECT COUNT(id) FROM `#__js_auto_categories` WHERE id = " . $id;
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total > 0)
            return true;
        else
            return false;
    }

    function getVehicleCategoryforForm($id) {              //getVehicleCategoryforForm
        $db = $this->getDBO();
        $category = null;
        if ($id) {
            if (is_numeric($id) == false)
                return false;
            $query = "SELECT vehiclecat.*
            FROM `#__js_auto_categories` AS vehiclecat
            WHERE vehiclecat.id = " . $id;
            $db->setQuery($query);
            $category = $db->loadObject();
        }
        return $category;
    }

    function changeStatusVehicleCategory($id, $status) {          //changeStatusVehicleCategory
        if (is_numeric($id) == false)
            return false;
        if (is_numeric($status) == false)
            return false;
        $canpublishunpublish = $this->getJSModel('common')->canPublishUnpublishWithOutDefault($id, 'categories');
        if ($canpublishunpublish) {
            $row = $this->getTable('category');
            $row->id = $id;
            $row->status = $status;
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                $returnvalue = 0;
            } else
                $returnvalue = 1;
        } else
            $returnvalue = 3;

        return $returnvalue;
    }

    function isVehicleCategoryExist($title) {          //isVehicleCategoryExist
        $db = JFactory::getDBO();
        $query = "SELECT COUNT(id) FROM #__js_auto_categories WHERE title = " . $db->Quote($title);
        $db->setQuery($query);
        $result = $db->loadResult();
        if ($result == 0)
            return 0;
        else
            return 1;
    }

    function getAllCategories($limitstart, $limit) {        //get all categories
        $db = JFactory::getDBO();
        $result = array();
        $query = "SELECT COUNT(id) FROM #__js_auto_categories";
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;
        $query = "SELECT * FROM #__js_auto_categories ORDER BY id ASC";

        $db->setQuery($query, $limitstart, $limit);
        $result[0] = $db->loadObjectList();
        $result[1] = $total;
        return $result;
    }

}

?>