<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:     www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest::getVar('option', 'com_jsautoz');

class JSAutozModelVehiclesearch extends JSAutozModel {

    var $_countries = null;

    function __construct() {
        parent::__construct();
    }

    function getSearchOptions() {                     //get search option
        $db = $this->getDBO();
        $zip = $this->getJSModel('zip')->getZipCodes('', '');
        $radiussearch = array(
            '0' => array('value' => '', 'text' => JText::_('Select Radius Limit')),
            '1' => array('value' => 10, 'text' => JText::_('With In Ten Km')),
            '2' => array('value' => 20, 'text' => JText::_('With In Twenty Km')),
            '3' => array('value' => 25, 'text' => JText::_('With In Twenty Five Km')),);

        $fieldorderings = $this->getJSModel('fieldordering')->getFieldsOrdering(1);
        $makes = $this->getJSModel('make')->getVehiclesMakes(JText::_('All'));
        $models = array();
        $lists['vehicletypes'] = JHTML::_('select.genericList', $this->getJSModel('vehicletype')->getVehiclesType(JText::_('All')), 'vehicletypeid', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['makes'] = JHTML::_('select.genericList', $makes, 'makeid', 'class="inputbox " ' . 'onChange="getvfsmodels(this.value)"', 'value', 'text', '');
        $lists['models'] = JHTML::_('select.genericList', $models, 'modelid', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['modelyears'] = JHTML::_('select.genericList', $this->getJSModel('modelyear')->getVehiclesModelYear(JText::_('All')), 'modelyearid', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['fueltypes'] = JHTML::_('select.genericList', $this->getJSModel('fueltype')->getVehiclesFuelType(JText::_('All')), 'fueltypeid', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['transmissions'] = JHTML::_('select.genericList', $this->getJSModel('transmission')->getVehiclesTransmission(JText::_('All')), 'transmissionid', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['conditions'] = JHTML::_('select.genericList', $this->getJSModel('condition')->getVehiclesCondition(JText::_('All')), 'conditionid', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['cylinders'] = JHTML::_('select.genericList', $this->getJSModel('cylinder')->getVehiclesCylinders(JText::_('All')), 'cylinderid', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['radiussearch'] = JHTML::_('select.genericlist', $radiussearch, 'radiussearch', 'class="inputbox" ' . '', 'value', 'text', '');
        $result[2] = $lists;
        $result[3] = $fieldorderings;
        return $result;
    }

    function getVehicleSearchResults($searchdata, $limitstart, $limit) {                //get vehicle search result
        $db = $this->getDBO();
        $wherequery = "";
        if ($searchdata['vehicletypeid'] != '')
            if (is_numeric($searchdata['vehicletypeid']) == false)
                return false;
        if ($searchdata['vehicletypeid'] != '')
            $wherequery .= " AND vehicle.vehicletypeid = " . $searchdata['vehicletypeid'];
        if ($searchdata['makeid'] != '')
            if (is_numeric($searchdata['makeid']) == false)
                return false;
        if ($searchdata['makeid'] != '')
            $wherequery .= " AND vehicle.makeid = " . $searchdata['makeid'];
        if (isset($searchdata['conditionid']))
            if ($searchdata['conditionid'] != '')
                if (is_numeric($searchdata['conditionid']) == false)
                    return false;
        if (isset($searchdata['conditionid']))
            if ($searchdata['conditionid'] != '')
                $wherequery .= " AND vehicle.conditionid = " . $searchdata['conditionid'];
        if (isset($searchdata['modelid']))
            if ($searchdata['modelid'] != '')
                if (is_numeric($searchdata['modelid']) == false)
                    return false;
        if (isset($searchdata['modelid']))
            if ($searchdata['modelid'] != 0)
                if ($searchdata['modelid'] != '')
                    $wherequery .= " AND vehicle.modelid = " . $searchdata['modelid'];
        if ($searchdata['modelyearid'] != '')
            if (is_numeric($searchdata['modelyearid']) == false)
                return false;
        if ($searchdata['modelyearid'] != '')
            $wherequery .= " AND vehicle.modelyearid = " . $searchdata['modelyearid'];
        if ($searchdata['fueltypeid'] != '')
            if (is_numeric($searchdata['fueltypeid']) == false)
                return false;
        if ($searchdata['fueltypeid'] != '')
            $wherequery .= " AND vehicle.fueltypeid= " . $searchdata['fueltypeid'];
        if ($searchdata['cylinderid'] != '')
            if (is_numeric($searchdata['cylinderid']) == false)
                return false;
        if ($searchdata['cylinderid'] != '')
            $wherequery .= " AND vehicle.cylinderid= " . $searchdata['cylinderid'];
        if ($searchdata['pricefrom'] != '')
            if (is_numeric($searchdata['pricefrom']) == false)
                return false;
        if ($searchdata['pricefrom'] != '')
            $wherequery .= " AND vehicle.price >= " . $searchdata['pricefrom'];
        if ($searchdata['priceto'] != '')
            if (is_numeric($searchdata['priceto']) == false)
                return false;
        if ($searchdata['priceto'] != '')
            $wherequery .= " AND vehicle.price <= " . $searchdata['priceto'];
        if ($searchdata['exteriorcolor'] != '')
            $wherequery .= " AND vehicle.exteriorcolor LIKE '%" . str_replace("'", "", $db->quote($searchdata['exteriorcolor'])) . "%'";
        if (isset($searchdata['title']))
            if ($searchdata['title'] != '')
                $wherequery .= " AND vehicle.title LIKE '%" . str_replace("'", "", $db->quote($searchdata['title'])) . "%'";
        if (isset($searchdata['registrationnumber']))
            if ($searchdata['registrationnumber'] != '')
                $wherequery .= " AND vehicle.registrationnumber=" . $db->quote($searchdata['registrationnumber']);
        if ($searchdata['regcity'] != 0)
            $wherequery .= " AND vehicle.regcity= " . $db->quote($searchdata['regcity']);
        if ($searchdata['loccity'] != 0)
            $wherequery .= " AND vehicle.loccity= " . $db->quote($searchdata['loccity']);
        if ($searchdata['loczip'] != '') {
            $zipcodes = $this->getJSModel('zip')->get_zips_in_range($searchdata['loczip'], $searchdata['radiussearch'], 1, 1); //$zip, $range, $sort=1, $include_base
            $total = "";
            foreach ($zipcodes as $code) {
                $total = $total + 1;
                if ($total == 1)
                    $wherequery .= " AND (vehicle.loczip = " . $code->code;
                else
                    $wherequery .= " OR vehicle.loczip = " . $code->code;
            }
            $wherequery .=" )";

            if ($total > 1) {
                $wherequery .= $wherequery;
            } else {
                $wherequery .= "AND vehicle.loczip = " . $code->code;
            }
        }
        if (isset($searchdata['enginecapacity']))
            if ($searchdata['enginecapacity'] != '')
                $wherequery .= " AND vehicle.enginecapacity= " . $db->quote($searchdata['enginecapacity']);
        if (isset($searchdata['mileages']))
            if ($searchdata['mileages'] != '')
                $wherequery .= " AND vehicle.mileages BETWEEN " . $db->quote($searchdata['enginecapacity']) . " AND " . $db->quote($searchdata['enginecapacity']);
        switch ($searchdata['radius_length_type']) {
            case "m":$radiuslength = 6378137;
                break;
            case "km":$radiuslength = 6378.137;
                break;
            case "mile":$radiuslength = 3963.191;
                break;
            case "nacmiles":$radiuslength = 3441.596;
                break;
        }
        $selectdistance = " ";
        if (($searchdata['longitude'] !== "") && ($searchdata['latitude'] !== "") && ($searchdata['radius'] !== "")) {
            $latitude = $searchdata['latitude'];
            $longitude = $searchdata['longitude'];
            $radius = $searchdata['radius'];
            if (!is_numeric($latitude))
                return false;
            if (!is_numeric($longitude))
                return false;
            if (!is_numeric($radius))
                return false;
            $radiussearch = " acos((SIN( PI()* $latitude /180 )*SIN( PI()*vehicle.latitude/180 ))+(cos(PI()* $latitude /180)*COS( PI()*vehicle.latitude/180) *COS(PI()*vehicle.longitude/180-PI()* $longitude /180)))* $radiuslength <= $radius";
            $selectdistance = " ,acos((sin(PI()*$latitude/180)*sin(PI()*vehicle.latitude/180))+(cos(PI()*$latitude/180)*cos(PI()*vehicle.latitude/180)*cose(PI()*vehicle.longitude/180 - PI()*$longitude/180)))*$radiuslength AS distance ";
        }
        if (isset($radiussearch) && $radiussearch != '')
            $wherequery .= " AND " . $radiussearch;

        $query = "SELECT count(vehicle.id) FROM `#__js_auto_vehicles` AS vehicle
                WHERE vehicle.status = 1 AND vehicle.addexpiryvalue >= CURDATE()  ";
        $query .= $wherequery;

        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;
        $query = "SELECT vehicle.issold AS soldvehicles,vehicle.price,vehicle.created,vehicle.uid AS uid,
                    vehicle.id,vehicle.title,vehicle.latitude,vehicle.longitude,vehicle.makeid AS makeid,vehicle.conditionid AS conditionid, vehicle.modelid AS modelid,vehicle.isgoldvehicle as gold,vehicle.isfeaturedvehicle as featured,
                    vehicle.exteriorcolor,vehicle.enginecapacity,vehicle.isdiscount,vehicle.discountstart,vehicle.discountend,vehicle.discounttype,vehicle.discount,vehicle.highwayfuelconsumption as highwayconsumption,vehicle.cityfuelconsumption as cityconsumption,
                    country.name AS countryname,state.name AS statename,city.name AS cityname,vehicle.addexpiryvalue,
                    vehicletypes.title AS vehicletitle,vehicle.mileages AS mileage,mileagetype.symbol as mileagetitle,
                    makes.title AS maketitle,models.title AS modeltitle,modelyear.title AS modelyeartitle,vehicle.status,transmission.title AS transmissiontitle,
                    fueltype.title AS fueltitle,cylinder.title AS cylindertitle ,conditions.title AS conditiontitle, cat.title AS cattitle , image.filename AS vehiclelogo,currency.symbol AS currency,vehicle.enginecapacity
                    FROM `#__js_auto_vehicles` AS vehicle
                    LEFT JOIN `#__js_auto_vehicleimages` AS image ON vehicle.id= image.vehicleid AND image.isdefault = 1
                    LEFT JOIN `#__js_auto_vehicletypes` AS vehicletypes ON vehicle.vehicletypeid = vehicletypes.id
                    LEFT JOIN `#__js_auto_makes` AS makes ON vehicle.makeid =makes.id
                    LEFT JOIN `#__js_auto_mileagetypes` AS mileagetype ON vehicle.mileagetypeid =mileagetype.id
                    LEFT JOIN `#__js_auto_transmissions` AS transmission ON vehicle.transmissionid =transmission.id
                    LEFT JOIN `#__js_auto_models` AS models ON vehicle.modelid =  models.id
                    LEFT JOIN `#__js_auto_categories` AS cat ON vehicle.categoryid =  cat.id
                    LEFT JOIN `#__js_auto_modelyears` AS modelyear ON vehicle.modelyearid = modelyear.id
                    LEFT JOIN `#__js_auto_conditions` AS conditions ON vehicle.conditionid = conditions.id
                    LEFT JOIN `#__js_auto_fueltypes` AS fueltype ON vehicle.fueltypeid = fueltype.id
                    LEFT JOIN `#__js_auto_cylinders` AS cylinder ON vehicle.cylinderid = cylinder.id
                    LEFT JOIN `#__js_auto_currency` AS currency ON vehicle.currencyid = currency.id
                    LEFT JOIN `#__js_auto_cities` AS city ON vehicle.loccity = city.id
                    LEFT JOIN `#__js_auto_countries` AS country ON city.countryid = country.id
                    LEFT JOIN `#__js_auto_states` AS state ON city.stateid = state.id
                    WHERE vehicle.status = 1 AND vehicle.addexpiryvalue >= CURDATE() ";
        $query .= $wherequery . " GROUP BY vehicle.id";

        $db->setQuery($query, $limitstart, $limit);
        $vehicleresult = $db->loadObjectList();
        if(!empty($vehicleresult))
        foreach($vehicleresult AS $vehicle){
            $vehicle->vehicleimages = $this->getJSModel('vehicleimage')->getVehicleImagebyId($vehicle->id);
        }
        $result[0] = $vehicleresult;
        
        $result[1] = $total;

        return $result;
    }

}

?>
