<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:     www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest::getVar('option', 'com_jsautoz');

class JSAutozModelvehicletype extends JSAutozModel {

    var $_config = null;
    var $_countries = null;

    function __construct() {
        parent::__construct();
    }

    function makeVehicletypeDefault($id) {
        if (!is_numeric($id))
            return false;
        $canmakedefault = $this->getJSModel('common')->canMakeDefault($id, 'vehicletypes');
        if ($canmakedefault) {
            $db = $this->getDBO();
            $query = "UPDATE `#__js_auto_vehicletypes` AS vehicletype SET vehicletype.isdefault= 0";
            $db->setQuery($query);
            if (!$db->query()) {
                return false;
            }
            $row = $this->getTable('vehicletype');
            $row->id = $id;
            $row->isdefault = 1;
            $row->status = 1;
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                echo $this->_db->getErrorMsg();
                $returnvalue = 0;
            } else
                $returnvalue = 1;
        } else
            $returnvalue = 4;

        return $returnvalue;
    }

    function getAllVehicleTypes($limitstart, $limit) {          //get all vehicle types
        $db = JFactory::getDBO();
        $result = array();
        $query = "SELECT COUNT(id) FROM #__js_auto_vehicletypes";
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;
        $query = "SELECT * FROM #__js_auto_vehicletypes ORDER BY id ASC";

        $db->setQuery($query, $limitstart, $limit);
        $result[0] = $db->loadObjectList();
        $result[1] = $total;
        return $result;
    }

    function getVehiclesType($title) {         //get vehicle types
        $db = JFactory::getDBO();
        $query = "SELECT  id, title FROM `#__js_auto_vehicletypes` WHERE status = 1 ORDER BY title ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $vehicletypes = array();
        if ($title)
            $vehicletypes[] = array('value' => JText::_(''), 'text' => $title);
        foreach ($rows as $row) {
            $vehicletypes[] = array('value' => $row->id, 'text' => JText::_($row->title));
        }
        return $vehicletypes;
    }

    function storeVehicleTypes() {                //store Vehicle Types
        $row = $this->getTable('vehicletype');
        $result = array();
        $data = JRequest::get('post');

        if ($_FILES['logo']['size'] > 0) { // logo
            $data['logo'] = str_replace(' ', '-', $_FILES['logo']['name']); // file name
        }
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        if ($data['id'] == '') { // only for new
            $result1 = $this->isVehicleTypeExist($data['title']);
            if ($result1 == 1) {
                $result[0] = 3;
                return $result;
            }
        }
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            $result[0] = false;
            return $result;
        }
        $typeid = $row->id;
        if ($_FILES['logo']['size'] > 0) { // logo
            $returnvalue = $this->getJSModel('vehicletype')->uploadVehicleTypeLogo($typeid, 0);
            if ($returnvalue == 1) {
                $result[0] = True;
                $result[1] = $row->id;
                return $result;
            } else
                $result[0] = 5;
            return $result;
        }else {
            $result[0] = true;
            $result[1] = $row->id;
            return $result;
        }
    }

    function uploadVehicleTypeLogo($id, $isdeletefile) {      //upload vehicle image
        if (is_numeric($id) == false)
            return false;
        $result = array();
        $db = JFactory::getDBO();
        $base = JPATH_BASE;
        $path = $base . '/components/com_jsautoz/include/logo';
        if (!file_exists($path)) { // create user directory
            $this->getJSModel('common')->makeDir($path);
        }
        $isupload = false;
        $path = $path . '/types';
        if (!file_exists($path)) { // create user directory
            $this->getJSModel('common')->makeDir($path);
        }
        $path = $path . '/type_' . $id;
        if (!file_exists($path)) { // create user directory
            $this->getJSModel('common')->makeDir($path);
        }
        if ($_FILES['logo']['size'] > 0) {
            $file_name = str_replace(' ', '-', $_FILES['logo']['name']); // file name
            $file_tmp = $_FILES['logo']['tmp_name']; // actual location

            $ext = $this->getJSModel('common')->getExtension($file_name);
            $ext = strtolower($ext);
            if (($ext != "gif") && ($ext != "jpg") && ($ext != "jpeg") && ($ext != "png"))
                return 6; //file type mistmathc

            $isupload = true;
        }
        if ($isupload) {
            move_uploaded_file($file_tmp, $path . '/' . $file_name);
            return 1;
        } else { // DELETE FILES
            if ($isdeletefile == 1) { // this code may not use
                $userpath = $path . '/type' . $id . '/logo';
                $files = glob($userpath . '/*.*');
                array_map('unlink', $files); // delete all file in the direcoty
            }
            return 1;
        }
    }

    function deleteVehicleType() {                //deleteVehicleType
        $cids = JRequest::getVar('cid', array(0), 'post', 'array');
        $row = $this->getTable('vehicletype');
        $couldnotdelete = 0;
        foreach ($cids as $cid) {
            if ($this->getJSModel('vehicletype')->vehicleTypeCanDelete($cid) == true) {
                if (!$row->delete($cid)) {
                    $this->setError($row->getErrorMsg());
                    return false;
                }
            } else
                $couldnotdelete++;
        }
        return $couldnotdelete;
    }

    function vehicleTypeCanDelete($id) {                 //vehicleTypeCanDelete
        if (is_numeric($id) == false)
            return false;
        $db = $this->getDBO();
        $query = " SELECT 
                    (SELECT COUNT(id) FROM `#__js_auto_vehicles` WHERE vehicletypeid = " . $id . ")
                    + (SELECT COUNT(id) FROM `#__js_auto_vehicletypes` WHERE id = " . $id . " AND isdefault = 1)
                    AS total";
        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total > 0)
            return false;
        else
            return true;
    }

    function getVehicleTypeforForm($id) {             //getVehicleTypeforForm
        $db = $this->getDBO();
        $vehicletype = null;
        if ($id) {
            if (is_numeric($id) == false)
                return false;
            $query = "SELECT vehicletype.*
            FROM `#__js_auto_vehicletypes` AS vehicletype
            WHERE vehicletype.id = " . $id;
            $db->setQuery($query);
            $vehicletype = $db->loadObject();
        }
        return $vehicletype;
    }

    function changeStatusVehicleType($id, $status) {            //changeStatusVehicleType
        if (is_numeric($id) == false)
            return false;
        if (is_numeric($status) == false)
            return false;
        $canchangestatus = $this->getJSModel('common')->canPublishUnpublish($id, 'vehicletypes');
        if ($canchangestatus) {
            $row = $this->getTable('vehicletype');
            $row->id = $id;
            $row->status = $status;
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                $returnvalue = 0;
            } else
                $returnvalue = 1;
        } else
            $returnvalue = 3;

        return $returnvalue;
    }

    function isVehicleTypeExist($title) {           //isVehicleTypeExist
        $db = JFactory::getDBO();
        $query = "SELECT COUNT(id) FROM #__js_auto_vehicletypes WHERE title = " . $db->Quote($title);
        $db->setQuery($query);
        $result = $db->loadResult();
        if ($result == 0)
            return 0;
        else
            return 1;
    }

    function getVehicleTypeidByTitle($title) {
        if (empty($title))
            return $title;
        $db = JFactory::getDBO();
        $query = "SELECT vehicletype.id AS vehicletypeid FROM `#__js_auto_vehicletypes` AS vehicletype WHERE LOWER(vehicletype.title) = " . $db->quote(strtolower($title));
        $db->setQuery($query);
        $result = $db->loadObject();
        if ($result) {
            return $result->vehicletypeid;
        } else {
            $row = $this->getTable('vehicletype');
            $data['title'] = $title;
            $data['status'] = 1;

            if (!$row->bind($data)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->check()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            if (!$row->store()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return $row->id;
        }
    }

}
?>