<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:     www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest::getVar('option', 'com_jsautoz');

class JSAutozModelZip extends JSAutozModel {

    var $_config = null;
    var $_countries = null;

    function __construct() {
        parent::__construct();
    }

    function get_zips_in_range($zip, $range, $sort = 1, $include_base) {
        $db = JFactory::getDBO();
        $details = $this->get_zip_point($zip);  // base zip details
        if ($details == false)
            return false;
        $lat_range = $range / 69.172;
        $lon_range = abs($range / (cos($details->latitude) * 69.172));
        $min_lat = number_format($details->latitude - $lat_range, "4", ".", "");
        $max_lat = number_format($details->latitude + $lat_range, "4", ".", "");
        $min_lon = number_format($details->longitude - $lon_range, "4", ".", "");
        $max_lon = number_format($details->longitude + $lon_range, "4", ".", "");

        $query = "SELECT code, latitude, longitude FROM `#__js_auto_zips`";
        if (!$include_base)
            $query .= "WHERE code <> " . $db->quote($zip) . " AND ";
        else
            $query .= "WHERE ";
        $query .= "latitude BETWEEN '$min_lat' AND '$max_lat'
                   AND longitude BETWEEN '$min_lon' AND '$max_lon'";

        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        return $rows;
    }

    function get_zip_point($zip) {
        $db = JFactory::getDBO();

        $query = "SELECT latitude, longitude FROM `#__js_auto_zips` WHERE code=" . $db->quote($zip);

        $db->setQuery($query);
        $row = $db->loadObject();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        return $row;
    }

    function getZipCodes($cityid, $title) {
        if (!is_numeric($cityid))
            return false;
        $db = JFactory::getDBO();
        $query = "SELECT  * FROM `#__js_auto_zips` WHERE enabled = 'Y' AND cityid = '" . $cityid . "' ORDER BY code ASC  ";

        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $zipcodes = array();
        if ($title)
            $zipcodes[] = array('value' => JText::_(''), 'text' => $title);
        foreach ($rows as $row) {
            $zipcodes[] = array('value' => $row->id, 'text' => $row->code);
        }
        return $zipcodes;
    }

    function getZipidByCode($title) {
        if ($title == "")
            return $title;
        $db = JFactory::getDBO();
        $query = "SELECT zip.id AS zipid FROM `#__js_auto_zips` AS zip WHERE LOWER(zip.code) = " . $db->quote(strtolower($title));
        $db->setQuery($query);
        $result = $db->loadObject();
        if ($result) {
            return $result->zipid;
        } else {
            return $title;
        }
    }

}

?>