
ALTER TABLE `#__js_auto_makes` ADD `alias` VARCHAR( 225 ) NOT NULL AFTER `title`;
UPDATE `#__js_auto_makes` SET alias = LOWER( REPLACE( title, ' ', '-' ) ); 

ALTER TABLE `#__js_auto_models` ADD `alias` VARCHAR( 225 ) NOT NULL AFTER `status`;
UPDATE `#__js_auto_models` SET alias = LOWER( REPLACE( title, ' ', '-' ) ); 

ALTER TABLE `#__js_auto_vehicles` ADD `alias` VARCHAR( 255 ) NOT NULL AFTER `title`;
UPDATE `#__js_auto_vehicles` SET alias = LOWER( REPLACE( title, ' ', '-' ) );


ALTER TABLE `#__js_auto_modelyears` CHANGE `title` `title` INT( 11 ) NOT NULL;


ALTER TABLE `#__js_auto_states` ADD `countryid` int(11) DEFAULT '0' AFTER `countrycode`;
UPDATE `#__js_auto_states` AS states JOIN `#__js_auto_countries` AS country ON country.code = states.countrycode SET states.countryid = country.id;


ALTER TABLE `#__js_auto_cities` ADD `countryid` int(11) DEFAULT '0' AFTER `countrycode`;
ALTER TABLE `#__js_auto_cities` ADD `stateid` int(11) DEFAULT '0' AFTER `statecode`;
UPDATE `#__js_auto_cities` AS cities JOIN `#__js_auto_countries` AS country ON country.code = cities.countrycode SET cities.countryid = country.id;
UPDATE `#__js_auto_cities` AS cities JOIN `#__js_auto_states` AS states ON states.code = cities.statecode SET cities.stateid = states.id;


RENAME TABLE `#__js_auto_countries` TO `#__js_auto_countries_old`;
RENAME TABLE `#__js_auto_states` TO `#__js_auto_states_old`;
RENAME TABLE `#__js_auto_cities` TO `#__js_auto_cities_old`;

DROP TABLE IF EXISTS `#__js_auto_countries`;
CREATE TABLE  `#__js_auto_countries` (
  `id` smallint(9) NOT NULL AUTO_INCREMENT,
  `name` varchar(40) DEFAULT NULL,
  `shortCountry` varchar(30) DEFAULT NULL,
  `continentID` tinyint(11) DEFAULT NULL,
  `dialCode` smallint(8) DEFAULT NULL,
  `enabled` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  FULLTEXT KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='utf8_general_ci';
INSERT INTO `#__js_auto_countries` (`id`, `name`, `shortCountry`, `continentID`, `dialCode`, `enabled`) VALUES (1, 'United States', 'US', 1, 1, 1), (2, 'Canada', 'Canada', 1, 1, 1), (3, 'Bahamas', 'Bahamas', 1, 242, 1), (4, 'Barbados', 'Barbados', 1, 246, 1), (5, 'Belize', 'Belize', 1, 501, 1), (6, 'Bermuda', 'Bermuda', 1, 441, 1), (7, 'British Virgin Islands', 'BVI', 1, 284, 1), (8, 'Cayman Islands', 'CaymanIsl', 1, 345, 1), (9, 'Costa Rica', 'CostaRica', 1, 506, 1), (10, 'Cuba', 'Cuba', 1, 53, 1), (11, 'Dominica', 'Dominica', 1, 767, 1), (12, 'Dominican Republic', 'DominicanRep', 1, 809, 1), (13, 'El Salvador', 'ElSalvador', 1, 503, 1), (14, 'Greenland', 'Greenland', 1, 299, 1), (15, 'Grenada', 'Grenada', 1, 473, 1), (16, 'Guadeloupe', 'Guadeloupe', 1, 590, 1), (17, 'Guatemala', 'Guatemala', 1, 502, 1), (18, 'Haiti', 'Haiti', 1, 509, 1), (19, 'Honduras', 'Honduras', 1, 503, 1), (20, 'Jamaica', 'Jamaica', 1, 876, 1), (21, 'Martinique', 'Martinique', 1, 596, 1), (22, 'Mexico', 'Mexico', 1, 52, 1), (23, 'Montserrat', 'Montserrat', 1, 664, 1), (24, 'Nicaragua', 'Nicaragua', 1, 505, 1), (25, 'Panama', 'Panama', 1, 507, 1), (26, 'Puerto Rico', 'PuertoRico', 1, 787, 1), (27, 'Trinidad and Tobago', 'Trinidad-Tobago', 1, 868, 1), (28, 'United States Virgin Islands', 'USVI', 1, 340, 1), (29, 'Argentina', 'Argentina', 2, 54, 1), (30, 'Bolivia', 'Bolivia', 2, 591, 1), (31, 'Brazil', 'Brazil', 2, 55, 1), (32, 'Chile', 'Chile', 2, 56, 1), (33, 'Colombia', 'Colombia', 2, 57, 1), (34, 'Ecuador', 'Ecuador', 2, 593, 1), (35, 'Falkland Islands', 'FalklandIsl', 2, 500, 1), (36, 'French Guiana', 'FrenchGuiana', 2, 594, 1), (37, 'Guyana', 'Guyana', 2, 592, 1), (38, 'Paraguay', 'Paraguay', 2, 595, 1), (39, 'Peru', 'Peru', 2, 51, 1), (40, 'Suriname', 'Suriname', 2, 597, 1), (41, 'Uruguay', 'Uruguay', 2, 598, 1), (42, 'Venezuela', 'Venezuela', 2, 58, 1), (43, 'Albania', 'Albania', 3, 355, 1), (44, 'Andorra', 'Andorra', 3, 376, 1), (45, 'Armenia', 'Armenia', 3, 374, 1), (46, 'Austria', 'Austria', 3, 43, 1), (47, 'Azerbaijan', 'Azerbaijan', 3, 994, 1), (48, 'Belarus', 'Belarus', 3, 375, 1), (49, 'Belgium', 'Belgium', 3, 32, 1), (50, 'Bosnia and Herzegovina', 'Bosnia-Herzegovina', 3, 387, 1), (51, 'Bulgaria', 'Bulgaria', 3, 359, 1), (52, 'Croatia', 'Croatia', 3, 385, 1), (53, 'Cyprus', 'Cyprus', 3, 357, 1), (54, 'Czech Republic', 'CzechRep', 3, 420, 1), (55, 'Denmark', 'Denmark', 3, 45, 1), (56, 'Estonia', 'Estonia', 3, 372, 1), (57, 'Finland', 'Finland', 3, 358, 1), (58, 'France', 'France', 3, 33, 1), (59, 'Georgia', 'Georgia', 3, 995, 1), (60, 'Germany', 'Germany', 3, 49, 1), (61, 'Gibraltar', 'Gibraltar', 3, 350, 1), (62, 'Greece', 'Greece', 3, 30, 1), (63, 'Guernsey', 'Guernsey', 3, 44, 1), (64, 'Hungary', 'Hungary', 3, 36, 1), (65, 'Iceland', 'Iceland', 3, 354, 1), (66, 'Ireland', 'Ireland', 3, 353, 1), (67, 'Isle of Man', 'IsleofMan', 3, 44, 1), (68, 'Italy', 'Italy', 3, 39, 1), (69, 'Jersey', 'Jersey', 3, 44, 1), (70, 'Kosovo', 'Kosovo', 3, 381, 1), (71, 'Latvia', 'Latvia', 3, 371, 1), (72, 'Liechtenstein', 'Liechtenstein', 3, 423, 1), (73, 'Lithuania', 'Lithuania', 3, 370, 1), (74, 'Luxembourg', 'Luxembourg', 3, 352, 1), (75, 'Macedonia', 'Macedonia', 3, 389, 1), (76, 'Malta', 'Malta', 3, 356, 1), (77, 'Moldova', 'Moldova', 3, 373, 1), (78, 'Monaco', 'Monaco', 3, 377, 1), (79, 'Montenegro', 'Montenegro', 3, 381, 1), (80, 'Netherlands', 'Netherlands', 3, 31, 1), (81, 'Norway', 'Norway', 3, 47, 1), (82, 'Poland', 'Poland', 3, 48, 1), (83, 'Portugal', 'Portugal', 3, 351, 1), (84, 'Romania', 'Romania', 3, 40, 1), (85, 'Russia', 'Russia', 3, 7, 1), (86, 'San Marino', 'SanMarino', 3, 378, 1), (87, 'Serbia', 'Serbia', 3, 381, 1), (88, 'Slovakia', 'Slovakia', 3, 421, 1), (89, 'Slovenia', 'Slovenia', 3, 386, 1), (90, 'Spain', 'Spain', 3, 34, 1), (91, 'Sweden', 'Sweden', 3, 46, 1), (92, 'Switzerland', 'Switzerland', 3, 41, 1), (93, 'Turkey', 'Turkey', 3, 90, 1),(94, 'Ukraine', 'Ukraine', 3, 380, 1), (95, 'United Kingdom', 'UK', 3, 44, 1), (96, 'Vatican City', 'Vatican', 3, 39, 1), (97, 'Afghanistan', 'Afghanistan', 4, 93, 1), (98, 'Bahrain', 'Bahrain', 4, 973, 1), (99, 'Bangladesh', 'Bangladesh', 4, 880, 1), (100, 'Bhutan', 'Bhutan', 4, 975, 1), (101, 'Brunei', 'Brunei', 4, 673, 1), (102, 'Cambodia', 'Cambodia', 4, 855, 1), (103, 'China', 'China', 4, 86, 1), (104, 'East Timor', 'EastTimor', 4, 670, 1), (105, 'Hong Kong', 'HongKong', 4, 852, 1), (106, 'India', 'India', 4, 91, 1), (107, 'Indonesia', 'Indonesia', 4, 62, 1), (108, 'Iran', 'Iran', 4, 98, 1), (109, 'Iraq', 'Iraq', 4, 964, 1), (110, 'Israel', 'Israel', 4, 972, 1), (111, 'Japan', 'Japan', 4, 81, 1), (112, 'Jordan', 'Jordan', 4, 962, 1), (113, 'Kazakhstan', 'Kazakhstan', 4, 7, 1), (114, 'Kuwait', 'Kuwait', 4, 965, 1), (115, 'Kyrgyzstan', 'Kyrgyzstan', 4, 996, 1), (116, 'Laos', 'Laos', 4, 856, 1), (117, 'Lebanon', 'Lebanon', 4, 961, 1), (118, 'Macau', 'Macau', 4, 853, 1), (119, 'Malaysia', 'Malaysia', 4, 60, 1), (120, 'Maldives', 'Maldives', 4, 960, 1), (121, 'Mongolia', 'Mongolia', 4, 976, 1), (122, 'Myanmar (Burma)', 'Myanmar(Burma)', 4, 95, 1), (123, 'Nepal', 'Nepal', 4, 977, 1), (124, 'North Korea', 'NorthKorea', 4, 850, 1), (125, 'Oman', 'Oman', 4, 968, 1), (126, 'Pakistan', 'Pakistan', 4, 92, 1), (127, 'Philippines', 'Philippines', 4, 63, 1), (128, 'Qatar', 'Qatar', 4, 974, 1), (129, 'Saudi Arabia', 'SaudiArabia', 4, 966, 1), (130, 'Singapore', 'Singapore', 4, 65, 1), (131, 'South Korea', 'SouthKorea', 4, 82, 1), (132, 'Sri Lanka', 'SriLanka', 4, 94, 1), (133, 'Syria', 'Syria', 4, 963, 1), (134, 'Taiwan', 'Taiwan', 4, 886, 1), (135, 'Tajikistan', 'Tajikistan', 4, 992, 1), (136, 'Thailand', 'Thailand', 4, 66, 1), (137, 'Turkmenistan', 'Turkmenistan', 4, 993, 1), (138, 'United Arab Emirates', 'UAE', 4, 971, 1), (139, 'Uzbekistan', 'Uzbekistan', 4, 998, 1), (140, 'Vietnam', 'Vietnam', 4, 84, 1), (141, 'Yemen', 'Yemen', 4, 967, 1), (142, 'Algeria', 'Algeria', 5, 213, 1), (143, 'Angola', 'Angola', 5, 244, 1), (144, 'Benin', 'Benin', 5, 229, 1), (145, 'Botswana', 'Botswana', 5, 267, 1), (146, 'Burkina Faso', 'BurkinaFaso', 5, 226, 1), (147, 'Burundi', 'Burundi', 5, 257, 1), (148, 'Cameroon', 'Cameroon', 5, 237, 1), (149, 'Cape Verde', 'CapeVerde', 5, 238, 1), (150, 'Central African Republic', 'CentralAfricanRep', 5, 236, 1), (151, 'Chad', 'Chad', 5, 235, 1), (152, 'Congo', 'Congo', 5, 242, 1), (153, 'Democoratic Republic of Congo', 'D.R Congo', 5, 242, 1), (154, 'Djibouti', 'Djibouti', 5, 253, 1), (155, 'Egypt', 'Egypt', 5, 20, 1), (156, 'Equatorial Guinea', 'EquatorialGuinea', 5, 240, 1), (157, 'Eritrea', 'Eritrea', 5, 291, 1), (158, 'Ethiopia', 'Ethiopia', 5, 251, 1), (159, 'Gabon', 'Gabon', 5, 241, 1), (160, 'Gambia', 'Gambia', 5, 220, 1), (161, 'Ghana', 'Ghana', 5, 233, 1), (162, 'Guinea', 'Guinea', 5, 224, 1), (163, 'Guinea-Bissau', 'Guinea-Bissau', 5, 245, 1), (164, 'Cote DIvory', 'IvoryCoast', 5, 225, 1), (165, 'Kenya', 'Kenya', 5, 254, 1), (166, 'Lesotho', 'Lesotho', 5, 266, 1), (167, 'Liberia', 'Liberia', 5, 231, 1), (168, 'Libya', 'Libya', 5, 218, 1), (169, 'Madagascar', 'Madagascar', 5, 261, 1), (170, 'Malawi', 'Malawi', 5, 265, 1), (171, 'Mali', 'Mali', 5, 223, 1), (172, 'Mauritania', 'Mauritania', 5, 222, 1), (173, 'Mauritius', 'Mauritius', 5, 230, 1), (174, 'Morocco', 'Morocco', 5, 212, 1), (175, 'Mozambique', 'Mozambique', 5, 258, 1), (176, 'Namibia', 'Namibia', 5, 264, 1), (177, 'Niger', 'Niger', 5, 227, 1), (178, 'Nigeria', 'Nigeria', 5, 234, 1), (179, 'Reunion', 'Reunion', 5, 262, 1), (180, 'Rwanda', 'Rwanda', 5, 250, 1), (181, 'Sao Tome and Principe', 'SaoTome-Principe', 5, 239, 1), (182, 'Senegal', 'Senegal', 5, 221, 1), (183, 'Seychelles', 'Seychelles', 5, 248, 1), (184, 'Sierra Leone', 'SierraLeone', 5, 232, 1), (185, 'Somalia', 'Somalia', 5, 252, 1), (186, 'South Africa', 'SouthAfrica', 5, 27, 1), (187, 'Sudan', 'Sudan', 5, 249, 1), (188, 'Swaziland', 'Swaziland', 5, 268, 1), (189, 'Tanzania', 'Tanzania', 5, 255, 1), (190, 'Togo', 'Togo', 5, 228, 1), (191, 'Tunisia', 'Tunisia', 5, 216, 1), (192, 'Uganda', 'Uganda', 5, 256, 1), (193, 'Western Sahara', 'WesternSahara', 5, 212, 1), (194, 'Zambia', 'Zambia', 5, 260, 1), (195, 'Zimbabwe', 'Zimbabwe', 5, 263, 1), (196, 'Australia', 'Australia', 6, 61, 1), (197, 'New Zealand', 'NewZealand', 6, 64, 1), (198, 'Fiji', 'Fiji', 6, 679, 1), (199, 'French Polynesia', 'FrenchPolynesia', 6, 689, 1), (200, 'Guam', 'Guam', 6, 671, 1), (201, 'Kiribati', 'Kiribati', 6, 686, 1), (202, 'Marshall Islands', 'MarshallIsl', 6, 692, 1), (203, 'Micronesia', 'Micronesia', 6, 691, 1), (204, 'Nauru', 'Nauru', 6, 674, 1), (205, 'New Caledonia', 'NewCaledonia', 6, 687, 1), (206, 'Papua New Guinea', 'PapuaNewGuinea', 6, 675, 1), (207, 'Samoa', 'Samoa', 6, 684, 1), (208, 'Solomon Islands', 'SolomonIsl', 6, 677, 1), (209, 'Tonga', 'Tonga', 6, 676, 1), (210, 'Tuvalu', 'Tuvalu', 6, 688, 1), (211, 'Vanuatu', 'Vanuatu', 6, 678, 1), (212, 'Wallis and Futuna', 'Wallis-Futuna', 6, 681, 1), (213, 'Comoros', 'Comoros', 0, 0, 1), (214, 'Cote DIvorie', 'Cote-DIvorie', NULL, NULL, 1);

DROP TABLE IF EXISTS `#__js_auto_states`;
CREATE TABLE  `#__js_auto_states` (
  `id` smallint(8) NOT NULL AUTO_INCREMENT,
  `name` varchar(35) DEFAULT NULL,
  `shortRegion` varchar(25) DEFAULT NULL,
  `countryid` smallint(9) DEFAULT NULL,
  `enabled` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `countryid` (`countryid`),
  FULLTEXT KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='utf8_general_ci';
INSERT INTO `#__js_auto_states` (`id`, `name`, `shortRegion`, `countryid`, `enabled`) VALUES (1, 'Alabama', 'AL', 1, 1), (2, 'Alaska', 'AK', 1, 1), (3, 'Arizona', 'AZ', 1, 1), (4, 'Arkansas', 'AR', 1, 1), (5, 'California', 'CA', 1, 1), (6, 'Colorado', 'CO', 1, 1), (7, 'Connecticut', 'CT', 1, 1), (8, 'Delaware', 'DE', 1, 1), (9, 'District of Columbia', 'DC', 1, 1), (10, 'Florida', 'FL', 1, 1), (11, 'Georgia', 'GA', 1, 1), (12, 'Hawaii', 'HI', 1, 1), (13, 'Idaho', 'ID', 1, 1), (14, 'Illinois', 'IL', 1, 1), (15, 'Indiana', 'IN', 1, 1), (16, 'Iowa', 'IA', 1, 1), (17, 'Kansas', 'KS', 1, 1), (18, 'Kentucky', 'KY', 1, 1), (19, 'Louisiana', 'LA', 1, 1), (20, 'Maine', 'ME', 1, 1), (21, 'Maryland', 'MD', 1, 1), (22, 'Massachusetts', 'MA', 1, 1), (23, 'Michigan', 'MI', 1, 1), (24, 'Minnesota', 'MN', 1, 1), (25, 'Mississippi', 'MS', 1, 1), (26, 'Missouri', 'MO', 1, 1), (27, 'Montana', 'MT', 1, 1), (28, 'Nebraska', 'NE', 1, 1), (29, 'Nevada', 'NV', 1, 1), (30, 'New Hampshire', 'NH', 1, 1), (31, 'New Jersey', 'NJ', 1, 1), (32, 'New Mexico', 'NM', 1, 1), (33, 'New York', 'NY', 1, 1), (34, 'North Carolina', 'NC', 1, 1), (35, 'North Dakota', 'ND', 1, 1), (36, 'Ohio', 'OH', 1, 1), (37, 'Oklahoma', 'OK', 1, 1), (38, 'Oregon', 'OR', 1, 1), (39, 'Pennsylvania', 'PA', 1, 1), (40, 'Rhode Island', 'RI', 1, 1), (41, 'South Carolina', 'SC', 1, 1), (42, 'South Dakota', 'SD', 1, 1), (43, 'Tennessee', 'TN', 1, 1), (44, 'Texas', 'TX', 1, 1), (45, 'Utah', 'UT', 1, 1), (46, 'Vermont', 'VT', 1, 1), (47, 'Virginia', 'VA', 1, 1), (48, 'Washington', 'WA', 1, 1), (49, 'West Virginia', 'WV', 1, 1), (50, 'Wisconsin', 'WI', 1, 1), (51, 'Wyoming', 'WY', 1, 1), (52, 'Alberta', 'AB', 2, 1), (53, 'British Columbia', 'BC', 2, 1), (54, 'Manitoba', 'MB', 2, 1), (55, 'New Brunswick', 'NB', 2, 1), (56, 'Newfoundland and Labrador', 'NL', 2, 1), (57, 'Northwest Territories', 'NT', 2, 1), (58, 'Nova Scotia', 'NS', 2, 1), (59, 'Nunavut', 'NU', 2, 1), (60, 'Ontario', 'ON', 2, 1), (61, 'Prince Edward Island', 'PE', 2, 1), (62, 'Quebec', 'QC', 2, 1), (63, 'Saskatchewan', 'SK', 2, 1), (64, 'Yukon', 'YT', 2, 1), (65, 'England', 'England', 95, 1), (66, 'Northern Ireland', 'NorthernIreland', 95, 1), (67, 'Scotland', 'Scottland', 95, 1), (68, 'Wales', 'Wales', 95, 1), (86, 'NWFP', 'NWFP', 126, 1), (87, 'FATA', 'FATA', 126, 1), (88, 'Balochistan', 'Balochistan', 126, 1), (89, 'Punjab', 'Punjab', 126, 1), (90, 'Capital', 'Capital', 126, 1);

DROP TABLE IF EXISTS `#__js_auto_cities`;
CREATE TABLE  `#__js_auto_cities` (
  `id` mediumint(6) NOT NULL AUTO_INCREMENT,
  `cityName` varchar(70) DEFAULT NULL,
  `name` varchar(60) DEFAULT NULL,
  `stateid` smallint(8) DEFAULT NULL,
  `countryid` smallint(9) DEFAULT NULL,
  `enabled` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `countryid` (`countryid`),
  KEY `stateid` (`stateid`),
  FULLTEXT KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='utf8_general_ci';



ALTER TABLE `#__js_auto_zips` CHANGE `id` `id` INT( 8 ) NOT NULL AUTO_INCREMENT ,
	CHANGE `code` `code` VARCHAR( 30 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
	CHANGE `enabled` `enabled` CHAR( 1 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT 'Y',
	CHANGE `countrycode` `countryid` INT( 11 ) NOT NULL ,
	CHANGE `statecode` `stateid` INT( 11 ) NOT NULL ,
	CHANGE `countycode` `countyid` INT( 11 ) NOT NULL ,
	CHANGE `citycode` `cityid` INT( 11 ) NOT NULL ,
	CHANGE `latitude` `latitude` FLOAT NULL ,
	CHANGE `longitude` `longitude` FLOAT NULL;

ALTER TABLE `#__js_auto_zips` DROP `countyid`;






INSERT INTO `#__js_auto_config` (`configname` ,`configvalue` ,`configfor`)VALUES ('show_vehicle_rating', '1', 'default'), ('dealer_detailvehicleoverview', '1', 'default'), ('max_thumbnailshowon_vehicledetail', '10', 'default'), ('defaultaddressdisplaytype', 'csc', 'default'), ('tellafriend_allowed', '0', 'default'), ('seller_share_fb_like', '1', 'socailsharing'), ('buyer_share_fb_like', '1', 'socailsharing'), ('seller_share_fb_share', '1', 'socailsharing'), ('buyer_share_fb_share', '1', 'socailsharing'), ('seller_share_fb_comments', '0', 'socailsharing'), ('buyer_share_fb_comments', '1', 'socailsharing'), ('seller_share_google_like', '1', 'socailsharing'), ('buyer_share_google_like', '1', 'socailsharing'), ('seller_share_google_share', '1', 'socailsharing'), ('buyer_share_google_share', '1', 'socailsharing'), ('seller_share_blog_share', '1', 'socailsharing'), ('buyer_share_blog_share', '1', 'socailsharing'), ('seller_share_friendfeed_share', '1', 'socailsharing'), ('buyer_share_friendfeed_share', '1', 'socailsharing'), ('seller_share_linkedin_share', '1', 'socailsharing'), ('buyer_share_linkedin_share', '1', 'socailsharing'), ('seller_share_digg_share', '1', 'socailsharing'), ('buyer_share_digg_share', '1', 'socailsharing'), ('seller_share_twitter_share', '1', 'socailsharing'), ('buyer_share_twiiter_share', '1', 'socailsharing'), ('seller_share_myspace_share', '1', 'socailsharing'), ('buyer_share_myspace_share', '1', 'socailsharing'), ('seller_share_yahoo_share', '1', 'socailsharing'), ('buyer_share_yahoo_share', '1', 'socailsharing'), ('close_seller_front_end', '1', 'default'), ('seller_detailvehiclelisting', '1', 'default');

ALTER TABLE `#__js_auto_vehicles` ADD `cityfuelconsumptiontypeid` INT( 11 ) NOT NULL AFTER `cityfuelconsumption` ;
ALTER TABLE `#__js_auto_vehicles` ADD `highwayfuelconsumptiontypeid` INT( 11 ) NOT NULL AFTER `highwayfuelconsumption`;

ALTER TABLE `#__js_auto_vehicles` ADD `streetaddress` VARCHAR( 150 ) NOT NULL ,
	ADD `stocknumber` INT( 11 ) NOT NULL ,
	ADD `acceleration` INT( 11 ) NOT NULL ,
	ADD `accelerationtypeid` INT( 11 ) NOT NULL ,
	ADD `maxspeed` INT( 11 ) NOT NULL ,
	ADD `maxspeedtypeid` INT( 11 ) NOT NULL ,
	ADD `bargainprice` INT( 11 ) NOT NULL ,
	ADD `exportprice` INT( 11 ) NOT NULL ,
	ADD `isdiscount` TINYINT( 1 ) NOT NULL ,
	ADD `discountstart` DATETIME NOT NULL ,
	ADD `discountend` DATETIME NOT NULL ,
	ADD `discounttype` TINYINT( 1 ) NOT NULL ,
	ADD `discount` INT( 11 ) NOT NULL 	;


UPDATE `#__js_auto_fieldordering` SET ordering = ordering+1 WHERE fieldfor = 1 AND ordering > 22;
UPDATE `#__js_auto_fieldordering` SET ordering = ordering+1 WHERE fieldfor = 1 AND ordering > 10;
UPDATE `#__js_auto_fieldordering` SET ordering = ordering+7 WHERE fieldfor = 1 AND ordering > 28;
UPDATE `#__js_auto_fieldordering` SET ordering = ordering+2 WHERE fieldfor = 1 AND ordering > 40;
	
INSERT INTO `#__js_auto_fieldordering` (`id` ,`field` ,`fieldtitle` ,`ordering` ,`section` ,`fieldfor` ,`published` ,`sys` ,`cannotunpublished` ,`required`)
VALUES (NULL , 'streetaddress', 'Street Address', '24', NULL , '1', '1', '0', '0', '0');

INSERT INTO `#__js_auto_fieldordering` (`id`, `field`, `fieldtitle`, `ordering`, `section`, `fieldfor`, `published`, `sys`, `cannotunpublished`, `required`) VALUES (NULL, 'stocknumber', 'Stock Number', '11', NULL, '1', '1', '0', '0', '0');	
INSERT INTO `#__js_auto_fieldordering` (`id`, `field`, `fieldtitle`, `ordering`, `section`, `fieldfor`, `published`, `sys`, `cannotunpublished`, `required`) VALUES (NULL, 'acceleration', 'Acceleration', '41', NULL, '1', '1', '0', '0', '0'), (NULL, 'maxspeed', 'Max. Speed', '42', NULL, '1', '1', '0', '0', '0');
INSERT INTO `#__js_auto_fieldordering` (`id`, `field`, `fieldtitle`, `ordering`, `section`, `fieldfor`, `published`, `sys`, `cannotunpublished`, `required`) VALUES (NULL, 'bargainprice', 'Bargain Price', '29', NULL, '1', '1', '0', '0', '0'), 
(NULL, 'exportprice', 'Export Price', '30', NULL, '1', '1', '0', '0', '0'),(NULL, 'isdiscount', 'Is Discount', '31', NULL, '1', '1', '0', '0', '0'),(NULL, 'discountstart', 'Discount Start', '32', NULL, '1', '1', '0', '0', '0'),(NULL, 'discountend', 'Discount End', '33', NULL, '1', '1', '0', '0', '0'),
(NULL, 'discounttype', 'Discount Type', '34', NULL, '1', '1', '0', '0', '0'),(NULL, 'discount', 'Discount', '35', NULL, '1', '1', '0', '0', '0');

ALTER TABLE `#__js_auto_vehicles` ADD `speedmetertypeid` INT( 11 ) NOT NULL ;
UPDATE `#__js_auto_fieldordering` SET ordering = ordering +1 WHERE fieldfor =1 AND ordering >9;

INSERT INTO `#__js_auto_fieldordering` (`id` ,`field` ,`fieldtitle` ,`ordering` ,`section` ,`fieldfor` ,`published` ,`sys` ,`cannotunpublished` ,`required`)
VALUES (NULL , 'speedmetertypeid', 'Speed Meter Type', '10', NULL , '1', '1', '0', '0', '0');

UPDATE `#__js_auto_fieldordering` SET ordering = ordering +2 WHERE fieldfor =1 AND ordering >39;
UPDATE `#__js_auto_fieldordering` SET `ordering`='41' WHERE `field`='mileages' AND fieldfor = 1 limit 1;
UPDATE `#__js_auto_fieldordering` SET `ordering`='40' WHERE `field`='speedmetertypeid' AND fieldfor = 1 limit 1;


INSERT INTO `#__js_auto_config` (`configname` ,`configvalue` ,`configfor`) VALUES ('dealer_detailvehiclelisting', '1', 'default'), ('vbshortlistvehicles', '1', 'links');


ALTER TABLE `#__js_auto_vehicles` ADD `co2` FLOAT NOT NULL;

UPDATE `#__js_auto_fieldordering` SET ordering = ordering +1 WHERE fieldfor =1 AND ordering >45;

INSERT INTO `#__js_auto_fieldordering` (`id` ,`field` ,`fieldtitle` ,`ordering` ,`section` ,`fieldfor` ,`published` ,`sys` ,`cannotunpublished` ,`required`)
VALUES (NULL , 'co2', 'CO2 Emission', '46', NULL , '1', '1', '0', '0', '0');



ALTER TABLE `#__js_auto_currency` ADD `code` VARCHAR( 10 ) NOT NULL AFTER `symbol` ;
	UPDATE `#__js_auto_currency` SET `code` = 'PKR' WHERE `title` ='Pakistani Rupee';
	UPDATE `#__js_auto_currency` SET `code` = 'USD' WHERE `title` ='US Doller';
	UPDATE `#__js_auto_currency` SET `code` = 'GBP' WHERE `title` ='Pound Sterling';
	UPDATE `#__js_auto_currency` SET `code` = 'EUR' WHERE `title` ='Euro';

ALTER TABLE  `#__js_auto_vehicles` CHANGE  `price`  `price` DECIMAL( 11 ) NULL DEFAULT NULL;

INSERT INTO  `#__js_auto_config` (`configname` ,`configvalue` ,`configfor`) VALUES ('pricenotation',  '',  'default'), ('pricedecimalpoint',  '0',  'default');



ALTER TABLE `#__js_auto_vehicles` ADD `dealerid` INT( 10 ) NULL AFTER `uid` ;

ALTER TABLE `#__js_auto_vehicles` ADD `soldbyuid` INT( 10 ) NULL AFTER `co2` ,
	ADD `goldvehiclebyuid` INT( 10 ) NULL AFTER `soldbyuid` ,
	ADD `featuredvehiclebyuid` INT( 10 ) NULL AFTER `goldvehiclebyuid` ,
	ADD `isdeleted` TINYINT( 1 ) NULL AFTER `featuredvehiclebyuid` ,
	ADD `deletevehilcebyuid` INT( 10 ) NULL AFTER `isdeleted`;

ALTER TABLE `#__js_auto_vehicles` CHANGE `isdeleted` `isdeleted` TINYINT( 1 ) NOT NULL DEFAULT '0';

INSERT INTO `#__js_auto_config` (`configname` ,`configvalue` ,`configfor`) VALUES ('mymanagerlist', '0', 'links'), ('mymanagerreports', '0', 'links'), ('myaddmanager', '0', 'links'), ('dealermanager_show_captcha', '1', 'default'), ('dealer_show_captcha', '1', 'default');

UPDATE `#__js_auto_fieldordering` SET `fieldtitle` = 'Other Options' WHERE `#__js_auto_fieldordering`.`field` = 'section_userfields';




UPDATE `#__js_auto_config` SET configvalue = '1.0.4' WHERE configname = 'version';
UPDATE `#__js_auto_config` SET configvalue = '104' WHERE configname = 'versioncode';

