<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:		Buruj Solutions
  + Contact:		www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:	April 05, 2012
  ^
  + Project: 		JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');
jimport('joomla.html.pagination');

class JSAutozViewVehicle extends JSAutozView {

    function display($tpl = null) {
        require_once JPATH_COMPONENT_ADMINISTRATOR . '/views/common.php';
        if ($layout == 'formvehicle') {        // form vehicle
            $user = JFactory::getUser();
            $uid = $user->id;
            $cids = JRequest::getVar('cid', array(0), '', 'array');
            $c_id = $cids[0];
            $result = $this->getJSModel('vehicle')->getVehicleforForm($c_id);
            $this->assignRef('vehicleid', $c_id);
            $this->assignRef('vehicle', $result[0]);
            $this->assignRef('vehicleoptions', $result[1]);
            $this->assignRef('lists', $result[2]);
            $this->assignRef('fieldorderings', $result[3]);
            $this->assignRef('fieldorderings_options', $result[4]);
            $this->assignRef('userfields', $result[5]);
            $vehicleuserid = false;
            if (isset($result[0]->uid))
                $vehicleuserid = $result[0]->uid;
            $getsellerinfo = $this->getJSModel('vehiclecontact')->getSellerInfo($vehicleuserid, $c_id);

            $this->assignRef('sellerinfo', $getsellerinfo);

            if (isset($result[0]->id))
                $isNew = false;
            $text = $isNew ? JText::_('Add') : JText::_('Edit');
            JToolBarHelper::title(JText::_('Vehicle') . '<small><small> [' . $text . ']</small></small>', 'vehicles');
            JToolBarHelper::save('vehicle.savevehiclesave', 'SAVE');
            JToolBarHelper::save('vehicle.savevehicle', JText::_('Save Vehicle And Upload Image') );
            if (isset($result[0]->id)) {
                JToolBarHelper::save2copy('vehicle.savevehiclesave2copy');
            }
            if ($isNew)
                JToolBarHelper::cancel('vehicle.cancelvehicle');
            else
                JToolBarHelper::cancel('vehicle.cancelvehicle', 'Close');
            JHTML::_('behavior.formvalidation');
        }elseif ($layout == 'vehicle_details') {
            JToolBarHelper::title(JText::_('Vehicle Detail'), 'vehicledetail');
            $id = JRequest::getVar('id');
            $result = $this->getJSModel('vehicle')->getVehiclebyIds($id);
            $this->assignRef('vehicle', $result);
            $result1 = $this->getJSModel('vehicleimage')->getVehicleImagebyId($id);
            $this->assignRef('vehicleimages', $result1);
            $this->assignRef('layout', $layout);
        } elseif ($layout == 'vehicle_overview') {
            JToolBarHelper::title(JText::_('Vehicle Overview'), 'vehicleoverview');
            $vehicleid = JRequest::getVar('id');
            $result = $this->getJSModel('vehicle')->getVehicleSpecificationbyId($vehicleid);
            $this->assignRef('vehicle', $result);
            $result1 = $this->getJSModel('vehicleimage')->getVehicleImagebyId($vehicleid);
            $this->assignRef('vehicleimages', $result1);
            $userfields = $this->getJSModel('customfield')->getUserFieldsForForm(1, $vehicleid); // job fields , ref id
            $fieldorderings = $this->getJSModel('fieldordering')->getFieldsOrdering(1);
            $fieldorderings_vehicle = $this->getJSModel('fieldordering')->getFieldsOrderingForVehicleOverview(1);
            $this->assignRef('fieldorderings_vehicle', $fieldorderings_vehicle);
            $sellerinfo = $this->getJSModel('vehiclecontact')->getSellerInformation($result->uid, $vehicleid);
            $this->assignRef('sellerinfo', $sellerinfo);
            $this->assignRef('fieldorderings', $fieldorderings);
            $this->assignRef('userfields', $userfields);
            $this->assignRef('layout', $layout);
            $this->assignRef('vehicleid', $vehicleid);
        } elseif ($layout == 'vehicle_specification') {
            JToolBarHelper::title(JText::_('Vehicle Specification'), 'vehiclespecs');
            $vehicleid = JRequest::getVar('id');
            $result = $this->getJSModel('vehicle')->getVehicleSpecificationbyId($vehicleid);
            $this->assignRef('vehicle', $result);
            $result1 = $this->getJSModel('vehicleoption')->getVehicleOverviewbyId($vehicleid);
            $this->assignRef('vehicleoptions', $result1);
            $result2 = $this->getJSModel('vehicleimage')->getVehicleImagebyId($vehicleid);
            $this->assignRef('vehicleimages', $result2);
            $fieldorderings_options = $this->getJSModel('fieldordering')->getFieldsOrdering(2);
            $sellerinfo = $this->getJSModel('vehiclecontact')->getSellerInformation($result->uid, $vehicleid);
            $this->assignRef('sellerinfo', $sellerinfo);
            

            $this->assignRef('vehicleoption', $fieldorderings_options);
            
            $this->assignRef('layout', $layout);
            $this->assignRef('vehicleid', $vehicleid);
        } elseif ($layout == 'vehiclequeue') {                          //vehicle queue
            JToolBarHelper::title(JText::_('Vehicle Approval Queue'), 'vehiclequeue');
            $searchtitle = JRequest::getVar('filter_av_title');
            $searchmakeid = $mainframe->getUserStateFromRequest($option . 'filter_av_makeid', 'filter_av_makeid', '', 'int');
            
            $searchmodelid = $mainframe->getUserStateFromRequest($option . 'filter_av_modelid', 'filter_av_modelid', '', 'int');
            $searchvehicletypeid = $mainframe->getUserStateFromRequest($option . 'filter_av_vehicletypeid', 'filter_av_vehicletypeid', '', 'int');
            $searchconditionid = $mainframe->getUserStateFromRequest($option . 'filter_av_conditionid', 'filter_av_conditionid', '', 'int');
            $result = $this->getJSModel('vehicle')->getAllUnapprovedVehicle($searchtitle, $searchmakeid, $searchmodelid, $searchvehicletypeid, $searchconditionid, $limitstart, $limit);
            //$items = $result[0];
            $total = $result[1];
            if ($total <= $limitstart)
                $limitstart = 0;
            $pagination = new JPagination($total, $limitstart, $limit);
            $this->assignRef('vehicles', $result[0]);
            $this->assignRef('lists', $result[2]);
            JToolBarHelper::cancel('vehicle.cancel');
        }elseif ($layout == 'vehicles') {                          //vehicles
            JToolBarHelper::title(JText::_('Vehicles'), 'vehicles');
            $searchtitle = JRequest::getVar('filter_av_title');
            $searchmakeid = $mainframe->getUserStateFromRequest($option . 'filter_av_makeid', 'filter_av_makeid', '', 'int');
            $searchmodelid = $mainframe->getUserStateFromRequest($option . 'filter_av_modelid', 'filter_av_modelid', '', 'int');
            $searchvehicletypeid = $mainframe->getUserStateFromRequest($option . 'filter_av_vehicletypeid', 'filter_av_vehicletypeid', '', 'int');
            $searchconditionid = $mainframe->getUserStateFromRequest($option . 'filter_av_conditionid', 'filter_av_conditionid', '', 'int');
            $statusid = $mainframe->getUserStateFromRequest($option . 'filter_av_statusid', 'filter_av_statusid', '', 'int');
            $result = $this->getJSModel('vehicle')->getAllVehicle($searchtitle, $searchmakeid, $searchmodelid, $searchvehicletypeid, $searchconditionid, $statusid, $limitstart, $limit);
            //$items = $result[0];
            $total = $result[1];
            if ($total <= $limitstart)
                $limitstart = 0;
            $pagination = new JPagination($total, $limitstart, $limit);
            JToolBarHelper::addNew('vehicle.editvehicle');
            JToolBarHelper::editList('vehicle.editvehicle');
            JToolBarHelper::deleteList(JText::_('Are You Sure To Delete'), 'vehicle.removevehicle');
            $this->assignRef('vehicles', $result[0]);
            $this->assignRef('lists', $result[2]);
        }elseif ($layout == 'view_vehicle') {       // view vehicle
            if (!isset($id))
                $id = '';
            $id = JRequest::getVar('id');
            $result = $this->getJSModel('vehicle')->getVehiclebyId($id);
            $this->assignRef('vehicle', $result[0]);
            $this->assignRef('vehicleoptions', $result[1]);
            $this->assignRef('fieldorderings', $result[2]);
            $this->assignRef('fieldorderings_options', $result[4]);
            JToolBarHelper::title(JText::_('View Vehicles'), 'vehicles');
            JToolBarHelper::addNew();
            JToolBarHelper::editList();
            JToolBarHelper::deleteList();
        }
        $socailsharing = $this->getJSModel('configuration')->getConfiginArray('socailsharing');
        $this->assignRef('socailsharing', $socailsharing);
        $this->assignRef('option', $option);
        $this->assignRef('config', $config);
        $this->assignRef('pagination', $pagination);
        $this->assignRef('uid', $uid);
        parent::display($tpl);
    }

    function getSortArg($type, $sort) {
        $mat = array();
        if (preg_match("/(\w+)(asc|desc)/i", $sort, $mat)) {
            if ($type == $mat[1]) {
                return ( $mat[2] == "asc" ) ? "{$type}desc" : "{$type}asc";
            } else {
                return $type . $mat[2];
            }
        }
        return "iddesc";
    }

}

?>
