/**********************************
Plugin : JS Image Slider
Project : JS Autoz Vehicle images slider in listing
Author : Shoaib Rehmat Ali
Created : 02-Aug-2014
***********************************/

(function( $ ) {
 
    $.fn.jsimgslide = function( options ) {
 
		var settings = $.extend({
            // These are the defaults.
            imgWidth: 335, // default image width
            imgHeight: 188 // default image height
        }, options );

		return this.each(function(){
			var parent = this;
			var imagecounter = 0;
			var totalimages = 0;
			var images = [];
			$(parent).find('div.slides').find('i').each(function(){
				images.push($(this).attr('img'));
				totalimages++;
			});
			var img = $("<img />").attr({'src':images[imagecounter],'id':'jsimgslideimage'})
			    .load(function() {
			        if (!this.complete || typeof this.naturalWidth == "undefined" || this.naturalWidth == 0) {
			            alert('broken image!');
			        } else {
			            $(parent).find('div.slides').prepend(img);
			        }
			});

		    // image height recalculate for the aspect ratio 16:9
		    var r_width = ($(parent).find('div.slides').width() / 16);			
		    settings.imgHeight = r_width * 9;
		    if(settings.imgHeight > 187){
		    	settings.imgHeight = 186;
		    }

			$(parent).width(settings.imgWidth)
					.height(settings.imgHeight)
					.find('div.slides')
					.width(settings.imgWidth)
					.height(settings.imgHeight);

			var leftHandle = $(parent).find('span.js-left');
			var rightHandle = $(parent).find('span.js-right');
			
			$(leftHandle).click(function(e){
				e.preventDefault();
				imagecounter--;
				if(imagecounter < 0){
					imagecounter = totalimages;
					imagecounter--; // zero based index
				}
				var img = $("<img />").attr({'src':images[imagecounter],'id':'jsimgslideimage'})
				    .load(function() {
				        if (!this.complete || typeof this.naturalWidth == "undefined" || this.naturalWidth == 0) {
				            alert('broken image!');
				        } else {
				            $(parent).find('img#jsimgslideimage').replaceWith(img);
				        }
				});
			});

			$(rightHandle).click(function(e){
				e.preventDefault();
				imagecounter++;
				if(imagecounter >= totalimages){
					imagecounter = 0;
				}
				var img = $("<img />").attr({'src':images[imagecounter],'id':'jsimgslideimage'})
				    .load(function() {
				        if (!this.complete || typeof this.naturalWidth == "undefined" || this.naturalWidth == 0) {
				            alert('broken image!');
				        } else {
				            $(parent).find('img#jsimgslideimage').replaceWith(img);
				        }
				});
				
			});
		});
 
    };
 
}( jQuery ));


