/**********************************
Plugin : JS Slider
Project : JS Autoz Vehicle slider
Author : Shoaib Rehmat Ali
Created : 02-Aug-2014
***********************************/

(function( $ ) {
 
    $.fn.jsslider = function( options ) {
 
		var settings = $.extend({
            // These are the defaults.
            imgWidth: 150, // default image width
            imgHeight: 150, // default image height
            marginRight: 5, // left margin of images
            column: 4, // column shows on the slider at a time
            speed: 500, // animation speed
            borderWidth: 2
        }, options );

		return this.each(function(){
			settings.borderWidth = settings.borderWidth * 2;

			var parent = this;
			var totalImages = 0;
			var slideCounter = 1;
			var totalSlides = 0;
			$(parent).find('div.slides').find('img').each(function(){
				$(this).width(settings.imgWidth).css({'height':settings.imgHeight,'margin':'0px '+(settings.marginRight/2)+'px'});
				var data = [];
				data.link = $(this).attr('data-link');
				data.title = $(this).attr('data-title');
				data.model = $(this).attr('data-model');
				data.price = $(this).attr('data-price');
				data.location = $(this).attr('data-location');
				data.conditionColor = $(this).attr('data-conditioncolor');
				data.borderColor = $(this).attr('data-borderColor');
				var dataDiv = $('<div>').css({'position':'absolute','width':settings.imgWidth,'height':settings.imgHeight,'margin':'2px '+((settings.marginRight+settings.borderWidth)/2)+'px','background':'rgba(0,0,0,.55)','opacity':'0'})
										.addClass('resetSize')
										.hover(function(){$(this).animate({'opacity':1},500).prev().css({'border':'2px solid '+$(this).prev().attr('data-borderColor')});},function(){$(this).animate({'opacity':0},500).prev().css({'border':'2px solid #000000'});})
										.append(
											$('<a>').attr('href',data.link).css({'display':'inline-block','width':'100%','height':'100%','text-decoration':'none'})
													.append(
														$('<span>').html(data.title).css({'padding':'5px 0px','border-bottom':'1px solid '+data.borderColor,'color':data.borderColor,'font-weight':'bold','display':'block','margin':'4px 10px 0px 10px'}),
														$('<span>').html(data.model).css({'padding':'5px 0px','color':'#ffffff','display':'block','margin':'4px 10px 0px 10px'}),
														$('<span>').html(data.price).css({'padding':'5px 0px','color':'#ffffff','display':'block','margin':'4px 10px 0px 10px'}),
														$('<span>').html(data.location).css({'padding':'5px 0px','color':'#ffffff','display':'block','margin':'4px 10px 0px 10px'})
													)											
										);
				var div = $('<div>').css({'position':'relative','display':'inline-block','float':'left'}).append($(this).clone()).append(dataDiv);
				$(this).replaceWith(div);
				totalImages++;
			});
			$(parent).find('div.slides').height(settings.imgHeight);
			var totalMargin = (settings.borderWidth + settings.marginRight) * totalImages;
			var totalWidth = totalMargin + (settings.imgWidth * totalImages);
			$(parent).find('div.slides').width(totalWidth);
			
			var frameWidth = $(parent).find('div.frame').width();
			var columnWidth = frameWidth / settings.column;
			
			totalSlides = Math.round(totalWidth / frameWidth);
			if((totalSlides * frameWidth) < totalWidth)
				totalSlides++;
			
			if(columnWidth > ( settings.imgWidth + settings.marginRight )){ // column greater then image
				//var imgRemaing = columnWidth - ( settings.imgWidth + settings.marginRight );
				var imgRemaing = columnWidth - (settings.imgWidth + settings.borderWidth);
				$(parent).find('div.slides').find('img').css({'margin':'0px '+(imgRemaing/2)+'px'}).next('div.resetSize').css({'margin':'0px '+((imgRemaing)/2)+'px'});
				totalWidth = ((columnWidth + settings.borderWidth) * totalImages);
				$(parent).find('div.slides').width(totalWidth);
				totalSlides = Math.round(totalWidth / frameWidth);
				if((totalSlides * frameWidth) < totalWidth)
					totalSlides++;
			}else{ // column is smaller then image
				var widthLeft = columnWidth - (settings.marginRight + settings.borderWidth);
				$(parent).find('div.slides').find('img').each(function(){
					$(this).width(widthLeft).next('div.resetSize').width(widthLeft);
				});
				totalWidth = (widthLeft + settings.marginRight + settings.borderWidth) * totalImages;
				$(parent).find('div.slides').width(totalWidth);
				totalSlides = Math.round(totalWidth / frameWidth);
				if((totalSlides * frameWidth) < totalWidth)
					totalSlides++;
			}
			var leftHandle = $(parent).find('span.js-left');
			var rightHandle = $(parent).find('span.js-right');
			
			$(leftHandle).css({
				'height':settings.imgHeight + 4,
				'line-height':settings.imgHeight+'px',
				'top':0				
			}).click(function(e){
				e.preventDefault();
				if(!$(parent).find('div.slides').is(':animated')){
					var marginLeft = $(parent).find('div.slides').css('marginLeft');
					marginLeft = Math.abs(parseInt(marginLeft));
					if(marginLeft != 0){
						margin = parseInt($(parent).find('div.frame').width()) - marginLeft;
						$(parent).find('div.slides').stop(true,true).animate({'marginLeft':margin},settings.speed,"linear");
						slideCounter--;
					}
				}
			});

			$(rightHandle).css({
				'height':settings.imgHeight + 4,
				'line-height':settings.imgHeight+'px',
				'top':0				
			}).click(function(e){
				e.preventDefault();
				if(!$(parent).find('div.slides').is(':animated')){
					var marginLeft = $(parent).find('div.slides').css('marginLeft');
					marginLeft = Math.abs(parseInt(marginLeft));
					console.log(slideCounter+' '+totalSlides);
					if(slideCounter < totalSlides){
						margin = parseInt($(parent).find('div.frame').width()) + marginLeft;
						$(parent).find('div.slides').stop(true,true).animate({'marginLeft':"-"+margin},settings.speed,"linear");
						slideCounter++;
					}
				}
			});
		});
 
    };
 
}( jQuery ));

