<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:		www.burujsolutions.com , info@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');
jimport('joomla.html.parameter');

class JSAutozModelCity extends JSAutozModel {

    function __construct() {
        parent::__construct();
    }

    function getCityNameById($cityid) {
        if (!is_numeric($cityid))
            return false;
        $db = JFactory::getDBO();
        $query = "SELECT city.name AS cityname FROM `#__js_auto_cities` AS city WHERE city.id = " . $cityid;
        $db->setQuery($query);
        $result['cityname'] = $db->loadResult();
        $result['cityid'] = $cityid;
        return $result;
    }

    function getCityIdByName($cityname) {
        $db = JFactory::getDBO();
        $query = "SELECT city.id AS cityid FROM `#__js_auto_cities` AS city WHERE LOWER(city.id) = " . $db->quote($cityname);
        $db->setQuery($query);
        $result['cityid'] = $db->loadResult();
        $result['cityname'] = $cityname;
        return $result;
    }

    function getVehiclebyCities() {
        $db = $this->getDBO();
        $config = $this->getJSModel('configuration')->getConfig('default');
        $query = "SELECT city.id AS cityid, city.name AS cityname, COUNT(vehicle.id) AS totalvehiclelbycity
                    FROM `#__js_auto_vehicles` AS vehicle
                    JOIN `#__js_auto_cities` AS city ON city.id = vehicle.loccity
                    JOIN `#__js_auto_countries` AS country ON country.id = city.countryid
                    WHERE country.enabled = 1 AND vehicle.status = 1 AND vehicle.addexpiryvalue >= CURDATE() 
                    GROUP BY cityname";
        $db->setQuery($query);
        $vehiclebycity = $db->loadObjectList();
        return $vehiclebycity;
    }

    function getCities($stateid, $title) {
        if (!is_numeric($stateid))
            return false;
        $db = JFactory::getDBO();
        $query = "SELECT * FROM `#__js_auto_cities` WHERE enabled = 'Y' AND stateid = " . $stateid . " ORDER BY name ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $cities = array();
        if ($title)
            $cities[] = array('value' => JText::_(''), 'text' => $title);
        else
            $cities[] = array('value' => JText::_(''), 'text' => JText::_('Choose City'));

        foreach ($rows as $row) {
            $cities[] = array('value' => $row->id, 'text' => JText::_($row->name));
        }
        return $cities;
    }

    function getAddressDataByCityName($cityname, $id = 0) {
        $db = JFactory::getDbo();
        $config = $this->getJSModel('configuration')->getConfiginArray('default');
        $query = "SELECT concat(city.name";
        switch ($config['defaultaddressdisplaytype']) {
            case 'csc'://City, State, Country
                $query .= " ,', ', (IF(state.name is not null,state.name,'')),IF(state.name is not null,', ',''),country.name)";
                break;
            case 'cs'://City, State
                $query .= " ,', ', (IF(state.name is not null,state.name,'')))";
                break;
            case 'cc'://City, Country
                $query .= " ,', ', country.name)";
                break;
            case 'c'://city by default select for each case
                $query .= ")";
                break;
        }

        $query .= " AS name, city.id AS id
                        FROM `#__js_auto_cities` AS city  
                        JOIN `#__js_auto_countries` AS country on city.countryid=country.id
                        LEFT JOIN `#__js_auto_states` AS state on city.stateid=state.id";
        if ($id == 0)
            $query .= " WHERE city.name LIKE '" . $cityname . "%' AND country.enabled = 1 AND city.enabled = 1 LIMIT 10";
        elseif (is_numeric($id))
            $query .= " WHERE city.id = $id AND country.enabled = 1 AND city.enabled = 1";
        $db->setQuery($query);
        $result = $db->loadObjectList();
        if (empty($result))
            return null;
        else
            return $result;
    }

    function mpGetVehiclebyCities($showcityhavevehicles = 0, $noofrecord = 20) {
        $db = $this->getDBO();
        $defaultcountry = '';
        $havingquery = '';
        if ($showcityhavevehicles == 0) {
            $query = "SELECT configvalue FROM `#__js_auto_config` WHERE configname = 'defaultcountry'";
            $db->setQuery($query);
            $defaultcountry = $db->loadResult();
            $defaultcountry = ' AND city.countryid = ' . $defaultcountry . ' ';
        } elseif ($showcityhavevehicles == 1) {
            $havingquery = " HAVING totalvehiclelbycity > 0 ";
        }
        $config = $this->getJSModel('configuration')->getConfig('default');
        $show_sold_vehicle = '';

        $query = "SELECT city.id AS cityid, city.name AS cityname, COUNT(vehicle.id) AS totalvehiclelbycity
                    FROM `#__js_auto_cities` AS city
                    LEFT JOIN `#__js_auto_countries` AS country ON country.id = city.countryid 
                    LEFT JOIN `#__js_auto_vehicles` AS vehicle ON vehicle.loccity = city.id AND vehicle.addexpiryvalue >= CURDATE()
                    WHERE country.enabled = 1 $defaultcountry " . $show_sold_vehicle . "
                    GROUP BY cityname $havingquery ORDER BY totalvehiclelbycity DESC, cityname ASC";

        $db->setQuery($query, 0, $noofrecord);
        $vehiclebycity = $db->loadObjectList();
        return $vehiclebycity;
    }

    function getMultiCityDataForView($id) {
        if (!is_numeric($id)) return false;
        $db = $this->getDBO();
        $query = "select mcity.id AS id,country.name AS countryName,city.name AS cityName,state.name AS stateName";
        $query.=" FROM `#__js_auto_request_vehicles_cities` AS mcity";
        $query.=" LEFT JOIN `#__js_auto_cities` AS city ON mcity.loccityid=city.id
                LEFT JOIN `#__js_auto_states` AS state ON city.stateid=state.id
                LEFT JOIN `#__js_auto_countries` AS country ON city.countryid=country.id";
        $query.=" where mcity.requestvehicleid=" . $id;
        $query.=" ORDER BY country.name";
        $db->setQuery($query);
        $cities = $db->loadObjectList();
        $mloc = array();
        $mcountry = array();
        $finalloc = "";
        // this function has been changed.
        
        foreach ($cities AS $d) {
            $mcountry[$d->countryName][] = array('cityName' => $d->cityName, 'statename' => $d->stateName);
        }
        foreach ($mcountry AS $countryname => $locdata) {
            $call = 0;
            foreach ($locdata AS $dl) {
                if ($call == 0) {
                    $finalloc .= '[' . $dl['cityName'];
                    if ($dl['statename']) {
                        $finalloc .= '-' . $dl['statename'];
                    }
                } else {
                    $finalloc .= ', ' . $dl['cityName'];
                    if ($dl['statename']) {
                        $finalloc .= '-' . $dl['statename'];
                    }
                }
                $call++;
            }
            $finalloc .= ', ' . $countryname . '] ';
        }


        return $finalloc;
    }

}

?>