<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:		www.burujsolutions.com , info@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');
jimport('joomla.html.parameter');

class JSAutozModelCondition extends JSAutozModel {

    function __construct() {
        parent::__construct();
    }

    function getVehiclesConditionForFilter($title) {
        $db = JFactory::getDBO();
        $query = "SELECT  id, title FROM `#__js_auto_conditions` WHERE status = 1 ORDER BY title ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $conditions = array();
        if ($title)
            $conditions [] = array('value' => -1, 'text' => JText::_($title));
        foreach ($rows as $row) {
            $conditions [] = array('value' => $row->id, 'text' => JText::_($row->title));
        }
        return $conditions;
    }

    function getVehiclesCondition() {
        $title = 'Any';
        $db = JFactory::getDBO();
        $query = "SELECT  id, title FROM `#__js_auto_conditions` WHERE status = 1 ORDER BY title ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $conditions = array();
        if ($title)
            $conditions [] = array('value' => JText::_(''), 'text' => JText::_($title));
        foreach ($rows as $row) {
            $conditions [] = array('value' => $row->id, 'text' => JText::_($row->title));
        }
        return $conditions;
    }

    function getVehiclesbyConditions() {
        $db = $this->getDBO();
        $config = $this->getJSModel('configuration')->getConfig('default');
        $show_sold_vehicle = '';

        $inquery = " (SELECT COUNT(vehicle.vehicletypeid) from `#__js_auto_vehicles`  AS vehicle
                        WHERE vehicle.conditionid = vcondition.id AND vehicle.status = 1 AND vehicle.isdeleted <> 1 AND vehicle.addexpiryvalue  >= CURDATE() " . $show_sold_vehicle . " ) AS totalvehiclebycondition";

        $query = "SELECT  DISTINCT vcondition.id AS vehicletype, vcondition.title AS title, ";
        $query .= $inquery;
        $query .= " FROM `#__js_auto_conditions` AS vcondition
                    WHERE vcondition.status = 1 
                    ORDER BY vcondition.title ";
                    
        $db->setQuery($query);
        $vehicletypes = $db->loadObjectList();
        return $vehicletypes;
    }

    function getConditionTitleById($conditionid) {
        $row = $this->getTable('condition');
        if (!$row->load($conditionid))
            return false;
        return $row->title;
    }

    function getConditionForCombo($title) {
        $db = JFactory::getDBO();
        $query = "SELECT vcondition.id AS conditionid, vcondition.title AS conditiontitle FROM `#__js_auto_conditions` AS vcondition WHERE vcondition.status= 1 ORDER BY conditiontitle ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $conditions[] = array('value' => '0', 'text' => $title);

        foreach ($rows as $row) {
            $conditions[] = array('value' => $row->conditionid, 'text' => JText::_($row->conditiontitle));
        }
        return $conditions;
    }

    function mpGetVehicleByConditions() {
        $db = $this->getDBO();
        $config = $this->getJSModel('configuration')->getConfig('default');
        $show_sold_vehicle = '';
        $inquery = " (SELECT COUNT(vehicle.id) from `#__js_auto_vehicles` AS vehicle
                        WHERE vehicle.status = 1 AND vehicle.addexpiryvalue  >= CURDATE() AND vcondition.id = vehicle.conditionid " . $show_sold_vehicle . " ) AS totalvehiclelbycondition ";

        $query = "SELECT DISTINCT vcondition.id AS vehicletype, vcondition.title AS maketitle,";
        $query .= $inquery;
        $query .= " FROM `#__js_auto_conditions` AS vcondition
                    LEFT JOIN `#__js_auto_vehicles` AS vehicle ON (vcondition.id = vehicle.conditionid " . $show_sold_vehicle . ")
                    ORDER BY maketitle ";
        $db->setQuery($query);
        $vehicles = $db->loadObjectList();
        return $vehicles;
    }

}

?>
