<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:		www.burujsolutions.com , info@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');
jimport('joomla.html.parameter');

class JSAutozModelMake extends JSAutozModel {

    function __construct() {
        parent::__construct();
    }

    function getMakeTitleById($id) {             //getVehicleModelforForm
        if (!is_numeric($id))
            return false;
        $db = $this->getDBO();
        $query = "SELECT make.title FROM `#__js_auto_makes` AS make WHERE make.id = " . $id;

        $db->setQuery($query);
        $make = $db->loadObject();
        if (isset($make))
            return $make->title;
        else
            return '';
    }

    function getVehiclesbyMake($show_sold_vehicles, $vehicletype, $makeid, $sortvalue, $sortorder, $limitstart, $limit) {
        if ($vehicletype)
            if (!is_numeric($vehicletype))
                return false;
        if ($makeid)
            if (!is_numeric($makeid))
                return false;
        $db = $this->getDBO();
        $result = array();
        $query = "SELECT SQL_CALC_FOUND_ROWS COUNT(DISTINCT  vehicles.id)  id
                    FROM #__js_auto_vehicles AS vehicles
                    WHERE vehicles.status = 1 AND vehicles.addexpiryvalue >= CURDATE()";
        if ($vehicletype == 1) {
            $query.=" AND vehicles.conditionid=" . $vehicletype;
        }
        if ($vehicletype == 2) {
            $query.=" AND vehicles.conditionid=" . $vehicletype;
        }
        $query.=" AND vehicles.makeid = " . $makeid;

        $db->setQuery($query);

        $totalresult = $db->loadResult();
        if ($totalresult <= $limitstart)
            $limitstart = 0;
        $query = "SELECT vehicles.id,vehicles.title,vehicles.price,vehicles.created,
                    vehicles.id,vehicles.title,
                    vehicles.exteriorcolor,vehicles.enginecapacity,vehicletypes.title AS vehicletitle,
                    vehicles.loccountry AS country,vehicles.locstate AS state,vehicles.loccity AS city,
                    country.name AS countryname,state.name AS statename,city.name AS cityname,
                    makes.title maketitle,models.title AS modeltitle,modelyear.title AS modelyeartitle,
                    fueltype.title AS fueltitle,cylinder.title AS cylindertitle ,
                    conditions.title AS conditiontitle, cat.title AS cattitle , image.filename AS vehiclelogo,currency.symbol AS currency
                    FROM `#__js_auto_vehicles` AS vehicles
                    LEFT JOIN `#__js_auto_vehicleimages` AS image ON vehicles.id= image.vehicleid AND image.isdefault = 1
                    LEFT JOIN `#__js_auto_vehicletypes` AS vehicletypes ON vehicles.vehicletypeid = vehicletypes.id
                    LEFT JOIN `#__js_auto_makes` AS makes ON vehicles.makeid =makes.id
                    LEFT JOIN `#__js_auto_models` AS models ON vehicles.modelid =  models.id
                    LEFT JOIN `#__js_auto_categories` AS cat ON vehicles.categoryid =  cat.id
                    LEFT JOIN `#__js_auto_modelyears` AS modelyear ON vehicles.modelyearid = modelyear.id
                    LEFT JOIN `#__js_auto_conditions` AS conditions ON vehicles.conditionid = conditions.id
                    LEFT JOIN `#__js_auto_fueltypes` AS fueltype ON vehicles.fueltypeid = fueltype.id
                    LEFT JOIN `#__js_auto_cylinders` AS cylinder ON vehicles.cylinderid = cylinder.id
                    LEFT JOIN `#__js_auto_currency` AS currency ON vehicles.currencyid = currency.id
                    LEFT JOIN `#__js_auto_cities` AS city ON vehicles.loccity = city.id
                    LEFT JOIN `#__js_auto_countries` AS country ON city.countryid = country.id
                    LEFT JOIN `#__js_auto_states` AS state ON city.stateid = state.id
                    WHERE vehicles.status = 1 AND vehicles.addexpiryvalue >= CURDATE()";
        if ($vehicletype == 1) {
            $query.=" AND vehicles.conditionid=" . $vehicletype;
        }
        if ($vehicletype == 2) {
            $query.=" AND vehicles.conditionid=" . $vehicletype;
        }
        $query.=" AND vehicles.makeid = " . $makeid . " GROUP BY vehicles.id ORDER BY " . $sortvalue . " " . $sortorder;

        $db->setQuery($query, $limitstart, $limit);
        $result[0] = $db->loadObjectList();
        $result[1] = $totalresult;
        return $result;
    }

    function getVehicleMakeTitle($makeid) {
        if (!is_numeric($makeid))
            return false;
        $db = $this->getDBO();
        $query = "SELECT make.* FROM `#__js_auto_makes` AS make WHERE  make.id = " . $makeid;
        $db->setQuery($query);
        $vehiclemake = $db->loadObject();
        return $vehiclemake;
    }

    function getVehiclebyMakesModels($vehicletype) {

        if ($vehicletype)
            if (!is_numeric($vehicletype))
                return false;
        $db = $this->getDBO();
        $inquery = " (SELECT COUNT(vehicle.makeid) FROM `#__js_auto_vehicles`  AS vehicle";
        if ($vehicletype == 1) {
            $inquery .=" WHERE vehicle.conditionid=" . $vehicletype . " AND vehicle.makeid = make.id AND vehicle.status = 1 AND vehicle.isdeleted <> 1 AND vehicle.addexpiryvalue  >= CURDATE() ) AS totalvehiclemake ,";
        } elseif ($vehicletype == 2) {
            $inquery .=" WHERE vehicle.conditionid=" . $vehicletype . " AND vehicle.makeid = make.id AND vehicle.status = 1 AND vehicle.isdeleted <> 1 AND vehicle.addexpiryvalue  >= CURDATE() ) AS totalvehiclemake ,";
        } else {
            $inquery .=" WHERE vehicle.makeid = make.id AND vehicle.addexpiryvalue  >= CURDATE() AND vehicle.status = 1 AND vehicle.isdeleted <> 1 ) AS totalvehiclemake ,";
        }
        $inquery .="(SELECT COUNT(vehicle.modelid) FROM `#__js_auto_vehicles` AS vehicle";
        if ($vehicletype == 1) {
            $inquery .=" WHERE vehicle.conditionid=" . $vehicletype . " AND vehicle.modelid = model.id AND vehicle.status = 1 AND vehicle.isdeleted <> 1 AND vehicle.addexpiryvalue  >= CURDATE() ) AS totalvehiclemodel";
        } elseif ($vehicletype == 2) {
            $inquery .=" WHERE vehicle.conditionid=" . $vehicletype . " AND vehicle.modelid = model.id AND vehicle.status = 1 AND vehicle.isdeleted <> 1 AND vehicle.addexpiryvalue  >= CURDATE() ) AS totalvehiclemodel";
        } else {
            $inquery .=" WHERE vehicle.modelid = model.id AND vehicle.isdeleted <> 1 AND vehicle.status = 1 AND vehicle.addexpiryvalue  >= CURDATE() ) AS totalvehiclemodel";
        }
        $query = "SELECT   make.id AS makeid, make.title AS maketitle ,make.logo AS logo, model.id AS modelid,model.title AS modeltitle ,";
        $query .= $inquery;
        $config = $this->getJSModel('configuration')->getConfig('default');
        $show_sold_vehicle = '';

        $query .= " FROM `#__js_auto_makes` AS make
        LEFT JOIN `#__js_auto_models`  AS model ON make.id = model.makeid
        LEFT JOIN `#__js_auto_vehicles` AS vehicle ON (make.id = vehicle.makeid AND model.id = vehicle.modelid " . $show_sold_vehicle . ")
         GROUP BY model.id ORDER BY make.id ASC ";

        $db->setQuery($query);
        $vehiclemakes = $db->loadObjectList();
        return $vehiclemakes;
    }

    function getVehiclebyMakesModelsNotTotal($vehicletype) {
        if ($vehicletype)
            if (!is_numeric($vehicletype))
                return false;
        $db = $this->getDBO();
        $config = $this->getJSModel('configuration')->getConfig('default');
        $show_sold_vehicle = '';

        $query = "SELECT   make.id AS makeid,make.logo AS logo, make.title AS maketitle , model.id AS modelid,model.title AS modeltitle 
                    FROM `#__js_auto_makes` AS make
                    LEFT JOIN `#__js_auto_models`  AS model ON make.id = model.makeid
                    LEFT JOIN `#__js_auto_vehicles`  AS vehicle ON (make.id = vehicle.makeid AND model.id = vehicle.modelid " . $show_sold_vehicle . " ";
        if ($vehicletype == 1) {
            $query.=" AND vehicle.status <> 0 AND vehicle.addexpiryvalue  >= CURDATE() AND vehicle.conditionid=" . $vehicletype . " ) GROUP BY model.id ";
        } elseif ($vehicletype == 2) {
            $query.=" AND vehicle.status <> 0 AND vehicle.addexpiryvalue  >= CURDATE() AND vehicle.conditionid=" . $vehicletype . " ) GROUP BY model.id ";
        } else {
            $query.=" AND vehicle.status <> 0 AND vehicle.addexpiryvalue  >= CURDATE() ) GROUP BY model.id ";
        }
        $db->setQuery($query);
        $vehiclemakes = $db->loadObjectList();
        return $vehiclemakes;
    }

    function getVehiclebyMakes($vehicletype) {
        if ($vehicletype){
            if (!is_numeric($vehicletype))
                return false;
            $vehicletype = "AND vehicle.conditionid = ".$vehicletype;
        }else{
            $vehicletype = '';
        }
        $db = $this->getDBO();
        $config = $this->getJSModel('configuration')->getConfig('default');
        $show_sold_vehicle = '';

        $query = "SELECT make.id AS makeid,make.logo AS logo, make.title AS maketitle ,count(vehicle.id) AS totalvehiclemake
                    FROM `#__js_auto_makes` AS make 
                    LEFT JOIN `#__js_auto_vehicles` as vehicle on ( vehicle.makeid = make.id AND date(vehicle.addexpiryvalue) > curdate() $vehicletype and vehicle.makeid = make.id and vehicle.status = 1 " . $show_sold_vehicle . " )
                    GROUP BY make.id ";
        $db->setQuery($query);
        $vehiclemakes = $db->loadObjectList();
        return $vehiclemakes;
    }

    function mpGetNewVehicleByMake() {
        $db = $this->getDBO();
        $config = $this->getJSModel('configuration')->getConfig('default');
        $show_sold_vehicle = '';

        $inquery = " (SELECT COUNT(vehicle.id) from `#__js_auto_vehicles` AS vehicle
                        WHERE vehicle.status = 1 AND vehicle.addexpiryvalue  >= CURDATE() AND make.id = vehicle.makeid AND vehicle.conditionid = 1 " . $show_sold_vehicle . " ) AS totalnewusedvehiclelbymake ";

        $query = "SELECT DISTINCT make.id AS makeid, make.title AS maketitle,";
        $query .= $inquery;
        $query .= " FROM `#__js_auto_makes` AS make LEFT JOIN `#__js_auto_vehicles`  AS vehicle ON make.id = vehicle.makeid";
        $query .= " ORDER BY maketitle ";
        $db->setQuery($query);
        $make = $db->loadObjectList();
        return $make;
    }

    function mpGetUsedVehicleByMake() {
        $db = $this->getDBO();
        $config = $this->getJSModel('configuration')->getConfig('default');
        $show_sold_vehicle = '';

        $inquery = " (SELECT COUNT(vehicle.id) from `#__js_auto_vehicles` AS vehicle
                        WHERE vehicle.status = 1 AND vehicle.addexpiryvalue  >= CURDATE() AND make.id = vehicle.makeid AND vehicle.conditionid = 2 " . $show_sold_vehicle . ") AS totalnewusedvehiclelbymake ";

        $query = "SELECT DISTINCT make.id AS makeid, make.title AS maketitle,";
        $query .= $inquery;
        $query .= " FROM `#__js_auto_makes` AS make LEFT JOIN `#__js_auto_vehicles` AS vehicle ON make.id = vehicle.makeid";
        $query .= " ORDER BY maketitle ";
        $db->setQuery($query);
        $usemake = $db->loadObjectList();
        return $usemake;
    }

    function mpGetNewUsedVehicleByMake() {
        $db = $this->getDBO();
        $config = $this->getJSModel('configuration')->getConfig('default');
        $show_sold_vehicle = '';
        $inquery = " (SELECT COUNT(vehicle.id) from `#__js_auto_vehicles` AS vehicle
                    WHERE vehicle.status = 1 AND vehicle.addexpiryvalue  >= CURDATE() AND make.id = vehicle.makeid " . $show_sold_vehicle . " ) AS totalnewusedvehiclelbymake ";

        $query = "SELECT DISTINCT make.id AS makeid, make.title AS maketitle,";
        $query .= $inquery;
        $query .= " FROM `#__js_auto_makes` AS make LEFT JOIN `#__js_auto_vehicles` AS vehicle ON make.id = vehicle.makeid";
        $query .= " ORDER BY maketitle ";
        $db->setQuery($query);
        $newusemake = $db->loadObjectList();
        return $newusemake;
    }

//end module and plugin
    function getVehiclesMakes($title = false) {
        $db = JFactory::getDBO();
        $query = "SELECT  id, title FROM `#__js_auto_makes` WHERE status = 1 ORDER BY title ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $makes = array();
        if ($title) {
            $makes[] = array('value' => JText::_(''), 'text' => JText::_($title));
        } else {
            $makes[] = array('value' => "0", 'text' => JText::_('All'));
        }

        foreach ($rows as $row) {
            $makes[] = array('value' => $row->id, 'text' => JText::_($row->title));
        }
        return $makes;
    }

    function mpGetVehicleByMakesModels($condition) {
        $db = $this->getDBO();
        switch ($condition) {
            case 1:
                $makecondition = "AND makevehicle.conditionid = 1 ";
                $modelcondition = "AND modelvehicle.conditionid = 1 ";
                break;
            case 2:
                $makecondition = "AND makevehicle.conditionid = 2 ";
                $modelcondition = "AND modelvehicle.conditionid = 2 ";
                break;
            case 3:
                $makecondition = "";
                $modelcondition = "";
                break;
        }
        $config = $this->getJSModel('configuration')->getConfig('default');
        $show_sold_vehicle = '';
        $show_make_vehicle = "";
        $show_model_vehicle = "";

        $inquery = " (SELECT COUNT(makevehicle.id) from `#__js_auto_vehicles` AS makevehicle
        		WHERE makevehicle.status = 1 AND makevehicle.addexpiryvalue  >= CURDATE() AND makevehicle.isdeleted <> 1 AND make.id = makevehicle.makeid " . $makecondition . " " . $show_make_vehicle . " ) AS totalvehiclebymake, ";

        $inquery .= " (SELECT COUNT(modelvehicle.id) from `#__js_auto_vehicles` AS modelvehicle
        		WHERE modelvehicle.status = 1 AND modelvehicle.addexpiryvalue  >= CURDATE() AND modelvehicle.isdeleted <> 1 AND model.id = modelvehicle.modelid " . $modelcondition . " " . $show_model_vehicle . " ) AS totalvehiclebymodel, ";

        $inquery .= " (SELECT COUNT(tempmodel.id) from `#__js_auto_models` AS tempmodel WHERE tempmodel.makeid = make.id) AS totalmodelformake ";

        $query = "SELECT make.id AS makeid, make.title AS maketitle,model.id AS modelid,model.title AS modeltitle,";
        $query .= $inquery;
        $query .= " FROM `#__js_auto_makes` AS make
                    LEFT JOIN `#__js_auto_models` AS model ON make.id = model.makeid
                    ORDER BY maketitle ";
        $db->setQuery($query);
        $makes = $db->loadObjectList();
        $tempmake = "";
        $totalvehiclebymake = 0;
        $makes_array = array();
        $models_array = array();
        foreach ($makes AS $make) {
            if ($tempmake != $make->maketitle) {
                if ($tempmake != "")
                    $makes_array[] = array($tempmake, $totalvehiclebymake, $models_array, $tempmakeid);
                $tempmake = $make->maketitle;
                $tempmakeid = $make->makeid;
                $totalvehiclebymake = $make->totalvehiclebymake;
                $models_array = array();
            }
            $model_temp_array[0] = $make->modeltitle;
            $model_temp_array[1] = $make->totalvehiclebymodel;
            $model_temp_array[2] = $make->modelid;
            $models_array[] = $model_temp_array;
        }
        return $makes_array;
    }

    function storeVehicleMake($data) {                //store Vehicle Make
        $row = $this->getTable('vehiclemake');
        $result = array();
        $data['status'] = 1; //by default active
        if ($_FILES['logo']['size'] > 0) { // logo
            $data['logo'] = str_replace(' ', '-', $_FILES['logo']['name']); // file name
        }
        //for alias apply rule
        if (!empty($data['alias']))
            $makealias = $data['alias'];
        else
            $makealias = $data['title'];

        $makealias = strtolower(str_replace(' ', '-', $makealias));
        $data['alias'] = $makealias;

        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        if ($data['id'] == '') { // only for new
            $result1 = $this->isVehicleMakeExist($data['title']);
            if ($result1 == 1) {
                return 3;
            }
        }
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        $makeid = $row->id;
        if ($_FILES['logo']['size'] > 0) { // logo
            $returnvalue = $this->uploadVehicleMakeLogo($makeid, 0);
            if ($returnvalue == 1)
                return true;
            else
                return 5;
        }else {
            return true;
        }
    }

}

?>
