<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:		www.burujsolutions.com , info@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');
jimport('joomla.html.parameter');

class JSAutozModelModel extends JSAutozModel {

    function __construct() {
        parent::__construct();
    }

    function getModelTitleById($id) {             //getVehicleModelforForm
        if (!is_numeric($id))
            return false;
        $db = $this->getDBO();
        $query = "SELECT model.title FROM `#__js_auto_models` AS model WHERE model.id = " . $id;

        $db->setQuery($query);
        $model = $db->loadObject();
        if (isset($model))
            return $model->title;
        else
            return '';
    }

    function listVehicleQuickModels($val) {
        $db = $this->getDBO();
        if ($val)
            if (is_numeric($val) == false)
                return false;
        $query = "SELECT id, title FROM `#__js_auto_models`  WHERE status = 1 AND makeid = " . $val . " ORDER BY title ASC";
        $db->setQuery($query);
        $result = $db->loadObjectList();
        if (empty($result)) {
            $return_value = "<input class='inputboxrequired' type='text' id='md' name='md' size='25' maxlength='100'  />";
        } else {
            $return_value = "<select id='md' name='md' class='inputbox jsautoz-cbo'  >\n";
            $return_value .= "<option value='0'>" . JText::_('Select Model') . "</option>\n";
            foreach ($result as $row) {
                $return_value .= "<option value=\"$row->id\" >$row->title</option> \n";
            }
            $return_value .= "</select>\n";
        }
        return $return_value;
    }

    function listVehicleFilterModels($val) {
        $db = $this->getDBO();
        if ($val)
            if (is_numeric($val) == false)
                return false;
        $query = "SELECT id, title FROM `#__js_auto_models`  WHERE status = 1 AND makeid = " . $val . " ORDER BY title ASC";
        $db->setQuery($query);
        $result = $db->loadObjectList();
        if (empty($result)) {
            $return_value = "<input class='inputbox required jsautoz-inputbox' type='text' id='fmd' name='fmd' size='25' maxlength='100'  />";
        } else {
            $return_value = "<select id='fmd' class='jsautoz-cbo' name='fmd'  >\n";
            $return_value .= "<option value='0'>" . JText::_('Select Model') . "</option>\n";
            foreach ($result as $row) {
                $return_value .= "<option value=\"$row->id\" >$row->title</option> \n";
            }
            $return_value .= "</select>\n";
        }
        return $return_value;
    }

    function getVehiclesbyModel($show_sold_vehicles, $vehicletype, $modelid, $sortvalue, $sortorder, $limitstart, $limit) {
        if ($vehicletype)
            if (!is_numeric($vehicletype))
                return false;
        if ($modelid)
            if (!is_numeric($modelid))
                return false;
        $db = $this->getDBO();
        $result = array();
        $query = "SELECT SQL_CALC_FOUND_ROWS COUNT(DISTINCT  vehicles.id)  id
                    FROM #__js_auto_vehicles AS vehicles
                    WHERE vehicles.status = 1 AND vehicles.addexpiryvalue >= CURDATE()";
        if ($vehicletype == 1) {
            $query.=" AND vehicles.conditionid=" . $vehicletype;
        }
        if ($vehicletype == 2) {
            $query.=" AND vehicles.conditionid=" . $vehicletype;
        }
        $query.=" AND vehicles.modelid = " . $modelid;

        $db->setQuery($query);

        $totalresult = $db->loadResult();
        if ($totalresult <= $limitstart)
            $limitstart = 0;
        $query = "SELECT vehicles.id,vehicles.title,vehicles.price,vehicles.created,
                    vehicles.id,vehicles.title,
                    vehicles.exteriorcolor,vehicles.enginecapacity,vehicletypes.title AS vehicletitle,
                    vehicles.loccountry AS country,vehicles.locstate AS state,vehicles.loccity AS city,
                    country.name AS countryname,state.name AS statename,city.name AS cityname,
                    makes.title maketitle,models.title AS modeltitle,modelyear.title AS modelyeartitle,
                    fueltype.title AS fueltitle,cylinder.title AS cylindertitle ,
                    conditions.title AS conditiontitle, cat.title AS cattitle , image.filename AS vehiclelogo ,currency.symbol AS currency
                    FROM `#__js_auto_vehicles` AS vehicles
                    LEFT JOIN `#__js_auto_vehicleimages` AS image ON vehicles.id= image.vehicleid AND image.isdefault = 1
                    LEFT JOIN `#__js_auto_vehicletypes` AS vehicletypes ON vehicles.vehicletypeid = vehicletypes.id
                    LEFT JOIN `#__js_auto_makes` AS makes ON vehicles.makeid =makes.id
                    LEFT JOIN `#__js_auto_models` AS models ON vehicles.modelid =  models.id
                    LEFT JOIN `#__js_auto_categories` AS cat ON vehicles.categoryid =  cat.id
                    LEFT JOIN `#__js_auto_modelyears` AS modelyear ON vehicles.modelyearid = modelyear.id
                    LEFT JOIN `#__js_auto_conditions` AS conditions ON vehicles.conditionid = conditions.id
                    LEFT JOIN `#__js_auto_fueltypes` AS fueltype ON vehicles.fueltypeid = fueltype.id
                    LEFT JOIN `#__js_auto_currency` AS currency ON vehicles.currencyid = currency.id
                    LEFT JOIN `#__js_auto_cylinders` AS cylinder ON vehicles.cylinderid = cylinder.id
                    LEFT JOIN `#__js_auto_cities` AS city ON vehicles.loccity = city.id
                    LEFT JOIN `#__js_auto_countries` AS country ON city.countryid = country.id
                    LEFT JOIN `#__js_auto_states` AS state ON city.stateid = state.id
                    WHERE vehicles.status = 1 AND vehicles.addexpiryvalue >= CURDATE()";
        if ($vehicletype == 1) {
            $query.=" AND vehicles.conditionid=" . $vehicletype;
        }
        if ($vehicletype == 2) {
            $query.=" AND vehicles.conditionid=" . $vehicletype;
        }

        $query.=" AND vehicles.modelid = " . $modelid . " GROUP BY vehicles.id ORDER BY " . $sortvalue . " " . $sortorder;

        $db->setQuery($query, $limitstart, $limit);
        $result[0] = $db->loadObjectList();
        $result[1] = $totalresult;
        return $result;
    }

    function getVehicleModelTitle($modelid) {
        if (!is_numeric($modelid))
            return false;
        $db = $this->getDBO();
        $query = "SELECT model.* FROM `#__js_auto_models` AS model WHERE  model.id = " . $modelid;
        $db->setQuery($query);
        $vehiclemodel = $db->loadObject();
        return $vehiclemodel;
    }

    function getVehiclebyModels() {
        $db = $this->getDBO();
        $config = $this->getJSModel('configuration')->getConfig('default');
        $show_sold_vehicle = '';
        $inquery = " (SELECT COUNT(vehicle.modelid) from `#__js_auto_vehicles` AS vehicle
                        WHERE vehicle.modelid = model.id AND vehicle.addexpiryvalue  >= CURDATE() " . $show_sold_vehicle . " ) AS totalvehiclemodel";

        $query = "SELECT  DISTINCT model.id, model.title, ";
        $query .= $inquery;
        $query .= " FROM `#__js_auto_models` AS model
                    LEFT JOIN `#__js_auto_vehicles`  AS vehicle ON model.id = vehicle.modelid
                    WHERE model.status = 1 ORDER BY model.title ";
        $db->setQuery($query);
        $vehiclemakes = $db->loadObjectList();
        return $vehiclemakes;
    }

    function getVehiclesModel($title) {
        $db = JFactory::getDBO();
        $query = "SELECT  id, title FROM `#__js_auto_models` WHERE status = 1  ORDER BY title ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $models = array();
        if ($title)
            $models[] = array('value' => JText::_(''), 'text' => $title);
        foreach ($rows as $row) {
            $models[] = array('value' => $row->id, 'text' => JText::_($row->title));
        }
        return $models;
    }

    function getVehiclesModels($title = '') {
        if(!$title) $title = JText::_('Any');
        $db = JFactory::getDBO();
        $query = "SELECT  id, title FROM `#__js_auto_models` WHERE ";
        $query .= " status = 1 ORDER BY title ASC ";

        $db->setQuery($query);
        $rows = $db->loadObjectList();
        $models = array();
        if ($title)
            $models[] = array('value' => JText::_(''), 'text' => $title);
        foreach ($rows as $row) {
            $models[] = array('value' => $row->id, 'text' => JText::_($row->title));
        }
        return $models;
    }

    function storevehiclemodel($data) {                //store Vehicle Model
        $row = $this->getTable('vehiclemodel');
        $result = array();
        $data['status'] = 1; //by default active
        //for alias apply rule
        if (!empty($data['alias']))
            $modelalias = $data['alias'];
        else
            $modelalias = $data['title'];

        $modelalias = strtolower(str_replace(' ', '-', $modelalias));
        $data['alias'] = $modelalias;

        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        if ($data['id'] == '') { // only for new
            $result1 = $this->getJSModel('make')->isVehicleMakeExist($data['title']);
            if ($result1 == 1) {
                return 3;
            }
        }
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        return true;
    }

    function listModels($val, $req = 0) {
        $db = $this->getDBO();
        if ($val)
            if (is_numeric($val) == false)
                return false;
        $query = "SELECT id, title FROM `#__js_auto_models`  WHERE status = 1 AND makeid = " . $val . " ORDER BY title ASC";
        $db->setQuery($query);
        $result = $db->loadObjectList();
        if ($req == 1)
            $required = ' required';
        else
            $required = '';
        if (empty($result)) {
            $return_value = "<input class='inputbox" . $required . "' type='text' name='modelid' size='40' maxlength='100'  />";
        } else {
            $return_value = "<select name='modelid'  class='inputbox" . $required . "' >\n";
            $return_value .= "<option value=''>" . JText::_('Select Model') . "</option>\n";
            foreach ($result as $row) {
                $return_value .= "<option value=\"$row->id\" >".JText::_($row->title)."</option> \n";
            }
            $return_value .= "</select>\n";
        }
        return $return_value;
    }

    function getVehiclesModelsbyMakeId($makeid, $title) {
        if (!is_numeric($makeid))
            return array();// to avoid issues with generic select
        $db = JFactory::getDBO();
        $query = "SELECT  id, title FROM `#__js_auto_models` WHERE status = 1 AND makeid = " . $makeid . " ORDER BY title ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        $models = array();
        if ($title)
            $models[] = array('value' => JText::_(''), 'text' => JText::_($title));
        else
            $models[] = array('value' => 0, 'text' => JText::_('All'));
        foreach ($rows as $row) {
            $models[] = array('value' => $row->id, 'text' => JText::_($row->title));
        }
        return $models;
    }

    function mpGetNewVehicleByModel() {
        $db = $this->getDBO();
        $config = $this->getJSModel('configuration')->getConfig('default');
        $show_sold_vehicle = '';
        $inquery = " (SELECT COUNT(vehicle.id) from `#__js_auto_vehicles` AS vehicle
                        WHERE vehicle.status = 1 AND vehicle.addexpiryvalue  >= CURDATE() AND model.id = vehicle.modelid AND vehicle.conditionid = 1 " . $show_sold_vehicle . " ) AS totalnewusedvehiclelbymodel ";

        $query = "SELECT DISTINCT model.id AS modelid, model.title AS modeltitle,model.makeid AS makeid,";
        $query .= $inquery;
        $query .= " FROM `#__js_auto_models` AS model
                    LEFT JOIN `#__js_auto_vehicles` AS vehicle ON model.id = vehicle.modelid
                    ORDER BY modeltitle ";
        $db->setQuery($query);
        $model = $db->loadObjectList();
        return $model;
    }

    function mpGetUsedVehicleByModel() {
        $db = $this->getDBO();
        $config = $this->getJSModel('configuration')->getConfig('default');
        $show_sold_vehicle = '';
        $inquery = " (SELECT COUNT(vehicle.id) from `#__js_auto_vehicles` AS vehicle
                WHERE vehicle.status = 1 AND vehicle.addexpiryvalue  >= CURDATE() AND model.id = vehicle.modelid AND vehicle.conditionid = 2 " . $show_sold_vehicle . " ) AS totalnewusedvehiclelbymodel ";

        $query = "SELECT DISTINCT model.id AS modelid, model.title AS modeltitle,model.makeid AS makeid,";
        $query .= $inquery;
        $query .= " FROM `#__js_auto_models` AS model
                    LEFT JOIN `#__js_auto_vehicles` AS vehicle ON model.id = vehicle.modelid
                    ORDER BY modeltitle ";
        $db->setQuery($query);
        $usemodel = $db->loadObjectList();
        return $usemodel;
    }

    function mpGetNewUsedVehicleByModel() {
        $db = $this->getDBO();
        $config = $this->getJSModel('configuration')->getConfig('default');
        $show_sold_vehicle = '';
        $inquery = " (SELECT COUNT(vehicle.id) from `#__js_auto_vehicles` AS vehicle
                        WHERE vehicle.status = 1 AND vehicle.addexpiryvalue  >= CURDATE() AND model.id = vehicle.modelid " . $show_sold_vehicle . " ) AS totalnewusedvehiclelbymodel ";

        $query = "SELECT DISTINCT model.id AS modelid, model.title AS modeltitle,model.makeid AS makeid,";
        $query .= $inquery;
        $query .= " FROM `#__js_auto_models` AS model
                    LEFT JOIN `#__js_auto_vehicles` AS vehicle ON model.id = vehicle.modelid
                    ORDER BY modeltitle ";
        $db->setQuery($query);
        $usenewmodel = $db->loadObjectList();
        return $usenewmodel;
    }

}

?>