<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:		www.burujsolutions.com , info@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');
jimport('joomla.html.parameter');

class JSAutozModelPermissions extends JSAutozModel {

    function __construct() {
        parent::__construct();
        if (!defined('PERMISSION_CONSTANT')) {
            $this->prepareConstant();
        }
    }

    function prepareConstant() {
        define('PERMISSION_CONSTANT', 'PERMISSION_CONSTANT');
        define('NOT_HAVE_PACKAGE', 'NOT_HAVE_PACKAGE');
        define('VALIDATE', 'VALIDATE');
        define('VISITOR_LISTING_PACKAGE_REQUIRED', 'VISITOR_LISTING_PACKAGE_REQUIRED');
        define('VISITOR_LISTING_LOGIN_REQUIRED', 'VISITOR_LISTING_LOGIN_REQUIRED');
        define('VISITOR_CAN_ADD_VEHICLE', 'VISITOR_CAN_ADD_VEHICLE');
        define('VEHICLE_LIMIT_EXCEEDS', 'VEHICLE_LIMIT_EXCEEDS');
    }

    function checkPermissions($PERMISSION_FOR) {
        $user = JFactory::getUser();
        switch ($PERMISSION_FOR) {
            case 'ADD_VEHICLE':
                //Checking permissions for the users to add vehicle or not allowed and why
                if (!$user->guest) { // user is login
                    //check who is login
                    $userinfo = $this->getJSModel('common')->whologined($user->id);
                    switch ($userinfo) {
                        case 'user': // user is a seller or normal login user
                            $returnvalue = VALIDATE;
                            return $returnvalue;
                            break;
                    }
                } else { // user is not login
                    $newlisting_requiredlogin = $this->getJSModel('configuration')->getConfigValue('newlisting_requiredlogin');
                    if ($newlisting_requiredlogin == '1') {
                        $returnvalue = VISITOR_LISTING_LOGIN_REQUIRED;
                        return $returnvalue;
                    } else {
                        $returnvalue = VISITOR_CAN_ADD_VEHICLE;
                        return $returnvalue;
                    }
                }
                break;
        }
    }

}

?>