<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:		www.burujsolutions.com , info@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');
jimport('joomla.html.parameter');

class JSAutozModelVehiclesearch extends JSAutozModel{

    function __construct() {
        parent::__construct();
    }

    function getSearchOptions() {

        $db = $this->getDBO();
        $query = "SELECT MAX(modelyear.title) AS maxmodelyear, MIN(modelyear.title) AS minmodelyear FROM `#__js_auto_modelyears` AS modelyear";
        $db->setQuery($query);
        $modelyears = $db->loadObject();
        $radiussearch = array(
            '0' => array('value' => '', 'text' => JText::_('Select Radius Limit')),
            '1' => array('value' => 10, 'text' => JText::_('With In Ten Km')),
            '2' => array('value' => 20, 'text' => JText::_('With In Twenty Km')),
            '3' => array('value' => 25, 'text' => JText::_('With In Twenty Five Km')),);

        $fieldorderings = $this->getJSModel('fieldordering')->getFieldsOrdering(1, 0);
        $makes = $this->getJSModel('make')->getVehiclesMakes(JText::_('All'));
        $lists['vehicletypes'] = JHTML::_('select.genericList', $this->getJSModel('vehicletype')->getVehiclesType(JText::_('All')), 'vehicletypeid', 'class="inputbox jsautoz-cbo" style="width:200px;"' . '', 'value', 'text', '');
        $lists['makes'] = JHTML::_('select.genericList', $makes, 'makeid', 'class="inputbox jsautoz-cbo" style="width:200px;"' . 'onChange="getvfsmodels(this.value)"', 'value', 'text', '');
        $lists['models'] = JHTML::_('select.genericList', $this->getJSModel('model')->getVehiclesModels(JText::_('All'), $makes[1]['value']), 'modelid', 'class="inputbox jsautoz-cbo" style="width:200px;"' . '', 'value', 'text', '');
        $lists['fueltypes'] = JHTML::_('select.genericList', $this->getJSModel('fueltype')->getVehiclesFuelType(JText::_('All')), 'fueltypeid', 'class="inputbox jsautoz-cbo" style="width:200px;"' . '', 'value', 'text', '');
        $lists['transmissions'] = JHTML::_('select.genericList', $this->getJSModel('transmission')->getVehiclesTransmission(JText::_('All')), 'transmissionid', 'class="inputbox jsautoz-cbo" style="width:200px;"' . '', 'value', 'text', '');
        $lists['conditions'] = JHTML::_('select.genericList', $this->getJSModel('condition')->getVehiclesCondition(JText::_('All')), 'conditionid', 'class="inputbox jsautoz-cbo" style="width:200px;"' . '', 'value', 'text', '');
        $lists['cylinders'] = JHTML::_('select.genericList', $this->getJSModel('cylinder')->getVehiclesCylinders(JText::_('All')), 'cylinderid', 'class="inputbox jsautoz-cbo" style="width:200px;"' . '', 'value', 'text', '');
        $lists['radiussearch'] = JHTML::_('select.genericlist', $radiussearch, 'radiussearch', 'class="inputbox jsautoz-cbo" style="width:200px;"' . '', 'value', 'text', '');
        $lists['maxmodelyear'] = $modelyears->maxmodelyear;
        $lists['minmodelyear'] = $modelyears->minmodelyear;

        $result[2] = $lists;
        $result[3] = $fieldorderings;
        return $result;
    }

    function getModSearchOptions() {
        $db = $this->getDBO();
        $query = "SELECT MAX(modelyear.title) AS maxmodelyear, MIN(modelyear.title) AS minmodelyear FROM `#__js_auto_modelyears` AS modelyear";
        $db->setQuery($query);
        $modelyear = $db->loadObject();
        $radiussearch = array(
            '0' => array('value' => '', 'text' => JText::_('Select Radius Limit')),
            '1' => array('value' => 10, 'text' => JText::_('With In Ten Km')),
            '2' => array('value' => 20, 'text' => JText::_('With In Twenty Km')),
            '3' => array('value' => 25, 'text' => JText::_('With In Twenty Five Km')),);

        $fieldorderings = $this->getJSModel('fieldordering')->getFieldsOrdering(1);
        $makes = $this->getJSModel('make')->getVehiclesMakes(JText::_('All'));
        $lists['vehicletypes'] = JHTML::_('select.genericList', $this->getJSModel('vehicletype')->getVehiclesType(JText::_('All')), 'vehicletypeid', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['makes'] = JHTML::_('select.genericList', $makes, 'makeid', 'class="inputbox " ' . 'onChange="getmodulesmodels(this.value)"', 'value', 'text', '');
        $lists['models'] = JHTML::_('select.genericList', $this->getJSModel('model')->getVehiclesModelsbyMakeId($makes[1]['value'],JText::_('All')), 'modelid', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['fueltypes'] = JHTML::_('select.genericList', $this->getJSModel('fueltype')->getVehiclesFuelType(JText::_('All')), 'fueltypeid', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['transmissions'] = JHTML::_('select.genericList', $this->getJSModel('transmission')->getVehiclesTransmission(JText::_('All')), 'transmissionid', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['conditions'] = JHTML::_('select.genericList', $this->getJSModel('condition')->getVehiclesCondition(JText::_('All')), 'conditionid', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['cylinders'] = JHTML::_('select.genericList', $this->getJSModel('cylinder')->getVehiclesCylinders(JText::_('All')), 'cylinderid', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['radiussearch'] = JHTML::_('select.genericlist', $radiussearch, 'radiussearch', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['maxmodelyear'] = $modelyear->maxmodelyear;
        $lists['minmodelyear'] = $modelyear->minmodelyear;
        $result[2] = $lists;
        $result[3] = $fieldorderings;
        return $result;
    }

    function getPlugSearchOptions() {
        $db = $this->getDBO();
        $query = "SELECT MAX(modelyear.title) AS maxmodelyear, MIN(modelyear.title) AS minmodelyear FROM `#__js_auto_modelyears` AS modelyear";
        $db->setQuery($query);
        $modelyear = $db->loadObject();
        $zip = $this->getJSModel('zip')->getZipCodes('', '');
        $radiussearch = array(
            '0' => array('value' => '', 'text' => JText::_('Select Radius Limit')),
            '1' => array('value' => 10, 'text' => JText::_('With In Ten Km')),
            '2' => array('value' => 20, 'text' => JText::_('With In Twenty Km')),
            '3' => array('value' => 25, 'text' => JText::_('With In Twenty Five Km')),);

        $fieldorderings = $this->getJSModel('fieldordering')->getFieldsOrdering(1);
        $makes = $this->getJSModel('make')->getVehiclesMakes(JText::_('All'));
        $lists['vehicletypes'] = JHTML::_('select.genericList', $this->getJSModel('vehicletype')->getVehiclesType(JText::_('All')), 'vehicletypeid', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['makes'] = JHTML::_('select.genericList', $makes, 'makeid', 'class="inputbox " ' . 'onChange="getpluginsmodels(this.value)"', 'value', 'text', '');
        $lists['models'] = JHTML::_('select.genericList', $this->getJSModel('model')->getVehiclesModelsbyMakeId( $makes[1]['value'],JText::_('All')), 'modelid', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['modelyears'] = JHTML::_('select.genericList', $this->getJSModel('modelyear')->getVehiclesModelYear(JText::_('All')), 'modelyearid', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['fueltypes'] = JHTML::_('select.genericList', $this->getJSModel('fueltype')->getVehiclesFuelType(JText::_('All')), 'fueltypeid', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['transmissions'] = JHTML::_('select.genericList', $this->getJSModel('transmission')->getVehiclesTransmission(JText::_('All')), 'transmissionid', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['conditions'] = JHTML::_('select.genericList', $this->getJSModel('condition')->getVehiclesCondition(JText::_('All')), 'conditionid', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['cylinders'] = JHTML::_('select.genericList', $this->getJSModel('cylinder')->getVehiclesCylinders(JText::_('All')), 'cylinderid', 'class="inputbox" ' . '', 'value', 'text', '');
        //$lists['loczip'] = JHTML::_('select.genericList', $zip, 'loczip', '', 'value', 'text', '');
        $lists['radiussearch'] = JHTML::_('select.genericlist', $radiussearch, 'radiussearch', 'class="inputbox" ' . '', 'value', 'text', '');
        $lists['maxmodelyear'] = $modelyear->maxmodelyear;
        $lists['minmodelyear'] = $modelyear->minmodelyear;
        $result[2] = $lists;
        $result[3] = $fieldorderings;
        return $result;
    }

	function getVehicleSearchResults($searchdata, $limitstart, $limit) {
        $db = $this->getDBO();
        $result = array();
        $wherequery = "";
        if ((isset($searchdata['vehicletypeid'])) && ($searchdata['vehicletypeid'] != '')) {
            if (is_numeric($searchdata['vehicletypeid']) == false)
                return false;
            $wherequery .= " AND vehicle.vehicletypeid = " . $searchdata['vehicletypeid'];
        }
        if ((isset($searchdata['makeid'])) && ($searchdata['makeid'] != '')) {
            if (is_numeric($searchdata['makeid']) == false)
                return false;
            $wherequery .= " AND vehicle.makeid = " . $searchdata['makeid'];
        }
        if ((isset($searchdata['conditionid'])) && ($searchdata['conditionid'] != '')) {
            if (is_numeric($searchdata['conditionid']) == false)
                return false;
            $wherequery .= " AND vehicle.conditionid = " . $searchdata['conditionid'];
        }
        if ((isset($searchdata['modelid']) && ($searchdata['modelid'] != '') && ($searchdata['modelid'] != 0))) {
            if (is_numeric($searchdata['modelid']) == false)
                return false;
            $wherequery .= " AND vehicle.modelid = " . $searchdata['modelid'];
        }
        if ((isset($searchdata['modelyearfrom'])) && ($searchdata['modelyearfrom'] != '') && (isset($searchdata['modelyearto'])) && ($searchdata['modelyearto'] != '')) {
            $wherequery.=" AND modelyears.title BETWEEN " . $db->quote($searchdata['modelyearfrom']) . " AND " . $db->quote($searchdata['modelyearto']);
        }
        if ((isset($searchdata['fueltypeid'])) && ($searchdata['fueltypeid'] != '')) {
            if (is_numeric($searchdata['fueltypeid']) == false)
                return false;
            $wherequery .= " AND vehicle.fueltypeid= " . $searchdata['fueltypeid'];
        }
        if ((isset($searchdata['cylinderid'])) && ($searchdata['cylinderid'] != '')) {
            if (is_numeric($searchdata['cylinderid']) == false)
                return false;
            $wherequery .= " AND vehicle.cylinderid= " . $searchdata['cylinderid'];
        }
        if ((isset($searchdata['pricefrom'])) && ($searchdata['pricefrom'] != '')) {
            if (is_numeric($searchdata['pricefrom']) == false)
                return false;
            $wherequery .= " AND vehicle.price >= " . $searchdata['pricefrom'];
        }
        if ((isset($searchdata['priceto'])) && ($searchdata['priceto'] != '')) {
            if (is_numeric($searchdata['priceto']) == false)
                return false;
            $wherequery .= " AND vehicle.price <= " . $searchdata['priceto'];
        }
        if ((isset($searchdata['exteriorcolor'])) && ($searchdata['exteriorcolor'] != ''))
            $wherequery .= " AND vehicle.exteriorcolor LIKE '%" . str_replace("'", "", $db->quote($searchdata['exteriorcolor'])) . "%'";
        if ((isset($searchdata['title'])) && ($searchdata['title'] != ''))
            $wherequery .= " AND vehicle.title LIKE '%" . str_replace("'", "", $db->quote($searchdata['title'])) . "%'";
        if ((isset($searchdata['registrationnumber'])) && ($searchdata['registrationnumber'] != ''))
            $wherequery .= " AND vehicle.registrationnumber =" . $db->quote($searchdata['registrationnumber']);

        if ((isset($searchdata['regcountry'])) && (is_numeric($searchdata['regcountry'])))
            $wherequery .= " AND vehicle.regcountry = " . $searchdata['regcountry'];
        if ((isset($searchdata['regstate'])) && (!empty($searchdata['regstate']))) {
            if (is_numeric($searchdata['regstate'])) {
                $statearray = $this->getJSModel('state')->getStateNameById($searchdata['regstate']);
                $wherequery .= " AND ( vehicle.regstate = " . $statearray['stateid'] . " OR LOWER(vehicle.regstate) = " . $db->quote(strtolower($statearray['statename'])) . " ) ";
            } else {
                $statearray = $this->getJSModel('state')->getStateIdByName($searchdata['regstate']);
                if ((isset($statearray['stateid'])) && (!empty($statearray['stateid']))) {
                    $wherequery .= " AND ( vehicle.regstate = " . $statearray['stateid'] . " OR LOWER(vehicle.regstate) = " . $db->quote(strtolower($statearray['statename'])) . " ) ";
                } else {
                    $wherequery .= " AND LOWER(vehicle.regstate)= " . $db->quote(strtolower($statearray['statename']));
                }
            }
        }

        if ((isset($searchdata['regcity'])) && (!empty($searchdata['regcity']))) {
            if (is_numeric($searchdata['regcity'])) {
                $statearray = $this->getJSModel('city')->getCityNameById($searchdata['regcity']);
                $wherequery .= " AND ( vehicle.regcity = " . $statearray['cityid'] . " OR LOWER(vehicle.regcity) = " . $db->quote(strtolower($statearray['cityname'])) . " ) ";
            } else {
                $statearray = $this->getJSModel('city')->getCityIdByName($searchdata['regcity']);
                if ((isset($statearray['cityid'])) && (!empty($statearray['cityid']))) {
                    $wherequery .= " AND ( vehicle.regcity = " . $statearray['cityid'] . " OR LOWER(vehicle.regcity) = " . $db->quote(strtolower($statearray['cityname'])) . " ) ";
                } else {
                    $wherequery .= " AND LOWER(vehicle.regcity)= " . $db->quote(strtolower($statearray['cityname']));
                }
            }
        }
        if ((isset($searchdata['loccountry'])) && (is_numeric($searchdata['loccountry'])))
            $wherequery .= " AND vehicle.loccountry= " . $searchdata['loccountry'];
        if ((isset($searchdata['locstate'])) && (!empty($searchdata['locstate']))) {
            if (is_numeric($searchdata['locstate'])) {
                $statearray = $this->getJSModel('state')->getStateNameById($searchdata['locstate']);
                $wherequery .= " AND ( vehicle.locstate = " . $statearray['stateid'] . " OR LOWER(vehicle.locstate) = " . $db->quote(strtolower($statearray['statename'])) . " ) ";
            } else {
                $statearray = $this->getStateIdByName($searchdata['locstate']);
                if ((isset($statearray['stateid'])) && (!empty($statearray['stateid']))) {
                    $wherequery .= " AND ( vehicle.locstate = " . $statearray['stateid'] . " OR LOWER(vehicle.locstate) = " . $db->quote(strtolower($statearray['statename'])) . " ) ";
                } else {
                    $wherequery .= " AND LOWER(vehicle.locstate)= " . $db->quote(strtolower($statearray['statename']));
                }
            }
        }

        if ((isset($searchdata['loccity'])) && (!empty($searchdata['loccity']))) {
            if (is_numeric($searchdata['loccity'])) {
                $statearray = $this->getJSModel('city')->getCityNameById($searchdata['loccity']);
                $wherequery .= "AND ( vehicle.loccity = " . $statearray['cityid'] . " OR LOWER(vehicle.loccity) = " . $db->quote(strtolower($statearray['cityname'])) . " ) ";
            } else {
                $statearray = $this->getJSModel('city')->getCityIdByName($searchdata['loccity']);
                if ((isset($statearray['cityid'])) && (!empty($statearray['cityid']))) {
                    $wherequery .= "AND ( vehicle.loccity = " . $statearray['cityid'] . " OR LOWER(vehicle.loccity) = " . $db->quote(strtolower($statearray['cityname'])) . " ) ";
                } else {
                    $wherequery .= " AND LOWER(vehicle.loccity)= " . $db->quote(strtolower($statearray['cityname']));
                }
            }
        }
        if ((isset($searchdata['loczip'])) && ($searchdata['loczip'] != 0)) {
			$wherequery .= "AND vehicle.loczip = " . $searchdata['loczip'];
        }
        if ((isset($searchdata['enginecapacity'])) && ($searchdata['enginecapacity'] != ''))
            $wherequery .= " AND vehicle.enginecapacity= " . $db->quote($searchdata['enginecapacity']);
        if ((isset($searchdata['mileages'])) && ($searchdata['mileages'] != ''))
            $wherequery .= " AND vehicle.mileages BETWEEN " . $db->quote($searchdata['mileages']) . " AND " . $db->quote($searchdata['mileages']);
        if (isset($searchdata['radius_length_type'])) {
            switch ($searchdata['radius_length_type']) {
                case "m":$radiuslength = 6378137;
                    break;
                case "km":$radiuslength = 6378.137;
                    break;
                case "mile":$radiuslength = 3963.191;
                    break;
                case "nacmiles":$radiuslength = 3441.596;
                    break;
            }
        }
        $selectdistance = " ";
        if ((isset($searchdata['longitude'])) && (isset($searchdata['latitude'])) && (isset($searchdata['radius']))) {

            if (($searchdata['longitude'] !== "") && ($searchdata['latitude'] !== "") && ($searchdata['radius'] !== "")) {
                $latitude = $searchdata['latitude'];
                $longitude = $searchdata['longitude'];
                $radius = $searchdata['radius'];
                if (!is_numeric($latitude))
                    return false;
                if (!is_numeric($longitude))
                    return false;
                if (!is_numeric($radius))
                    return false;
                $radiussearch = " acos((SIN( PI()* $latitude /180 )*SIN( PI()*vehicle.latitude/180 ))+(cos(PI()* $latitude /180)*COS( PI()*vehicle.latitude/180) *COS(PI()*vehicle.longitude/180-PI()* $longitude /180)))* $radiuslength <= $radius";
                $selectdistance = " ,acos((sin(PI()*$latitude/180)*sin(PI()*vehicle.latitude/180))+(cos(PI()*$latitude/180)*cos(PI()*vehicle.latitude/180)*cose(PI()*vehicle.longitude/180 - PI()*$longitude/180)))*$radiuslength AS distance ";
            }
        }
        if (isset($radiussearch) && $radiussearch != '')
            $wherequery .= " AND " . $radiussearch;


        $query = "SELECT count(vehicle.id) 
                    FROM `#__js_auto_vehicles` AS vehicle 
                    LEFT JOIN `#__js_auto_modelyears` AS modelyears ON modelyears.id = modelyearid
                    WHERE vehicle.status = 1 AND vehicle.addexpiryvalue >= CURDATE() ";
        $query .= $wherequery;

        $db->setQuery($query);
        $total = $db->loadResult();
        if ($total <= $limitstart)
            $limitstart = 0;
        $query = "SELECT vehicle.*,vehicletypes.title as vehicletypetitle, makes.title as maketitle, models.title as modeltitle,                    
					transmission.title AS transmission,vehicle.mileages AS mileage,mileagetype.symbol as mileagetype,	                    vehicle.loccountry AS country,vehicle.locstate AS state,vehicle.loccounty AS county,vehicle.loccity AS city,
                    country.name AS countryname,state.name AS statename,city.name AS cityname,
					fueltype.title AS fueltitle,vehicle.highwayfuelconsumption as highwayconsumption,vehicle.cityfuelconsumption as cityconsumption,
                    modelyears.title as modelyeartitle, fueltypes.title as fueltypetitle,  cylinders.title as cylindertitle,
                    image.filename AS vehiclelogo,conditions.title AS conditiontitle,currency.symbol AS currency
                    FROM `#__js_auto_vehicles` AS vehicle
                    LEFT JOIN `#__js_auto_vehicleimages` AS image ON vehicle.id= image.vehicleid AND image.isdefault = 1
                    LEFT JOIN `#__js_auto_vehicletypes` AS vehicletypes ON vehicle.vehicletypeid = vehicletypes.id
                    LEFT JOIN `#__js_auto_makes` AS makes ON vehicle.makeid = makes.id
                    LEFT JOIN `#__js_auto_mileagetypes` AS mileagetype ON vehicle.mileagetypeid =mileagetype.id
                    LEFT JOIN `#__js_auto_transmissions` AS transmission ON vehicle.transmissionid =transmission.id
                    LEFT JOIN `#__js_auto_models` AS models ON vehicle.modelid = models.id
                    LEFT JOIN `#__js_auto_modelyears` AS modelyears ON vehicle.modelyearid = modelyears.id
                    LEFT JOIN `#__js_auto_fueltypes` AS fueltypes ON vehicle.fueltypeid = fueltypes.id
                    LEFT JOIN `#__js_auto_cylinders` AS cylinders ON vehicle.cylinderid = cylinders.id
                    LEFT JOIN `#__js_auto_currency` AS currency ON vehicle.currencyid = currency.id
                    LEFT JOIN `#__js_auto_conditions` AS conditions ON vehicle.conditionid = conditions.id
                    LEFT JOIN `#__js_auto_fueltypes` AS fueltype ON vehicle.fueltypeid = fueltype.id
                    LEFT JOIN `#__js_auto_cities` AS city ON vehicle.loccity = city.id
                    LEFT JOIN `#__js_auto_countries` AS country ON city.countryid = country.id
                    LEFT JOIN `#__js_auto_states` AS state ON city.stateid = state.id
                    WHERE vehicle.status = 1 AND vehicle.addexpiryvalue >= CURDATE() ";
        $query .= $wherequery;
        $query .= ' ORDER BY vehicle.created DESC';
        $db->setQuery($query, $limitstart, $limit);
        $vehicleresult = $db->loadObjectList();

        if(!empty($vehicleresult))
        foreach($vehicleresult AS $vehicle){
			$vehicle->vehicleimages = $this->getJSModel('vehicleimage')->getVehicleImagebyId($vehicle->id);
		}
        
        $result[0] = $vehicleresult;
        $result[1] = $total;

        return $result;
    }
}

?>
