<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:		www.burujsolutions.com , info@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:         JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');
jimport('joomla.html.parameter');

class JSAutozModelVehicletype extends JSAutozModel {

    function __construct() {
        parent::__construct();
    }

    function getVehicleTypeTitle($type) {
        if (!is_numeric($type))
            return false;
        $db = $this->getDBO();
        $query = "SELECT type.* FROM `#__js_auto_vehicletypes` AS type WHERE  type.id = " . $type;
        $db->setQuery($query);
        $vehicletype = $db->loadObject();
        return $vehicletype;
    }

    function getVehiclesbyVehicleType() {
        $db = $this->getDBO();
        $config = $this->getJSModel('configuration')->getConfig('default');
        $show_sold_vehicle = '';
        $inquery = " (SELECT COUNT(vehicle.vehicletypeid) from `#__js_auto_vehicles`  AS vehicle
                        WHERE vehicle.vehicletypeid = vehicletype.id AND vehicle.status = 1 AND vehicle.isdeleted <> 1 AND vehicle.addexpiryvalue  >= CURDATE() " . $show_sold_vehicle . " ) AS totalvehicletype";

        $query = "SELECT  DISTINCT vehicletype.id, vehicletype.title, vehicletype.logo,";
        $query .= $inquery;
        $query .= " FROM `#__js_auto_vehicletypes` AS vehicletype
                    LEFT JOIN `#__js_auto_vehicles` AS vehicle ON vehicletype.id = vehicle.vehicletypeid
                    WHERE vehicletype.status = 1 ORDER BY vehicletype.title ";
        $db->setQuery($query);
        $vehicletypes = $db->loadObjectList();
        return $vehicletypes;
    }

    function getFiveTopVehicleByTypeid($typeid) {
        if (!is_numeric($typeid))
            return false;
        $db = $this->getDbo();
        $config = $this->getJSModel('configuration')->getConfig('default');
        $show_sold_vehicle = '';

        $query = "SELECT COUNT(vehicle.title) 
                    FROM `#__js_auto_vehicles` AS vehicle
                    LEFT JOIN `#__js_auto_makes` AS vehiclemake ON vehiclemake.id = vehicle.makeid
                    LEFT JOIN `#__js_auto_modelyears` AS vehiclemodelyear ON vehiclemodelyear.id = vehicle.modelyearid
                    WHERE DATE(vehicle.addexpiryvalue) > CURDATE() AND vehicle.status = 1 AND vehicle.vehicletypeid = " . $typeid . $show_sold_vehicle;
        $db->setQuery($query);
        $total = $db->loadResult();
        $query = "SELECT vehicle.id AS vehicleid,vehicle.title AS vehicletitle,vehiclemake.title AS maketitle,vehiclemodelyear.title AS modelyeartitle
                    FROM `#__js_auto_vehicles` AS vehicle
                    LEFT JOIN `#__js_auto_makes` AS vehiclemake ON vehiclemake.id = vehicle.makeid
                    LEFT JOIN `#__js_auto_modelyears` AS vehiclemodelyear ON vehiclemodelyear.id = vehicle.modelyearid
                    WHERE vehicle.vehicletypeid = " . $typeid . $show_sold_vehicle . " AND DATE(vehicle.addexpiryvalue) > CURDATE() AND vehicle.status = 1 ORDER BY vehicle.hits DESC LIMIT 5";
        $db->setQuery($query);
        $result = $db->loadObjectList();
        if ($result) {
            $html = '<span class="vehiclebytype-data">';
            $itemid = JRequest::getVar('Itemid');
            $spanleft = "";
            $spanright = "";
            foreach ($result AS $res) {
                $spanleft .= '<span class="vehiclebytype-make"><a href="index.php?option=com_jsautoz&c=vehicle&view=vehicle&layout=vehicle_overview&id=' . $res->vehicleid . '&cl=16&Itemid=' . $itemid . '">' . JText::_($res->maketitle) . '</a></span>';
                $spanright .= '<span class="vehiclebytype-year">' . $res->modelyeartitle . "</span>";
            }
            $html .= '<span class="vehiclebytype-leftspan">' . $spanleft . '</span><span class="vehiclebytype-sperator"></span><span class="vehiclebytype-rightspan">' . $spanright . '</span>';
            $html .= "</span>";
            if ($total > 5)
                $html .= '<span id="vehiclebytype-moreinfo"><a href="index.php?option=com_jsautoz&c=vehicle&view=vehicle&layout=listvehicles&plink=1&type=' . $typeid . '&cl=16&Itemid=' . $itemid . '">' . JText::_('More Info') . '</a></span>';
        }else {
            $html = '<span class="vehicleybytype-novehiclefound">' . JText::_('No Vehicle Found') . '</span>';
        }
        return $html;
    }

    function getVehiclesType($title = false) {
        $db = JFactory::getDBO();
        $query = "SELECT  id, title FROM `#__js_auto_vehicletypes` WHERE status = 1 ORDER BY title ASC ";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        if ($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }
        $vehicletypes = array();
        if ($title) {
            $vehicletypes[] = array('value' => JText::_(''), 'text' => JText::_($title));
        } else {
            $vehicletypes[] = array('value' => "0", 'text' => JText::_('All'));
        }

        foreach ($rows as $row) {
            $vehicletypes[] = array('value' => $row->id, 'text' => JText::_($row->title));
        }
        return $vehicletypes;
    }

    function mpGetVehicleByTypes($nooftypes) {
        if ($nooftypes)
            if (!is_numeric($nooftypes))
                return false;
        $db = $this->getDBO();
        $config = $this->getJSModel('configuration')->getConfig('default');
        $show_sold_vehicle = '';

        $query = "SELECT vtype.id AS vtypeid,vtype.title AS vtypetitle,
                    (SELECT COUNT(vehicle.id) FROM `#__js_auto_vehicles` AS vehicle WHERE vehicle.vehicletypeid = vtype.id AND date(vehicle.addexpiryvalue) >= CURDATE() AND vehicle.status <> 0 ".$show_sold_vehicle.") AS totalvehiclesbytype
                    FROM `#__js_auto_vehicletypes` AS vtype
                    ORDER BY vtype.id DESC LIMIT " . $nooftypes;
        $db->setQuery($query);
        $result = $db->loadObjectList();
        return $result;
    }

    function mpGetVehiclesByTypes($nooftypes, $typehavevehicle) {
        if ($nooftypes)
            if (!is_numeric($nooftypes))
                return false;
        $db = $this->getDBO();
        $config = $this->getJSModel('configuration')->getConfig('default');
        $show_sold_vehicle = '';

        $query = "SELECT vtype.id AS vtypeid,vtype.title AS vtypetitle,vtype.logo,
                    (SELECT COUNT(vehicle.id) FROM `#__js_auto_vehicles` AS vehicle WHERE vehicle.vehicletypeid = vtype.id AND date(vehicle.addexpiryvalue) >= CURDATE() AND vehicle.status <> 0 ".$show_sold_vehicle." ) AS totalvehiclesbytype
                    FROM `#__js_auto_vehicletypes` AS vtype";
        if ($typehavevehicle == 1)
            $query .= " HAVING totalvehiclesbytype > 0";
        $query .= " ORDER BY totalvehiclesbytype DESC, vtypetitle ASC LIMIT " . $nooftypes;
        $db->setQuery($query);
        $result = $db->loadObjectList();
        return $result;
    }

    function mpGetVehiclesByTypesAndMake($nooftypes, $typehavevehicle) {
        if ($nooftypes)
            if (!is_numeric($nooftypes))
                return false;
        $db = $this->getDBO();
        $config = $this->getJSModel('configuration')->getConfig('default');
        $show_sold_vehicle = '';

        $query = "SELECT vtype.id AS vtypeid,vtype.title AS vtypetitle,vtype.logo AS vtypelogo,make.id AS makeid,make.logo AS makelogo,make.title AS maketitle,vehicles.id AS vehicleid, model.title AS modeltitle, modelyear.title AS modelyeartitle,vehicles.price AS vehicleprice,fueltype.title AS fueltypetitle,
                    vehicles.isdiscount, vehicles.discountstart,vehicles.discountend,vehicles.discounttype,vehicles.discount,currency.symbol AS currency
                    FROM `#__js_auto_vehicles` AS vehicles
                    LEFT JOIN `#__js_auto_vehicletypes` AS vtype ON vtype.id = vehicles.vehicletypeid 
                    LEFT JOIN `#__js_auto_makes` AS make ON make.id = vehicles.makeid
                    LEFT JOIN `#__js_auto_models` AS model ON model.id = vehicles.modelid
                    LEFT JOIN `#__js_auto_modelyears` AS modelyear ON modelyear.id = vehicles.modelyearid
                    LEFT JOIN `#__js_auto_fueltypes` AS fueltype ON fueltype.id = vehicles.fueltypeid
                    LEFT JOIN `#__js_auto_currency` AS currency ON currency.id = vehicles.currencyid
                    LEFT JOIN `#__js_auto_vehicleimages` AS image ON vehicles.id= image.vehicleid AND image.isdefault = 1
                    WHERE DATE(vehicles.addexpiryvalue) > CURDATE() AND vehicles.status = 1 ".$show_sold_vehicle."
                    ";
        $query .= " ORDER BY vtypetitle ASC LIMIT " . $nooftypes;
        $db->setQuery($query);
        $result = $db->loadObjectList();
        return $result;
    }

}

?>