<?php

/**
 * @Copyright Copyright (C) 2012 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:        www.burujsolutions.com , info@burujsolutions.com
 * Created on:  April 05, 2012
  ^
  + Project:    JS Autoz
  ^
 */
defined('_JEXEC') or die('Restricted access');

function JSAutozBuildRoute(&$query) {
    $segments = array();
    $router = new jsautozRouter;
    //if(isset( $query['c'] )) { $segments[] = $query['c']; unset( $query['c'] );};
    if (isset($query['view'])) {
        $view = $query['view'];
        unset($query['view']);
    };
    if (isset($query['layout'])) {
        $value = $router->buildLayout($query['layout'], $view);
        $segments[] = $value;
        unset($query['layout']);
    };

    //task
    if (isset($query['task'])) {
        if (count($segments) == 0)
            $segments[] = 'tk';
        $segments[] = $query['task'];
        unset($query['task']);
    }

    // listvehicles
    if (isset($query['cl'])) {
        $value = $router->buildCL($query['cl']);
        $segments[] = $value;
        unset($query['cl']);
    };
    if (isset($query['c'])) {
        $value = "cont-" .  $query['c'];
        $segments[] = $value;
        unset($query['c']);
    };
    if (isset($query['vtype'])) {
        $value = "cond-" . $router->buildCondition($query['vtype']) . "-" . $query['vtype'];
        $segments[] = $value;
        unset($query['vtype']);
    };
    if (isset($query['mk'])) {
        $make = "make-" . $router->getVehicleMake($query['mk']) . "-" . $query['mk'];
        $segments[] = $make;
        unset($query['mk']);
    };
    if (isset($query['md'])) {
        $make = "model-" . $router->getVehicleModel($query['md']) . "-" . $query['md'];
        $segments[] = $make;
        unset($query['md']);
    };

    // by city
    if (isset($query['country'])) {
        $segments[] = "cn-" . $query['country'];
        unset($query['country']);
    };
    if (isset($query['state'])) {
        $segments[] = "st-" . $query['state'];
        unset($query['state']);
    };
    if (isset($query['county'])) {
        $segments[] = "ct-" . $query['county'];
        unset($query['county']);
    };
    if (isset($query['city'])) {
        $segments[] = "cy-" . $query['city'];
        unset($query['city']);
    };
    // by price
    if (isset($query['prs'])) {
        $segments[] = "ps-" . $query['prs'];
        unset($query['prs']);
    };
    if (isset($query['pre'])) {
        $segments[] = "pe-" . $query['pre'];
        unset($query['pre']);
    };
    // by model year 
    if (isset($query['mod'])) {
        $segments[] = "modelyear-" . $router->getModelyear($query['mod']);
        unset($query['mod']);
    };

    // vehicle_overview, vehicle_specification, vehicle_gallery, vehicle_reviews, formbuyercontact
    if (isset($query['id'])) {
        $segments[] = "vehicle-" . $router->getVehicleTitle($query['id']) . "-" . $query['id'];
        unset($query['id']);
    };
    //dealer id
    if (isset($query['did'])) {
        $segments[] = "dealer-" . $router->getDealerAlias($query['did']) . "-" . $query['did'];
        unset($query['did']);
    };

    //buyer id
    if (isset($query['bid'])) {
        $segments[] = "buyer-" . $query['bid'];
        unset($query['bid']);
    };

    //vehicle_review didnot found in working code in query vehicleid
    if (isset($query['vehicleid'])) {
        $segments[] = "14-" . $query['vehicleid'];
        unset($query['vehicleid']);
    };


    //vehiclealertunsubscribe
    if (isset($query['email'])) {
        $segments[] = "email-" . $query['email'];
        unset($query['email']);
    };


    //formvehicle
    if (isset($query['adtype'])) {
        $segments[] = "g-" . $query['adtype'];
        unset($query['adtype']);
    };
    if (isset($query['nadtype'])) {
        $segments[] = "h-" . $query['nadtype'];
        unset($query['nadtype']);
    };


    // dealer id from vehicle detail page to view dealer
    if (isset($query['uid'])) {
        $segments[] = "vuser-" . $query['uid'];
        unset($query['uid']);
    };

    //package_details
    if (isset($query['gd'])) {
        $segments[] = "p-" . $query['gd'];
        unset($query['gd']);
    };

    //package_buynow
    if (isset($query['pb'])) {
        $segments[] = "nw-" . $query['pb'];
        unset($query['pb']);
    };

    //makedefaultvehicleimage
    if (isset($query['vimgid'])) {
        $segments[] = "vehicleimage-" . $router->getVehicleImage($query['vimgid']) . "-" . $query['vimgid'];
        unset($query['vimgid']);
    };

    if (isset($query['vm'])) {
        $segments[] = "message-" . $router->getVehicleMessage($query['vm']);
        unset($query['vm']);
    };
    if (isset($query['type'])) {
        $segments[] = "tp-" . $query['type'];
        unset($query['type']);
    };
    if (isset($query['format'])) {
        $segments[] = "format-" . $query['format'];
        unset($query['format']);
    };

    if (isset($query['action'])) {
        $segments[] = "reportaction-" . $query['action'];
        unset($query['action']);
    };
    if (isset($query['managerid'])) {
        $segments[] = "manager-" . $router->getManagerName($query['managerid']) . "-" . $query['managerid'];
        unset($query['managerid']);
    };
    if (isset($query['conditionid'])) {
        $segments[] = "condition-" . $router->getCondition($query['conditionid']) . "-" . $query['conditionid'];
        unset($query['conditionid']);
    };
    if (isset($query['plink'])) {
        $segments[] = "plink" . "-" . $query['plink'];
        unset($query['plink']);
    };
    if (isset($query['Itemid'])) {
        //$segments[] = "Itemid" . "-" . $query['Itemid'];
        //unset($query['Itemid']);
        $_SESSION['JSAzItemid'] = $query['Itemid'];
    }

    return $segments;
}

function JSAutozParseRoute($segments) {

    $vars = array();
    $count = count($segments);
    //echo '<br> count '.$count;print_r($segments);exit;

    /*
      $menu = JMenu::getInstance('site');
      $item = &$menu->getActive();
      $menu = JSite::getMenu();
      $item = $menu->getActive();
     */
    $router = new jsautozRouter;

    if (isset($segments[0])) {
        $layout = $segments[0];
        //unset($segments[1]);
    }
    else
        $layout = "";
    if ($layout == 'tk') {
        $vars['task'] = $segments[1];
    } else {
        $lresult = $router->parseLayout($layout);
        $vars['view'] = $lresult["view"];
        $vars['layout'] = $lresult["layout"];
    }
    $i = 0;
    foreach ($segments AS $seg) {
        if ($i >= 1) {
            $array = explode(":", $seg);
            $index = $array[0];
            //unset the current index
            unset($array[0]);
            if (isset($array[1]))
                $value = implode("-", $array);

            switch ($index) {
                case "from":$vars['cl'] = $router->parseCL($value);
                    break;
                case "cond":$vars['vtype'] = $router->parseId($value);
                    break;
                case "make":$vars['mk'] = $router->parseId($value);
                    break;
                case "model":$vars['md'] = $router->parseId($value);
                    break;
                case "cn":$vars['country'] = $value;
                    break;
                case "st":$vars['state'] = $value;
                    break;
                case "ct":$vars['county'] = $value;
                    break;
                case "cy":$vars['city'] = $value;
                    break;
                case "ps":$vars['prs'] = $value;
                    break;
                case "pe":$vars['pre'] = $value;
                    break;
                case "modelyear":$vars['mod'] = $router->parseModelyear($value);
                    break;
                case "vehicle":$vars['id'] = $router->parseId($value);
                    break;
                case "dealer":$vars['did'] = $router->parseId($value);
                    break;
                case "buyer":$vars['bid'] = $router->parseId($value);
                    break;
                case 14:$vars['vehicleid'] = $value;
                    break;
                case "email":$vars['email'] = $value;
                    break;
                case "g":$vars['adtype'] = $value;
                    break;
                case "h":$vars['nadtype'] = $value;
                    break;
                case "vuser":$vars['uid'] = $value;
                    break;
                case "p":$vars['gd'] = $value;
                    break;
                case "nw":$vars['pb'] = $value;
                    break;
                case "vehicleimage":$vars['vimgid'] = $router->parseId($value);
                    break;
                case "message":$vars['vm'] = $router->parseVehicleMessage($value);
                    break;
                case "tp":$vars['type'] = $value;
                    break;
                case "format":$vars['format'] = $value;
                    break;
                case "reportaction":$vars['action'] = $router->parseId($value);
                    break;
                case "manager":$vars['managerid'] = $router->parseId($value);
                    break;
                case "condition":$vars['conditionid'] = $router->parseId($value);
                    break;
                case "plink":$vars['plink'] = $router->parseId($value);
                    break;
                case "cont":$vars['c'] = $value;
                    break;
              //  case "Itemid":$vars['Itemid'] = $value;
              //      break;
                /*                  //condition
                  case "new": $vars['vtype'] = 1;break;
                  case "used":$vars['vtype'] = 2;break;
                  case "all":$vars['vtype'] = -1;break;
                 * 
                 */
                //from -cl
                case "makes":$vars['cl'] = 1;
                    break;
                case "city":$vars['cl'] = 2;
                    break;
                case "price":$vars['cl'] = 3;
                    break;
                case "listmodelyear":$vars['cl'] = 4;
                    break;
                case "gold":$vars['cl'] = 5;
                    break;
                case "featured":$vars['cl'] = 6;
                    break;
                case "search":$vars['cl'] = 7;
                    break;
                case "seller":$vars['cl'] = 9;
                    break;
                case "dvehicles":$vars['cl'] = 10;
                    break;
                case "vehicles":$vars['cl'] = 11;
                    break;
                case "models":$vars['cl'] = 12;
                    break;
                case "dealervehicle":$vars['cl'] = 13;
                    break;
                case "type":$vars['cl'] = 16;
                    break;
                case "nuvehicles":$vars['cl'] = 20;
                    break;
                case "list":$vars['cl'] = 8;
                    break;
                case "shortlist":$vars['cl'] = 14;
                    break;
                case "compare":$vars['cl'] = 15;
                    break;
                case "quicklinks":$vars['cl'] = 26;
                    break;
                case "conditions":$vars['cl'] = 27;
                    break;
            }
        }
        $i++;
    }

    if (isset($_SESSION['JSAzItemid'])) {
        $vars['Itemid'] = $_SESSION['JSAzItemid'];
    }
    return $vars;
}

class jsautozRouter {

    function buildLayout($value, $view) {
        $returnvalue = "";
        switch ($value) {
            case "messages":$returnvalue = "messages";break;
            case "compare_vehicles":$returnvalue = "compare";break;
            case "controlpannel": if ($view == 'buyer') $returnvalue = "controlpanel"; else $returnvalue = "controlpannel"; break;
            case "dealerlist":$returnvalue = "dealers"; break;
            case "featuredvehicles":$returnvalue = "featuredvehicles"; break;
            case "formbuyercontact":$returnvalue = "contact"; break;
            case "goldvehicles":$returnvalue = "goldvehicles"; break;
            case "listvehicles":$returnvalue = "vehicles"; break;
            case "newvehiclealerts":$returnvalue = "emailalert"; break;
            case "popup":$returnvalue = "popup"; break;
            case "send_message": if ($view == 'buyer') $returnvalue = "sendmessage"; else $returnvalue = "sendmessages"; break;
            case "tell_a_friend":$returnvalue = "tellafriend"; break;
            case "vehiclealertunsubscribe":$returnvalue = "unsubscribe"; break;
            case "vehiclebycity":$returnvalue = "city"; break;
            case "vehiclebymodelyear":$returnvalue = "modelyear"; break;
            case "vehiclebyprice":$returnvalue = "price"; break;
            case "vehiclebytypes":$returnvalue = "types"; break;
            case "vehicle_details":$returnvalue = "details"; break;
            case "vehicle_filter":$returnvalue = "filter"; break;
            case "vehicle_gallery":$returnvalue = "gallery"; break;
            case "vehicle_images": if ($view == 'buyer') $returnvalue = "vimages"; else $returnvalue = "vehicleimages"; break;
            case "vehicle_messages":$returnvalue = "vehicle_messages"; break;
            case "vehicle_models":$returnvalue = "models"; break;
            case "vehicle_overview":$returnvalue = "overview"; break;
            case "vehicle_quicklink":$returnvalue = "quicklink"; break;
            case "vehicle_reviews":$returnvalue = "reviews"; break;
            case "vehicles": if ($view == "rss") $returnvalue = "rssvehicles"; else $returnvalue = "bymodels"; break;
            case "vehiclesearch":$returnvalue = "search"; break;
            case "vehiclesearch_results":$returnvalue = "searchresults"; break;
            case "vehicle_specification":$returnvalue = "specification"; break;
            case "vehicles_shortlist":$returnvalue = "shortlist"; break;
            case "viewdealer":$returnvalue = "viewdealer"; break;
            case "view_dealer":$returnvalue = "dealerinfo"; break;
            case "view_vehicle": if ($view == 'buyer') $returnvalue = "detail"; else $returnvalue = "viewvehicle"; break;
            //seller
            case "authenticate":
				if($view == 'vehicle')
					$returnvalue = "authenticatev"; 
				else 
					$returnvalue = 'authenticate';
			break;
            case "formdealer":$returnvalue = "formdealer"; break;
            case "formvehicle":$returnvalue = "formvehicle"; break;
            case "images":$returnvalue = "images"; break;
            case "my_stats":$returnvalue = "stats"; break;
            case "package_buynow":$returnvalue = "buynow"; break;
            case "package_details":$returnvalue = "packagedetails"; break;
            case "packages":$returnvalue = "packages"; break;
            case "purchasehistory":$returnvalue = "purchasehistory"; break;
            case "vehiclelist":$returnvalue = "myvehicles"; break;
            case "vehicle_review":$returnvalue = "vehiclereview"; break;
            case "vehicle_type":$returnvalue = "vehicletype"; break;
            case "managersreport":$returnvalue = "managersreport"; break;
            case "formdealermanager":$returnvalue = "formmanager"; break;
            case "managerslist":$returnvalue = "managerslist"; break;
            case "norecordfound":$returnvalue = "norecordfound"; break;
            case "vehiclebycondition":$returnvalue = "vehiclebycondition"; break;
            case "formvehiclemake":$returnvalue = "vehiclemakeform"; break;
            case "formvehiclemodel":$returnvalue = "vehiclemodelform"; break;
            
            case "formrequestvehicle":$returnvalue = "requestvehicle"; break;
            case "myrequestedvehicles":$returnvalue = "myrequestvehicle"; break;
            case "requestedvehicle_detail":$returnvalue = "requestvehicle_detail"; break;
            case "requestedvehicles":$returnvalue = "requestedvehicles"; break;
            case "dealersearch":$returnvalue = "dealersearch"; break;
            case "dealersearchresults":$returnvalue = "dealersearchresults"; break;
            
        }
        return $returnvalue;
    }

    function parseLayout($value) {
        //  $returnvalue = "";

        switch ($value) {
            case "dealersearchresults": $returnvalue["layout"] = "dealersearchresults"; $returnvalue["view"] = "dealer"; break;
            case "dealersearch": $returnvalue["layout"] = "dealersearch"; $returnvalue["view"] = "dealer"; break;
            case "requestedvehicles": $returnvalue["layout"] = "requestedvehicles"; $returnvalue["view"] = "requestvehicle"; break;
            case "requestvehicle_detail": $returnvalue["layout"] = "requestedvehicle_detail"; $returnvalue["view"] = "requestvehicle"; break;
            case "requestvehicle": $returnvalue["layout"] = "formrequestvehicle"; $returnvalue["view"] = "requestvehicle"; break;
            case "myrequestvehicle": $returnvalue["layout"] = "myrequestedvehicles"; $returnvalue["view"] = "requestvehicle"; break;
            case "messages": $returnvalue["layout"] = "messages"; $returnvalue["view"] = "message"; break;
            case "compare": $returnvalue["layout"] = "compare_vehicles"; $returnvalue["view"] = "vehicle"; break;
            case "controlpanel": $returnvalue["layout"] = "controlpannel"; $returnvalue["view"] = "buyer"; break;
            case "dealers": $returnvalue["layout"] = "dealerlist"; $returnvalue["view"] = "dealer"; break;
            case "featuredvehicles": $returnvalue["layout"] = "featuredvehicles"; $returnvalue["view"] = "featuredvehicle"; break;
            case "contact": $returnvalue["layout"] = "formbuyercontact"; $returnvalue["view"] = "vehiclecontact"; break;
            case "goldvehicles": $returnvalue["layout"] = "goldvehicles"; $returnvalue["view"] = "goldvehicle"; break;
            case "vehicles": $returnvalue["layout"] = "listvehicles"; $returnvalue["view"] = "vehicle"; break;
            case "emailalert": $returnvalue["layout"] = "newvehiclealerts"; $returnvalue["view"] = "vehiclealert"; break;
            case "popup": $returnvalue["layout"] = "popup"; $returnvalue["view"] = "vehicle"; break;
            case "sendmessage": $returnvalue["layout"] = "send_message"; $returnvalue["view"] = "message"; break;
            case "tellafriend": $returnvalue["layout"] = "tell_a_friend"; $returnvalue["view"] = "vehicle"; break;
            case "unsubscribe": $returnvalue["layout"] = "vehiclealertunsubscribe"; $returnvalue["view"] = "vehiclealert"; break;
            case "city": $returnvalue["layout"] = "vehiclebycity"; $returnvalue["view"] = "city"; break;
            case "modelyear": $returnvalue["layout"] = "vehiclebymodelyear"; $returnvalue["view"] = "modelyear"; break;
            case "price": $returnvalue["layout"] = "vehiclebyprice"; $returnvalue["view"] = "price"; break;
            case "types": $returnvalue["layout"] = "vehiclebytypes"; $returnvalue["view"] = "vehicletype"; break;
            case "details": $returnvalue["layout"] = "vehicle_details"; $returnvalue["view"] = "vehicle"; break;
            case "filter": $returnvalue["layout"] = "vehicle_filter"; $returnvalue["view"] = "vehicle"; break;
            case "gallery": $returnvalue["layout"] = "vehicle_gallery"; $returnvalue["view"] = "vehicle"; break;
            case "vimages": $returnvalue["layout"] = "vehicle_images"; $returnvalue["view"] = "vehicleimage"; break;
            case "vehicle_messages": $returnvalue["layout"] = "vehicle_messages"; $returnvalue["view"] = "message"; break;
            case "models": $returnvalue["layout"] = "vehicle_models"; $returnvalue["view"] = "model"; break;
            case "overview": $returnvalue["layout"] = "vehicle_overview"; $returnvalue["view"] = "vehicle"; break;
            case "quicklink": $returnvalue["layout"] = "vehicle_quicklink"; $returnvalue["view"] = "vehicle"; break;
            case "reviews": $returnvalue["layout"] = "vehicle_reviews"; $returnvalue["view"] = "vehicle"; break;
            case "bymodels": $returnvalue["layout"] = "vehicles"; $returnvalue["view"] = "vehicle"; break;
            case "search": $returnvalue["layout"] = "vehiclesearch"; $returnvalue["view"] = "vehiclesearch"; break;
            case "searchresults": $returnvalue["layout"] = "vehiclesearch_results"; $returnvalue["view"] = "vehiclesearch"; break;
            case "specification": $returnvalue["layout"] = "vehicle_specification"; $returnvalue["view"] = "vehicle"; break;
            case "shortlist": $returnvalue["layout"] = "vehicles_shortlist"; $returnvalue["view"] = "vehicleshortlist"; break;
            case "viewdealer": $returnvalue["layout"] = "viewdealer"; $returnvalue["view"] = "dealer"; break;
            case "dealerinfo": $returnvalue["layout"] = "view_dealer"; $returnvalue["view"] = "dealer"; break;
            case "detail": $returnvalue["layout"] = "view_vehicle"; $returnvalue["view"] = "vehicle"; break;
            case "vehiclebycondition": $returnvalue["layout"] = "vehiclebycondition"; $returnvalue["view"] = "condition"; break;
            //seller
            case "authenticatev": $returnvalue["layout"] = "authenticate"; $returnvalue["view"] = "vehicle"; break;
            case "authenticate": $returnvalue["layout"] = "authenticate"; $returnvalue["view"] = "requestvehicle"; break;
            case "controlpannel": $returnvalue["layout"] = "controlpannel"; $returnvalue["view"] = "seller"; break;
            case "formdealer": $returnvalue["layout"] = "formdealer"; $returnvalue["view"] = "dealer"; break;
            case "formvehicle": $returnvalue["layout"] = "formvehicle"; $returnvalue["view"] = "vehicle"; break;
            case "images": $returnvalue["layout"] = "images"; $returnvalue["view"] = "vehicleimage"; break;
            case "stats": $returnvalue["layout"] = "my_stats"; $returnvalue["view"] = "seller"; break;
            case "buynow": $returnvalue["layout"] = "package_buynow"; $returnvalue["view"] = "sellerpackage"; break;
            case "packagedetails": $returnvalue["layout"] = "package_details"; $returnvalue["view"] = "sellerpackage"; break;
            case "packages": $returnvalue["layout"] = "packages"; $returnvalue["view"] = "sellerpackage"; break;
            case "purchasehistory": $returnvalue["layout"] = "purchasehistory"; $returnvalue["view"] = "purchasehistory"; break;
            case "sendmessages": $returnvalue["layout"] = "send_message"; $returnvalue["view"] = "message"; break;
            case "vehicleimages": $returnvalue["layout"] = "vehicle_images"; $returnvalue["view"] = "vehicleimage"; break;
            case "myvehicles": $returnvalue["layout"] = "vehiclelist"; $returnvalue["view"] = "vehicle"; break;
            case "vehiclereview": $returnvalue["layout"] = "vehicle_review"; $returnvalue["view"] = "vehiclereview"; break;
            case "vehicletype": $returnvalue["layout"] = "vehicle_type"; $returnvalue["view"] = "vehicletype"; break;
            case "viewvehicle": $returnvalue["layout"] = "view_vehicle"; $returnvalue["view"] = "vehicle"; break;
            case "managersreport": $returnvalue["layout"] = "managersreport"; $returnvalue["view"] = "dealermanager"; break;
            case "formmanager": $returnvalue["layout"] = "formdealermanager"; $returnvalue["view"] = "dealermanager"; break;
            case "managerslist": $returnvalue["layout"] = "managerslist"; $returnvalue["view"] = "dealermanager"; break;
            case "norecordfound": $returnvalue["layout"] = "norecordfound"; $returnvalue["view"] = "purchasehistory"; break;
            case "vehiclemakeform": $returnvalue["layout"] = "formvehiclemake"; $returnvalue["view"] = "make"; break;
            case "vehiclemodelform": $returnvalue["layout"] = "formvehiclemodel"; $returnvalue["view"] = "model"; break;
            //rss
            case "rssvehicles": $returnvalue["layout"] = "vehicles"; $returnvalue["view"] = "rss"; break;
        }
        return $returnvalue;
    }

    function buildCL($value) {
        $returnvalue = "";
        switch ($value) {
            case 1:$returnvalue = "makes"; break;
            case 2:$returnvalue = "city"; break;
            case 3:$returnvalue = "price"; break;
            case 4:$returnvalue = "listmodelyear"; break;
            case 5:$returnvalue = "gold"; break;
            case 6:$returnvalue = "featured"; break;
            case 7:$returnvalue = "search"; break;
            case 8:$returnvalue = "list"; break;
            case 9:$returnvalue = "seller"; break;
            case 10:$returnvalue = "dvehicles"; break;
            case 11:$returnvalue = "vehicles"; break;
            case 12:$returnvalue = "models"; break;
            case 13:$returnvalue = "dealervehicle"; break;
            case 14:$returnvalue = "shortlist"; break;
            case 15:$returnvalue = "compare"; break;
            case 16:$returnvalue = "type"; break;
            case 17:$returnvalue = "from-17"; break;
            case 18:$returnvalue = "from-18"; break;
            case 19:$returnvalue = "from-19"; break;
            case 20:$returnvalue = "nuvehicles"; break;
            case 21:$returnvalue = "from-21"; break;
            case 22:$returnvalue = "from-22"; break;
            case 23:$returnvalue = "from-23"; break;
            case 24:$returnvalue = "from-24"; break;
            case 25:$returnvalue = "from-25"; break;
            case 26:$returnvalue = "quicklinks"; break;
            case 27:$returnvalue = "conditions"; break;
            case 28:$returnvalue = "requestedvehicles"; break;
            case 29:$returnvalue = "myrequestedvehicles"; break;
        }
        return $returnvalue;
    }

    function parseCL($value) {
        $returnvalue = "";
        switch ($value) {
            case "makes": $returnvalue = 1; break;
            case "city":$returnvalue = 2; break;
            case "price":$returnvalue = 3; break;
            case "listmodelyear":$returnvalue = 4; break;
            case "gold":$returnvalue = 5; break;
            case "featured":$returnvalue = 6; break;
            case "search":$returnvalue = 7; break;
            case "list":$returnvalue = 8; break;
            case "seller":$returnvalue = 9; break;
            case "dvehicles":$returnvalue = 10; break;
            case "vehicles":$returnvalue = 11; break;
            case "models":$returnvalue = 12; break;
            case "dealervehicle":$returnvalue = 13; break;
            case "shortlist":$returnvalue = 14; break;
            case "compare":$returnvalue = 15; break;
            case "type":$returnvalue = 16; break;
            case "17":$returnvalue = 17; break;
            case "18":$returnvalue = 18; break;
            case "19":$returnvalue = 19; break;
            case "nuvehicles":$returnvalue = 20; break;
            case "21":$returnvalue = 21; break;
            case "22":$returnvalue = 22; break;
            case "23":$returnvalue = 23; break;
            case "24":$returnvalue = 24; break;
            case "25":$returnvalue = 25; break;
            case "quicklinks":$returnvalue = 26; break;
            case "conditions":$returnvalue = 27; break;
            case "requestedvehicles":$returnvalue = 28; break;
            case "myrequestedvehicles":$returnvalue = 29; break;
            default :$returnvalue = $value; break;
        }
        return $returnvalue;
    }

    function buildCondition($value) {
        $returnvalue = "";
        switch ($value) {
            case 1:$returnvalue = "new"; break;
            case 2:$returnvalue = "used"; break;
            default :$returnvalue = $this->getCondition($value); break;
        }
        return $returnvalue;
    }

    function parseCondition($value) {
        $returnvalue = "";
        switch ($value) {
            case "new": $returnvalue = 1; break;
            case "used":$returnvalue = 2; break;
            case "all":$returnvalue = -1; break;
        } return $returnvalue;
    }

    function getVehicleMake($makeid) {
        $db = JFactory::getDBO();
        $query = "SELECT alias FROM `#__js_auto_makes` WHERE id = " . (int) $makeid;
        $db->setQuery($query);
        $result = $db->loadResult();
        $result = str_replace('/', '', $result);
        return $result;
    }

    function getVehicleModel($modelid) {
        $db = JFactory::getDBO();
        $query = "SELECT alias FROM `#__js_auto_models` WHERE id = " . (int) $modelid;
        $db->setQuery($query);
        $result = $db->loadResult();
        $result = str_replace('/', '', $result);
        return $result;
    }

    function getVehicleTitle($vehicleid) {
        $db = JFactory::getDBO();
        $query = "SELECT alias FROM `#__js_auto_vehicles` WHERE id = " . (int) $vehicleid;
        $db->setQuery($query);
        $result = $db->loadResult();
        $result = str_replace('/', '-', $result);
        return $result;
    }

    function getModelyear($modelyearid) {
        $db = JFactory::getDBO();
        $query = "SELECT title FROM `#__js_auto_modelyears` WHERE id = " . (int) $modelyearid;
        $db->setQuery($query);
        $result = $db->loadResult();
        return $result;
    }

    function getVehicleImage($vehicleimageid) {
        $db = JFactory::getDBO();
        $query = "SELECT filename FROM `#__js_auto_vehicleimages` WHERE id = " . (int) $vehicleimageid;
        $db->setQuery($query);
        $result = $db->loadResult();
        //applay url rule
        $result = strtolower(str_replace(' ', '-', $result));
        return $result;
    }

    function parseModelyear($modelyear) {
        $db = JFactory::getDBO();
        $query = "SELECT id FROM `#__js_auto_modelyears` WHERE title = " . (int) $modelyear;
        $db->setQuery($query);
        $result = $db->loadResult();
        return $result;
    }

    function parseId($value) {
        $id = explode("-", $value);
        $count = count($id);
        $id = (int) $id[($count - 1)];
        return $id;
    }

    function getVehicleMessage($messagenumber) {
        switch ($messagenumber) {
            case 1: $message = "overview"; break;
            case 2: $message = "buyer"; break;
            case 3: $message = "seller"; break;
            default: $message = $messagenumber; break;
        }
        return $message;
    }

    function getManagerName($manageruid) {
        $db = JFactory::getDBO();
        $query = "SELECT businessname FROM `#__js_auto_dealermanagers` WHERE manageruid = " . (int) $manageruid;
        $db->setQuery($query);
        $result = $db->loadResult();
        $result = strtolower(str_replace(' ', '-', $result));
        return $result;
    }

    function getCondition($condition) {
        $db = JFactory::getDBO();
        $query = "SELECT title FROM `#__js_auto_conditions` WHERE id = " . (int) $condition;
        $db->setQuery($query);
        $result = $db->loadResult();
        $result = strtolower(str_replace(' ', '-', $result));
        return $result;
    }

    function parseVehicleMessage($message) {
        switch ($message) {
            case "overview": $message = 1; break;
            case "buyer": $message = 2; break;
            case "seller": $message = 3; break;
            default: $message = $message; break;
        } 
        return $message;
    }

}
